; OKDP - Based on the file from the Truval guys this will decompress
;        the CCITT stuff. I will test it on ISF which is written
;
;               Data DeCompression, CCITT G3-4 FAX
;
;
DSEG   segment  para public 'DATA'
extrn  buffer:word,height_pix:word,width_bytes:word

first  db       0            ;indicator to allow one read off the end

linecount dw    0            ;current line overall being expanded

bstor  db       0            ;partially filled output string byte storage
bcount db       8            ;count of remaining bit to fill before purge
outptr dw       0            ;output buffer pointer, current byte count in line
lastreq   db    0            ;last requested bit stream length
saved     dw    0            ;d-register store
blsave    db    0            ;bl save

input     dw    0            ;word saved, encoded pix data
incount   db    0            ;current bits available before byte refresh, input
in_wid    dw    0            ; bytes to lod from current line

dseg   ends



;******************************************************************
;
;      Data DeCompression Subprogram per CCITT G3-4 FAX.  Good only for
;      single bit map "line art".  Grey scale would have to be compressed
;      once each for individual bit planes.
;
;      Reads from file "handle", places data at "pageseg":0 up to
;      "height_pix", where line length and pages are parameterized above.
;      "outptr" is available above for reading file length.
;
;
;********************************************************************

CSEG   segment  para public 'CODE'
       assume   cs:cseg,ds:dseg
extrn  reset_segs:near,read_file:near,next_wait:near

dcmprs proc     near
ccitt1_line:
public ccitt1_line
;this sets up things for the very first read
       call     reset_segs
       mov      first,0
       mov      bcount,8          ;initial value, no bits to output yet
       mov      linecount,0       ;overall line count
       mov      outptr,0          ;initial place in current line
       mov      lastreq,8         ;first request will have been byte
       mov      incount,0         ;initially no bits saved on input
       mov      input,0           ;first input string = 0
       mov      blsave,8          ; save remainder for start
       clc
       ret

ccitt_line:
public ccitt_line
       call     reset_segs
;
; have a full buffer
;      bp points to last byte in buffer
;      si is where we are coming from
;      di is where we are going to
;   no problems about how to deal with the flush buffer, we check
; after each line
;
; this begins reading a line
;
; if ax is non-zero then it is the limit of the lngth of the lines
; to be read. The input data length
       mov     in_wid,07fffh
       cmp     ax,0
       je      nxtlin
       mov     in_wid,ax
nxtlin:
       mov      bl,blsave        ; save remainder
       mov      cl,8
       call     get8              ;obtain a byte from the input bit-stream
       cmp      bl,035h           ;is it zero-length white?
       jz       nblakv            ;yes, go decode for black bit string

white: cmp      bl,1              ;see if extended make-up codes
       jz       wmakup            ;yes, go do those
       mov      bh,0
       shl      bx,1              ;*2, for word-table access
; have to do lseg stuff
       push     ds
       push     ax
       mov      ax,lseg
       mov      ds,ax
       assume   ds:lseg
       mov      dl,whitet[bx]     ;first, get string length
       mov      bl,whitet+1[bx]   ;then remainder for bit-string accesses
       assume   ds:dseg
       pop      ax
       pop      ds
       shl      dl,1              ;look at extended table bit
       jc       whitex            ;go calculate extended table
       shr      dl,1              ;restore
       mov      dh,0              ;extend to dx
       mov      al,0ffh           ;white code to AL
       call     emit              ;go place into output line
       jmp      whtend            ;terminate code, go see if line end
redervv:jmp      rederr
nblakv: jmp nblak
whitex:shr      dl,1              ;restore original value less "extend" bit
wfinsh:mov      al,64             ;modulo for extended bits
       mul      dl                ;times extend code
       jc       arn               ;result in AX
       mov      ah,0              ;clear AH otherwise
arn:   mov      dx,ax             ;to DX for call below
       cmp      bl,9              ;see if another bit required
       jne      arn1              ;no
       mov      bl,8              ;yes, used 8 bits
       mov      cl,1              ;get one more
       mov      saved,dx          ;"get"clobbers d-reg
       call     get8              ;yes get next bit
       mov      dx,saved
       and      bl,1              ;see if next bit is on
       jnz      arn2
       or       bl,1
       jmp      arn1
arn2:  cmp      dx,1600           ;is this the special case
       jnz      arn3
       add      dx,64             ;if white extended code = 1600, add 128
arn3:  add      dx,64             ;next bit on, DX = DX + 64
arn1:  mov      al,0ffh           ;white non terminate code
       call     emit              ;go spew DX AL's
       mov      cl,8
       call     get8              ;go get another byte [bl has remainder from prior]
       jmp      white             ;continue white bit string


wmakup:mov      bl,8              ;remainder for prior get8 (used all 8)
       mov      cl,4
       call     get8              ;get next nyble
       mov      lastreq,8         ;looks like 8 bits used now
       and      bx,0fh            ;isolate just lower nyble
       shl      bx,1              ;*2, for word-table access
       push     ds
       push     ax
       mov      ax,lseg
       mov      ds,ax
       assume   ds:lseg
       mov      dl,tabl[bx]       ;first, get string length
       mov      bl,tabl+1[bx]     ;then remainder for bit-string accesses
       assume   ds:dseg
       pop      ax
       pop      ds
       jmp      wfinsh            ;complete make up, extended

whtend:
       cmp      in_wid,0
       jg       not_wendlin
       je       wen
       add      si,in_wid
       jmp      endlin
not_wendlin:
       push     ax
       mov      ax,width_bytes
       cmp      outptr,ax         ;see if this is end of current line
       pop      ax
       jl       black             ;continue black line
       jz       wen

       jmp      endlin            ;out of bit sync, line too long

wen:   mov      blsave,bl         ;save for input stream renormalize
       mov      dl,bcount         ;see if unfinished count
       cmp      dl,8
       jz       donew             ;last byte was on boundry
       mov      dh,0
       mov      al,dh             ;zeros to fill byte
       call     emit              ;flush out final bits
donew: jmp      endlin            ;common end of line code

rederv: jmp      rederr
nblak: mov      bl,8              ;remainder for prior get8 (used all 8)
black: mov      cl,4
       call     get8              ;first look at initial nyble
       and      bl,0fh
       cmp      bl,1              ;see if more bits needed
       jl       normal            ; bl=0, special case
       jnz      no
       mov      bl,4              ;bit count so far
       mov      cl,4
       call     get8              ;shift in 4 more
       mov      lastreq,8         ;(really needed 8 all along)
       jmp      no
normal:mov      bl,4              ;bit count so far
       mov      cl,8
       call     get8              ;shift in 8 more
       and      bx,00ffh
       cmp      bx,020h           ;see if extended make-up codes
       jl       bmakup            ;yes, go makup
no:    mov      bh,0
       shl      bx,1              ;*2, for word-table access
       push     ds
       push     ax
       mov      ax,lseg
       mov      ds,ax
       assume   ds:lseg
       mov      dl,blackt[bx]     ;first, get string length
       mov      bl,blackt+1[bx]   ;then remainder for bit-string accesses
       assume   ds:dseg
       pop      ax
       pop      ds
       shl      dl,1              ;look at extended table bit
       jc       blackx            ;go calculate extended table
       shr      dl,1              ;restore
       mov      dh,0              ;extend to dx
       mov      al,0              ;black code to AL
       call     emit              ;go place into output line
       jmp      blkend            ;terminate code, go see if line end

blackx:shr      dl,1              ;restore original value less "extend" bit
bfinsh:mov      al,64             ;modulo for extended bits
       mul      dl                ;times extend code
       jc       barn              ;result in AX
       mov      ah,0              ;clear AH otherwise
barn:  mov      dx,ax             ;to DX for call below
       cmp      bl,9              ;see if another bit required
       jne      barn1             ;no
       mov      bl,8              ;yes, used 8 bits
       mov      cl,1              ;get one more
       mov      saved,dx          ;"get"clobbers d-reg
       call     get8              ;yes get next bit
       mov      dx,saved
       and      bl,1              ;see if next bit is on
       jnz      barn2
       or       bl,1
       jmp      barn1
barn2: add      dx,64             ;next bit on, DX = DX + 64
barn1: mov      al,0              ;black non terminate code
       call     emit              ;go spew DX AL's
       jmp      black             ;continue black bit string

bmakup:and      bx,0fh
       shl      bx,1              ;*2, for word-table access
       push     ds
       push     ax
       mov      ax,lseg
       mov      ds,ax
       assume   ds:lseg
       mov      dl,tabl[bx]       ;first, get string length
       mov      bl,tabl+1[bx]     ;then remainder for bit-string accesses
       assume   ds:dseg
       pop      ax
       pop      ds
       jmp      bfinsh            ;complete make up, extended

redrv1:jmp      rederr            ;vector

blkend:
       cmp      in_wid,0
       jg       not_bendlin
       je       endit
       add      si,in_wid
       jmp      endlin
not_bendlin:
       push     ax
       mov      ax,width_bytes
       cmp      outptr,ax         ;see if this is end of current line
       pop      ax
       jl       whiter            ;continue white line
       jz       endit             ;exit if enough bytes

       jmp      endlin            ;out of bit sync, line too long

whiter:mov      cl,8
       call     get8              ;setup required by white
       jmp      white
endit: mov      blsave,bl         ;save for renormalize input stream
       mov      dl,bcount         ;see if unfinished count
       cmp      dl,8
       jz       endlin            ;last byte was on boundry
       mov      dh,0
       mov      al,dh             ;zeros to fill byte
       call     emit              ;flush out final bits

;endline is color blind
; this is doing ems page stuff
endlin:mov      bl,blsave
       mov      cl,0
       call     get8
       inc      linecount         ;new line, inc for old one
       mov      outptr,0          ;at line end, see if segment end
       cmp      incount,8         ;positioned with next byte already?
       jz       asis              ;yes, do not reposition input stream
       mov      bl,8              ;input stream intact
       mov      blsave,8
       mov      lastreq,8
       mov      incount,0
       mov      input,0
       jmp      ret_line          ;go do another line
asis:  mov      bl,0
       mov      blsave,0
       jmp      ret_line

ret_line:
       clc
       ret                        ;ACTUAL PROGRAM RETURN HERE
done_lines:
       stc
       ret

maperr:
; record a map error somehow
       mov    dx,1
       jmp    done_lines

rederr:
       mov    dx,2
       jmp    done_lines

wrong:
       mov    dx,3
       jmp    done_lines

dcmprs endp

;
;      CL = desired number of bits this time  [1,4,8]
;      BL = number of bits actually used from last time [1 - 8 (0 illegal)]
;
get8   proc     near
       mov      dl,cl       ;save bits required count

       mov      bh,lastreq  ;get bits last requested
       mov      lastreq,dl  ;save this request

       sub      bh,bl     ;bit residue = bits requested last - bits used last
;                         BH = 0 - 7          (unused residue from last)
       mov      ax,input  ;get residue
       mov      cl,bh
       shr      ax,cl     ;residue positioned for receiving new data

       mov      cl,8
       sub      cl,bh
       sub      cl,incount;see if we have destroyed prior bits
       jge      gtt1      ;no still available

       dec      si        ;yes must reset pointers to get prior byte
       mov      ch,8
       sub      ch,incount
       sub      bh,ch     ;new residue until get prior byte
       mov      ch,bh
       jmp      gtt2
gtt1:
       mov      ch,incount;bits available on input before byte refresh
       add      ch,bh
gtt2:
       mov      cl,dl     ;recover bits required count
       sub      cl,ch     ;less available before byte refresh
       jl       less      ;more than enough bits already avaliable
       jz       even      ;right on the boundry

       xchg     cl,ch     ;prepare to shift remaining available
       shl      ax,cl     ;now only remaining to shift
       xchg     cl,ch     ;remainder "to shift" count in cl

       call     getbyt    ;go get new byte in AL
       mov      ch,8
       sub      ch,cl     ;prepare new remainder count
       mov      incount,ch;save for next time
fnsh:  shl      ax,cl     ;finish the job
       mov      input,ax  ;save for next time
       mov      bl,ah     ;for caller
       clc
gberr: ret

even:  mov      incount,0 ;will exhaust exactly
       mov      cl,dl     ;get back required bit count
       jmp      fnsh

less:  neg      cl        ;residue for next time
       mov      incount,cl;save for next time
       mov      cl,dl     ;get back required bit count
       jmp      fnsh

get8   endp

getbyt proc     near
; get a byte from the input buffer
;   set up buffer
       push  ds
       mov   ds,buffer
       lodsb                ;no get to AL, contents of DS:[si]
       pop  ds
       dec   in_wid
       clc
       ret
reader:
       stc
       ret
getbyt endp
;
;      called with:
;             OUTPUT COUNT = DX
;             WHITE/BLACK =  AL
;      ES[di] -> Pageseg[logi_page]
;
emit   proc     near
       push    es
       mov     es,buffer
       mov      ah,bstor          ;get prior incomplete bit string
       mov      bstor,al          ;save b/w
       mov      cl,bcount         ;remaining bit count [initially = 8]
       mov      ch,0

       sub      dx,cx             ;deplete desired output count
       jl       e4                ;cant output this cycle
       jz       e2                ;will hit boundry

       shl      ax,cl             ;complete partial byte
       xchg     ah,al             ;move down
; have to store the byte to output buffer
       stosb                      ;stash partial byte
       inc      outptr

e1:    mov      cx,8
       mov      al,bstor          ;get back b/w bits
       sub      dx,cx             ;see if a byte can go
       jl       e4                ;no, store partial
       jz       e3                ;yes, exactly one byte
       stosb                      ;stash full byte
       inc      outptr
       jmp      e1                ;try another

e2:    shl      ax,cl
       xchg     ah,al
e3:    stosb                      ;store completed byte
       inc      outptr
       mov      bcount,8          ;indicate ready for full next
       pop     es
       ret

e4:    neg      dx                ;remainder count
       sub      cx,dx             ;produce shift count
       mov      al,bstor          ;get color
       shl      ax,cl             ;do remainder shift
       mov      bstor,ah          ;save remainder bits
       mov      bcount,dl         ;save remainder to shift count
       pop     es
       ret

emit   endp

cseg   ends


LSEG   segment public 'DATA'
    assume   ds:lseg
;      table of extended and terminating codes, white run-length codes
whitet db       0,8,0,8
public whitet
       db       29,8,30,8,45,8,46,8,22,7,22,7
       db       23,7,23,7
       db       47,8,48,8,13,6,13,6,13,6,13,6

       db       20,7,20,7
       db       33,8,34,8,35,8,36,8,37,8,38,8,19,7,19,7
       db       31,8,32,8,1,6,1,6,1,6,1,6

       db       12,6,12,6,12,6,12,6
       db       53,8,54,8,26,7,26,7
       db       39,8,40,8,41,8,42,8,43,8,44,8,21,7,21,7

       db       28,7,28,7
       db       61,8,62,8,63,8,0,8,133,8,134,8,10,5,10,5,10,5,10,5,10,5,10,5,10,5,10,5

       db       11,5,11,5,11,5,11,5,11,5,11,5,11,5,11,5
       db       27,7,27,7
       db       59,8,60,8,151,9,153,9,18,7,18,7

       db       24,7,24,7
       db       49,8,50,8,51,8,52,8,25,7,25,7
       db       55,8,56,8,57,8,58,8,131,6,131,6,131,6,131,6

       db       154,6,154,6,154,6,154,6
       db       135,8,136,8,139,9,138,8,137,8,141,9,143,9,145,9,147,9,149,9,132,7,132,7

       db       2,4,2,4,2,4,2,4,2,4,2,4,2,4,2,4,2,4,2,4,2,4,2,4,2,4,2,4,2,4,2,4

       db       3,4,3,4,3,4,3,4,3,4,3,4,3,4,3,4,3,4,3,4,3,4,3,4,3,4,3,4,3,4,3,4

       db       130,5,130,5,130,5,130,5,130,5,130,5,130,5,130,5
       db       8,5,8,5,8,5,8,5,8,5,8,5,8,5,8,5

       db       9,5,9,5,9,5,9,5,9,5,9,5,9,5,9,5
       db       16,6,16,6,16,6,16,6
       db       17,6,17,6,17,6,17,6

       db       4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4

       db       5,4,5,4,5,4,5,4,5,4,5,4,5,4,5,4,5,4,5,4,5,4,5,4,5,4,5,4,5,4,5,4

       db       14,6,14,6,14,6,14,6
       db       15,6,15,6,15,6,15,6
       db       129,5,129,5,129,5,129,5,129,5,129,5,129,5,129,5

       db       6,4,6,4,6,4,6,4,6,4,6,4,6,4,6,4,6,4,6,4,6,4,6,4,6,4,6,4,6,4,6,4

       db       7,4,7,4,7,4,7,4,7,4,7,4,7,4,7,4,7,4,7,4,7,4,7,4,7,4,7,4,7,4,7,4
whitetl =       $ - whitet

;      table of extended and terminating codes, black run-length codes
blackt db       0,8,0,8
public blackt
       db       6,4,5,4,1,3,1,3,4,3,4,3
       db       3,2,3,2,3,2,3,2,2,2,2,2,2,2,2,2

       db       9,6,9,6,9,6,9,6
       db       8,6,8,6,8,6,8,6
       db       7,5,7,5,7,5,7,5,7,5,7,5,7,5,7,5

       db       18,6,18,6,18,6,18,6
       db       52,8,138,9,140,9,55,8,56,8,148,9,150,9,59,8,60,8,152,9,24,7,24,7

       db       25,7,25,7
       db       154,9,133,8,134,8,135,8,136,9,53,8,54,8,142,9,144,9,146,9,129,6,129,6,129,6,129,6

       db       13,4,13,4,13,4,13,4,13,4,13,4,13,4,13,4,13,4,13,4,13,4,13,4,13,4,13,4,13,4,13,4

       db       23,7,23,7
       db       50,8,51,8,44,8,45,8,46,8,47,8,57,8,58,8,61,8,132,8,16,6,16,6,16,6,16,6

       db       17,6,17,6,17,6,17,6
       db       48,8,49,8,62,8,63,8,30,8,31,8,32,8,33,8,40,8,41,8,22,7,22,7

       db       14,4,14,4,14,4,14,4,14,4,14,4,14,4,14,4,14,4,14,4,14,4,14,4,14,4,14,4,14,4,14,4

       db       10,3,10,3,10,3,10,3,10,3,10,3,10,3,10,3,10,3,10,3,10,3,10,3,10,3,10,3,10,3,10,3

       db       10,3,10,3,10,3,10,3,10,3,10,3,10,3,10,3,10,3,10,3,10,3,10,3,10,3,10,3,10,3,10,3

       db       11,3,11,3,11,3,11,3,11,3,11,3,11,3,11,3,11,3,11,3,11,3,11,3,11,3,11,3,11,3,11,3

       db       11,3,11,3,11,3,11,3,11,3,11,3,11,3,11,3,11,3,11,3,11,3,11,3,11,3,11,3,11,3,11,3

       db       15,5,15,5,15,5,15,5,15,5,15,5,15,5,15,5
       db       130,8,131,8,26,8,27,8,28,8,29,8,19,7,19,7

       db       20,7,20,7
       db       34,8,35,8,36,8,37,8,38,8,39,8,21,7,21,7
       db       42,8,43,8,0,6,0,6,0,6,0,6

       db       12,3,12,3,12,3,12,3,12,3,12,3,12,3,12,3,12,3,12,3,12,3,12,3,12,3,12,3,12,3,12,3

       db       12,3,12,3,12,3,12,3,12,3,12,3,12,3,12,3,12,3,12,3,12,3,12,3,12,3,12,3,12,3,12,3
blacktl =       $ - blackt

;       extended run length table
tabl   db       28,7,28,7
       db       31,8,32,8,33,8,34,8,35,8,36,8,29,7,29,7
       db       30,7,30,7
       db       37,8,38,8,39,8,40,8
tabll  =        $ - tabl
lseg   ends
       end
