; OKCONFIG.ASM has the routines for setting the configuration file
; defaults. The dseg has the config file data area of 1024 bytes.
; this gives plenty of room for growth and the use of macros.
;
DSEG  segment public 'DATA'
assume  cs:cseg,ds:dseg,es:dseg
; external references
;
segmentsize=8000h
extrn  left_margin:word,curx:word,cury:word
extrn  strg:byte,mode:byte,str_len:word,maxlines:word
extrn  curr_seg:word,siloc:word,ems_frame:word,ems_allocated:word
extrn  ems_free:word,colori:word,linew:word,planes:word
extrn  planesa:byte
extrn dos_mem:word,tot_mem:word,ems_mem:word,xms_mem:word
;
extrn dither:byte

;  bad ems message
ems_no db  "Memory cannot be allocated.",10
       db  "No EMS working driver found.",10
       db  " PRESS ANY KEY TO CONTINUE",0
;  no more ems memory
ems_nm db  "EMS memory cannot be changed",10
       db  "   after it is allocated.",10
       db  "First Deallocate EMS Memory.",10
       db  " PRESS ANY KEY TO CONTINUE",0
;
;  unable to allocate ems memory
ems_na db  "Unable to allocate EMS pages",10
       db  " PRESS ANY KEY TO CONTINUE",0
;
;  EMS display
ems_ds db  "          Memory Allocation",10
       db  "STACK=8k, I-O Buffer=32k, LZW hash=20k",10
ems1   db  "  Real Memory=000k, EMS Memory=0000k",10
ems2   db  "  Page Width=0000, Page Length=0000",10
ems3   db  "       Free EMS Memory=0000k",10
ems4   db  "     XMS (HIMEM.SYS) Memory=0000k",10
       db  "     PRESS ANY KEY TO CONTINUE",0
rmem equ ems1+14 ;real memory
emem equ ems1+31 ;ems memory
pwid equ ems2+13 ; page wid
plen equ ems2+31 ; pagelen
fmem equ ems3+23 ; free ems
xmem equ ems4+28 ; used XMS memory
;
;
; the following is for default setting informational messages
;
; =186 =187 =188 =200 =201 =205
line1  equ this byte
line2  db  "   The default setting has been changed        ",10
line3  db  "     TO:                                       ",10
deftype equ line3+9
line4  db  "                                               ",10
defmess equ line4
line5  db  "         PRESS ANY KEY TO CONTINUE",0
; the default file is the file where the default is stored
default_file DB   'CONFIG.OK',0 ; name of config file
;
;    THESE are the messages and options that are displayed
;
;
sneg_mess db ' Scanning Negative/Positive set ',0
sneg_1 db 'Positive       ',0
sneg_2 db 'Negative       ',0
;
;
;
att_mess db  ' Set Typing Character Attribute',0
att_0    db  'White on Black',0
att_1    db  'Black on White',0
att_2    db  'White on Black - OR',0
att_3    db  'Black on White - OR',0
att_4    db  'White on Black - AND',0
att_5    db  'Black on White - AND',0
att_6    db  'White on Black - XOR',0
att_7    db  'Black on White - XOR',0
attline dw att_0,att_1,att_2,att_3,att_4,att_5,att_6,att_7
;
baud_mess db '         New Baud rate set',0
baud_0  db 'Not set      ',0
baud_1  db '1200 baud set',0
baud_2  db '2400 baud set',0
baud_3  db '4800 baud set',0
baud_4  db '9600 baud set',0
baudline dw baud_0,baud_1,baud_2,baud_3,baud_4
com_mess db '    Serial printer selected',0
com1  db 'COM1 selected',0
com2  db 'COM2 selected',0
com3  db 'COM3 selected',0
;
den_mess db '  Printer Density Selected',0
den_1  db 'Lowest Print Density',0
den_2  db 'Medium Print Density',0
den_3  db 'High Print Density',0
den_4  db 'Higher Print Density',0
den_5  db 'Even Higher Print Density',0
den_6  db 'Highest Print Density',0
denline dw den_1,den_2,den_3,den_4,den_5,den_6
;
xor_mess db '  Print picture in negative',0
xor_0  db 'Positive (inverse of screen)',0
xor_1  db 'Negative (normal)',0
xorline dw xor_0,xor_1
;
pass_mess db 'Number of print head passes',0
pass1  db 'One pass of print head',0
pass2  db 'Two passes of print head',0
passline dw pass1,pass2
;
lpt_mess db '  Parallel printer selected',0
lpt_1  db 'LPT1 selected',0
lpt_2  db 'LPT2 selected',0
lpt_3  db 'LPT3 selected',0
lptline dw lpt_1,lpt_2,lpt_3,com1,com2,com3
;
;
skew_mess db '  Skew Angle Selected',0
skew_1  db '1 for 1 skew ',0
skew_2  db '2 vert for 1 horiz',0
skew_3  db '1 vert for 2 horiz',0
;
deb_mess db 'WARNING, Use in debug mode only',0
deb_0    db 'Break points cleared',0
deb_1    db 'Break point 1 set',0
deb_2    db 'Break point 2 set',0
deb_3    db 'Break point 3 set',0
deb_4    db 'Break point 4 set',0
deb_5    db 'Break point 5 set',0
deb_6    db 'Break point 6 set',0
deb_7    db 'Break point 7 set',0
deb_8    db 'Break point 8 set',0
deb_9    db 'Break point 9 set',0
debline dw deb_0,deb_1,deb_2,deb_3,deb_4,deb_5,deb_6,deb_7,deb_8,deb_9
;
mac_mess db '         Macro string Activated',0
mac_line db 'Use Alt-Number to start',0
mac_enter db "MACRO>> ",0
;
prt_mess   db ' New Printer Driver Selected',0
prt_1      db '  BJ80 or IBM graphics',0
prt_2      db 'Hewlett Packard LaserJet',0
prt_3      db '  Ricoh LP4080R',0
prt_4      db '  Esc K (Epson etc.)',0
prt_5      db '  C.Itoh 8051',0
prt_6      db '  Canon LBP-8A2',0
prt_7      db '  Toshiba P3x1',0
prt_8      db '  GEMINI 10x or 15x',0
prt_9      db '  Okidata 92 or 93',0
prt_10     db '  Centronix Model 354',0
prt_11     db '  IBM Proprinter     ',0
prt_12     db '  NEC Pinwriter P6/P7',0
prt_13     db '  IBM Pproprinter 24',0
prt_14     db '  EPSON LQ1000/LQ800',0
prtline    dw prt_1,prt_2,prt_3,prt_4,prt_5,prt_6,prt_7,prt_8,prt_9
           dw prt_10,prt_11,prt_12,prt_13,prt_14
;
par_mess   db '   Initialization Parity Set',0
par_0      db 'Parity not set     ',0
par_1      db 'Parity = NONE,8,1  ',0
par_2      db 'Parity = EVEN,7,1  ',0
par_3      db 'Parity = IGNORE,7,1',0
parline    dw par_0,par_1,par_2,par_3
;
scale_mess db '      Character scale set',0
scale_h    db 'Scale set to HALF',0
scale_1    db 'Scale set to NORMAL',0
scale_2    db 'Scale set to DOUBLE',0
scale_3    db 'Scale set to QUAD',0
scaleline  dw scale_h,scale_1,scale_2,scale_3
;
width_mess db '  Line Drawing Width set',0
width_1    db 'Width set to 1 pels',0
width_2    db 'Width set to 2 pels',0
width_3    db 'Width set to 3 pels',0
width_4    db 'Width set to 4 pels',0
width_5    db 'Width set to 5 pels',0
width_6    db 'Width set to 6 pels',0
width_7    db 'Width set to 7 pels',0
width_8    db 'Width set to 8 pels',0
;
apply_mess db '   Dot Application method',0
apply_0    db 'Dot Application set to Punch',0
apply_1    db 'Dot Application set to XOR',0
apply_2    db 'Dot Application set to OR',0
apply_3    db 'Dot Application set to Negative Punch',0
apply_4    db 'Dot Application set to Negative XOR',0
apply_5    db 'Dot Application set to Negative Or',0
;
color_mess db '   Color or fill pattern',0
color_0    db 'Color set to White Dots',0
color_1    db 'Color set to Black Dots',0
color_2    db 'Color set to Gray Pattern',0
color_3    db 'Color set to Horizontal Lines',0
color_4    db 'Color set to Vertical Lines',0
color_5    db 'Color set to Diagonal Lines',0
color_6    db 'Color set to Small Checks',0
color_7    db 'Color set to Large Checks',0
color_8    db 'Color set to Brick Face',0
color_9    db 'Color set to Honeycomb',0
color_10   db 'Color set to Dollar signs',0
color_11   db 'Color set to Happy Faces',0
color_12   db 'Color set to Eyeballs',0
color_13   db 'Color set to Radiating lines',0
color_14   db 'Color set to Confetti',0
color_15   db 'Color set to Herring Bone',0
color_16   db 'Color set to Insect',0
color_17   db 'Color set to Experimental',0
;
font_mess db '    Default Font Setting',0
font_0    db 'Font set to font #0',0
font_1    db 'Font set to font #1',0
font_2    db 'Font set to font #2',0
font_3    db 'Font set to font #3',0
font_4    db 'Font set to font #4',0
fontline  dw font_0,font_1,font_2,font_3,font_4
;
vwid_mess  db 'VIRT. PAGE WIDTH SET, IMAGE CLEARED',0
vwid_128   db 'Virtual page size 1024',0
vwid_256   db 'Virtual page size 2048',0
vwid_512   db 'Virtual page size 4096',0
vwid_1024  db 'Virtual page size 8192',0
vwidline   dw vwid_128,vwid_256,vwid_512,vwid_1024
;
;
ems_mess  db '       EMS memory allocated',0
ems_A   db 'EMS allocation set to ALL  ',0
ems_1   db 'EMS allocation set to 128k ',0
ems_2   db 'EMS allocation set to 256k ',0
ems_3   db 'EMS allocation set to 512k ',0
ems_4   db 'EMS allocation set to 1024k',0
ems_5   db 'EMS allocation set to 1536k',0
ems_6   db 'EMS allocation set to 2048k',0
ems_7   db 'EMS allocation set to 3072k',0
ems_8   db 'EMS allocation set to 4096k',0
ems_0   db 'EMS allocation set to 0',0
;
plane_mess db '    EGA/VGA Color Planes',0
plane_1  db ' 1  plane (no color)',0
plane_4  db ' 4  planes ',0
plane_8  db ' 8  planes ',0
plane_16 db ' 16 planes ',0
;
;voice_mess db '      VOICE ON/OFF OPTION',0
;voice_on  db ' ***ON****',0
;voice_off db ' ***OFF***',0
;
tone_mess db '      TONE ON/OFF OPTION',0
tone_on_mess  db ' ***ON****',0
tone_off_mess db ' ***OFF***',0
toneline dw tone_on_mess,tone_off_mess
;
destroy_mess db '   LEAVE/CLEAN OPTION',0
destroy_off_mess  db ' **LEAVE**',0
destroy_on_mess db ' **CLEAN**',0
destroyline dw destroy_on_mess,destroy_off_mess
;
dith_mess db '      Color Shift Option',0
dith_0  db 'No shift ',0
dith_1  db 'Shift right 1',0
dith_2  db 'Shift right 2',0
dith_3  db 'Shift right 3',0
dith_4  db 'Shift right 4',0
dithline dw dith_0,dith_1,dith_2,dith_3,dith_4
;
;  this is the display area for showing the data
dpage equ this byte
; =186 =187 =188 =200 =201 =205
      db '           CONFIGURATION OPTIONS DISPLAY',10
      db '',10
      db '        Printer Setup Information',10
prtloc equ $+18
      db 'Printer Model:                                   ',10
lptloc equ $+18
      db 'Printer Port:                                    ',10
denloc equ $+18
      db 'Printer Density:                                 ',10
parloc equ $+8
baudloc equ $+36
      db 'Parity:                       Baud:              ',10
xorloc equ $+18
      db 'Negative/Positive:                               ',10
      db '',10
      db '         Miscellaneous Options                   ',10
modeloc equ $+12
vwidloc equ $+27
      db 'Video Mode:    Page width:                       ',10
debloc equ $+12
      db 'Breakpoint:                                      ',10
;voiceloc equ $+12
;      db '                                                 ',10
attloc equ $+17
      db 'Type Attribute:                                  ',10
scaleloc equ $+17
      db 'Character Scale:                                 ',0
;
appl_sw     db   0   ; type of dot applied, 0 = punch,1 = xor, etc
skew   db 0
public skew
public appl_sw
;
;
;
; default data area used for storing default information 512 bytes
;
default     EQU   this  BYTE
;
signature   db    'KPG'
version     dw    0218h
aspect      db    0    ;future use aspect ratio adjust
attribute   dw    0    ; attribute of printout
baud        db    0    ; current baud rate (bits)
public  baud
comport     dw    0    ; comport + 3 for output
debug       db    0    ; this byte throws us into debug mode
default_mode DB   0      ; default video mode
font         DW    0     ; currently selected font
help_file    db    'HELP.OK'
             db    57 dup(0)
lines_per_byte db  8     ; count of how many lines in each print pass
public lines_per_byte
lpt          dw    0     ; printer port, 1-3, 4-6 is com1
public lpt
orient       db    0     ; orientation
public orient
p_xor        db    1     ; xor factor for printers
public p_xor
parity       db    0     ; parity for com printer
public parity
pdensity     db    0     ; printer density 1-6
public pdensity
printer      dw    0     ; current printer number
public printer
scale        dw    1     ; character scale
public  scale
voice_switch db    1     ; voice on or off
vwid         dw    256   ; default virtual page width
destroy    db  0
public destroy
;
; the keyboard macros
macro1      db   73 dup(0)
macro2      db   73 dup(0)
macro3      db   73 dup(0)
macro4      db   73 dup(0)
macro5      db   73 dup(0)
macro6      db   73 dup(0)
macro7      db   73 dup(0)
macro8      db   73 dup(0)
macro9      db   73 dup(0)
macro0      db   73 dup(0)
; here on are addons, not in alpha order to keep compat with old
; versions
ems_count   dw   0   ; count of ems_pages
; moving the scanner options here also
;
jres    dw   0     ; jlaser resolution
jorig   dw   0     ; jlaser number of original copies
jpaper  dw   0     ; jlaser paper size
jtray   dw   0     ; jlaser tray number
tone_on db   0     ; tone off/on
sneg    db   0     ; scan negative switch
p_pass  db   0     ; number of printer passes
plane_switch db  1     ; default number of planes preferred
pad         EQU   this  BYTE
padlen      =     offset default   -  offset pad   +  1024
; this is the pad for the rest of 1024 bytes
            DB    padlen DUP("P")
;
;  PUBLICs
;
public debug,font,default_mode
public default,vwid,default_file,attribute
public macro1,macro2,macro3,macro4,macro5
public macro6,macro7,macro8,macro9,macro0
public ems_count,tone_on,sneg
public p_pass
;
;
DSEG  ends


CSEG segment public 'CODE'
assume  cs:cseg,ds:dseg,es:dseg
extrn present:near,prbox:near,getkey:near,print_string:near
extrn blip:near,create_file:near,write_file:near,close_file:near
extrn blop:near,goback:near,erase_mem:near,reset_segs:near
extrn quit:near,gstring:near,calc_last:near
extrn ddswitch:byte
extrn ems_allocate:near,ems_dealloc:near
public SET_LPT1,SET_LPT2,SET_LPT3,SET_P_NO_XOR,GET_P1,GET_P2,GET_P3,GET_P4
public SET_P_XOR,SET_DEN1,SET_DEN2,SET_DEN3,SET_DEN4,SET_DEN5,SET_DEN6
public SET_OR1,SET_OR2,SET_ASP1,SET_ASP2 
public set_attrib0,set_attrib1,set_attrib2,set_attrib3,set_attrib4,set_attrib5
public set_attrib6,set_attrib7
public do_memory,set_ems1,set_ems2,set_ems3,set_ems4,set_ems5
public set_ems6,set_ems7,set_ems8,set_ems0
;
;
do_memory:
; displays the current memory configuration
; the display item is in ems_ds
; used real memory
     call  reset_segs
     mov    ax,dos_mem
     mov    cx,32
     mul    cx
     call   bin_to_dec
     lea    di,rmem
     xchg   ax,dx
     mov    al,ah
     cld
     stosb
     mov    ax,dx
     stosw
; used ems memory
     mov    ax,ems_allocated
     mov    cx,16
     mul    cx
     call   bin_to_dec
     lea    di,emem
     xchg   ax,dx
     stosw
     mov    ax,dx
     stosw
; free ems memory
     mov    ax,ems_free
     mov    cx,16
     mul    cx
     call   bin_to_dec
     lea    di,fmem
     xchg   ax,dx
     stosw
     mov    ax,dx
     stosw
; used xms memory
     mov    ax,xms_mem   ; in 32k blocks
     mov    dx,0
     mov    cx,32
     mul    cx
     call   bin_to_dec
     lea    di,xmem
     xchg   ax,dx
     stosw
     mov    ax,dx
     stosw
; virtual page length
     mov    ax,maxlines
     call   bin_to_dec
     lea    di,plen
     xchg   ax,dx
     stosw
     mov    ax,dx
     stosw
; virtual page width
     lea    si,vwidline
     mov    bx,0
     cmp   vwid,128
     je    do_vwd2
     mov    bx,1
     cmp   vwid,256
     je    do_vwd2
     mov    bx,2
     cmp   vwid,512
     je    do_vwd2
     mov    bx,3
do_vwd2:
     shl    bx,1
     mov    ax,word ptr ds:[si+bx]
     add    ax,18
     mov    si,ax
     mov    cx,4
     lea    di,pwid
     cld
rep  movsb
; print the panel
     mov    left_margin,64
     mov    curx,64
     mov    cury,32
     lea    dx,ems_ds
     call   prbox
     call   getkey
     call   blip
     call   present
     mov    left_margin,0
     call   goback
     ret
        ret

;
ems_settings:
set_emsA:
public set_emsa
     call check_ems
     mov  ax,ems_free
     and  ax,11111100b
     mov  cx,16
     mul  cx
     mov  ems_count,ax
     call ems_allocate
     lea   di,ems_a
     call check_ems2
     ret
set_ems1:
     call check_ems
     mov  ems_count,128
     call ems_allocate
     lea   di,ems_1
     call check_ems2
     ret
set_ems2:
     call check_ems
     mov  ems_count,256
     call ems_allocate
     lea   di,ems_2
     call check_ems2
     ret
set_ems3:
     call check_ems
     mov  ems_count,512
     call ems_allocate
     lea   di,ems_3
     call check_ems2
     ret
set_ems4:
     call check_ems
     mov  ems_count,1024
     call ems_allocate
     lea   di,ems_4
     call check_ems2
     ret
set_ems5:
     call check_ems
     mov  ems_count,1536
     call ems_allocate
     lea   di,ems_5
     call check_ems2
     ret
set_ems6:
     call check_ems
     mov  ems_count,2048
     call ems_allocate
     lea   di,ems_6
     call check_ems2
     ret
set_ems7:
     call check_ems
     mov  ems_count,3072
     call ems_allocate
     lea   di,ems_7
     call check_ems2
     ret
set_ems8:
     call check_ems
     mov  ems_count,4096
     call ems_allocate
     lea   di,ems_8
     call check_ems2
     ret
set_ems0:
     cmp   ems_frame,0
     jne    bad_ems_frameb
     jmp   bad_ems_frame
bad_ems_frameb:
     mov  ems_count,0
     call ems_dealloc
     lea   di,ems_0
     jmp   ems2a
check_ems2:
     cmp   ems_allocated,0
     je    bad_ems_alloc
ems2a:
     push  di
; calculate maxlines, total number of lines in pic
            MOV   AX,segmentsize
            mov   dx,0
            mov   cx,tot_mem
            mul   cx
            div   vwid
            mov   maxlines,ax
     call  calc_last
     pop   di
     lea   si,ems_mess
     call  pmess
     call  goback

bad_ems_alloc:
     mov    left_margin,64
     mov    curx,64
     mov    cury,32
     lea    dx,ems_na
     call   prbox
     call  getkey
     call  present
     call  goback
check_ems:
     cmp   ems_frame,0
     je    bad_ems_frame
     cmp   ems_allocated,0
     jne   no_more_ems
     ret
no_more_ems:
     mov    left_margin,64
     mov    curx,64
     mov    cury,32
     lea    dx,ems_nm
     call   prbox
     call  getkey
     call  present
     call  goback
bad_ems_frame:
; pring out error message
     mov    left_margin,64
     mov    curx,64
     mov    cury,32
     lea    dx,ems_no
     call   prbox
     call  getkey
     call  present
     call  goback

;
;
;
;
disp_config:
public disp_config
; move the data
; print model
     lea    si,prtline
     mov    bx,printer
     lea    di,prtloc
     call   move_def
; print port
     lea    si,lptline
     mov    bx,lpt
     lea    di,lptloc
     call   move_def
; print density
     lea    si,denline
     mov    bl,pdensity
     mov    bh,0
     lea    di,denloc
     call   move_def
; print baud
     lea    si,baudline
     mov    bl,baud
     mov    bh,0
     cmp bx,0
     je     do_bl
     mov    cl,5
     shr    bx,cl
     sub    bx,3
do_bl:
     lea    di,baudloc
     call   move_def
; print parity
     lea    si,parline
     lea    di,parloc
     mov    bx,1
     cmp    parity,3
     je     do_parl
     mov    bx,2
     cmp    parity,0e7h
     je     do_parl
     mov    bx,3
     cmp    parity,2
     je     do_parl
     mov    bx,0
do_parl:
     call   move_def
; print xor
     lea    si,xorline
     mov    bl,p_xor
     mov    bh,0
     lea    di,xorloc
     call   move_def
; voice
;     lea    si,voiceline
;     mov    bl,voice_switch
;     mov    bh,0
;     lea    di,voiceloc
;     call   move_def
; debug
     lea    si,debline
     mov    bl,debug
     mov    bh,0
     lea    di,debloc
     call   move_def
; character attrib
     lea    si,attline
     mov    bx,attribute
     lea    di,attloc
     call   move_def
; character scale
     lea    si,scaleline
     mov    bx,scale
     lea    di,scaleloc
     call   move_def
; video mode
     lea    di,modeloc
     mov    al,mode
     cmp    al,-1
     je     no_vesa
     mov    ax,'EV'
     jmp    al_num
no_vesa:
; convert al to hex
     mov    ah,al
     mov    cl,4
     shr    al,cl
     and    ah,0fh
     add    ax,3030h
     cmp    ah,39h
     jle    ah_num
     add    ah,7
ah_num:
     cmp    al,39h
     jle    al_num
     add    al,7
al_num:
     stosw
; virtual page width
     lea    si,vwidline
     mov    bx,0
     cmp   vwid,128
     je    do_vwd
     mov    bx,1
     cmp   vwid,256
     je    do_vwd
     mov    bx,2
     cmp   vwid,512
     je    do_vwd
     mov    bx,3
do_vwd:
     lea    di,vwidloc
     call   move_def
; print the panel
     mov    left_margin,64
     mov    curx,64
     mov    cury,32
     lea    dx,dpage
     call   prbox
     call   getkey
     call   blip
     call   present
     mov    left_margin,0
     call   goback
     ret
move_def:
; this moves the stuff in si to di
      shl   bx,1
      mov   si,word ptr ds:[si+bx]
      cld
      lodsb
md_loop:
      stosb
      lodsb
      cmp  al,0
      jne  md_loop
      ret

pmess:
; the pmess proc prints out the message that the default has been
; changed.
; the change message is in si, the type change is in di
     push   si
     push   di
; clear out the message
     lea    di,defmess
     mov    cx,38
     cld
     mov    al,' '
rep  stosb
     lea    di,deftype
     mov    cx,28
     cld
     mov    al,' '
rep  stosb
; now move in the type change
     pop    si
     lea    di,deftype
     mov    cx,28
dt_loop:
     lodsb
     cmp    al,0
     je     end_dt
     stosb
     loop   dt_loop
end_dt:
; now move in the defmess
     pop    si
     lea    di,defmess
     mov    cx,38
dm_loop:
     lodsb
     cmp    al,0
     je     end_dm
     stosb
     loop   dm_loop
end_dm:
; print the message
     mov    left_margin,64
     mov    curx,64
     mov    cury,48
     lea    dx,line1
     call   prbox
     call   getkey
     call   blip
     call   present
     mov    left_margin,0
     call   goback
     ret

bin_to_dec:
public bin_to_dec
; converts ax into a 4 digit decimal in dx:ax
; leading zeros are spaces
      mov  dx,0
      mov  cx,100
      div  cx
      mov  cl,10
      div  cl
      xchg ax,dx
      div  cl
      or   dx,3030h
      or   ax,3030h
      cmp  dl,30h
      je   dl_0
      ret
dl_0:
      mov  dl,' '
      cmp  dh,30h
      je   dh_0
      ret
dh_0:
      mov  dh,' '
      cmp  al,30h
      je   al_0
      ret
al_0:
      mov  al,' '
      ret

save_config:
; save the mode
     mov   al,mode
     mov   default_mode,al
;
     lea   si,default_file
     lea   di,strg
     mov   cx,20
     cld
rep  movsb
     call  create_file
     jc    bad_create
     lea    dx,default
     mov    cx,1024
     call  write_file
     jc    bad_create
     call   close_file
     jc    bad_create
     call   goback
     ret
bad_create:
     call blop
     call blop
     call blop
     call blop
     ret

;
SET_DEFAULTS:
; all the misc default setting stuff is here
; the character attribute bytes are here
;
; printer procs from old fpprint.asm
;
set_p_xor:
      mov   p_xor,1
     lea   di,xor_1
     jmp   do_xor
set_p_no_xor:
      mov   p_xor,0
     lea   di,xor_0
do_xor:
     lea   si,xor_mess
     call  pmess
     ret
;
set_pass1:
      mov   p_pass,0
     lea   di,pass1
     jmp   do_pass
set_pass2:
      mov   p_pass,1
     lea   di,pass2
do_pass:
     lea   si,pass_mess
     call  pmess
     ret
public set_pass1,set_pass2



set_asp1:
set_asp2:
     ret
set_or1:
      mov     orient,0
       cmp    printer,1
       je    set_o1
      call  goback
       ret
set_o1:
        call blip
      ret
set_or2:
      mov     orient,1
       cmp    printer,1
       je    set_o1
      call  goback
       ret

;
; dither settings
set_d0:
public set_d0
    mov  dither,0
     lea   di,dith_0
     jmp   do_dith
set_d1:
public set_d1
    mov  dither,2
     lea   di,dith_1
     jmp   do_dith
set_d2:
public set_d2
    mov  dither,4
     lea   di,dith_2
     jmp   do_dith
set_d3:
public set_d3
    mov  dither,6
     lea   di,dith_3
     jmp   do_dith
set_d4:
public set_d4
    mov  dither,8
     lea   di,dith_3
;    jmp   do_dith
;
do_dith:
     lea   si,dith_mess
     call  pmess
     ret

set_dither_on:
public set_dither_on
    mov  cs:ddswitch,1
    call  blop
    clc
    ret
set_dither_off:
public set_dither_off
    mov  cs:ddswitch,0
    call  blop
    clc
    ret

set_den1:
       mov  pdensity,0
     lea   di,den_2
     jmp   do_den
set_den2:
       mov  pdensity,1
     lea   di,den_3
     jmp   do_den
set_den3:
       mov  pdensity,2
     lea   di,den_4
     jmp   do_den
set_den4:
       mov  pdensity,3
     lea   di,den_3
     jmp   do_den
set_den5:
       mov  pdensity,4
     lea   di,den_5
     jmp   do_den
       ret
set_den6:
       mov  pdensity,5
     lea   di,den_6
do_den:
     lea   si,den_mess
     call  pmess
     ret
set_lpt1:
       mov  lpt,0
     lea   di,lpt_1
     jmp   do_lpt
set_lpt2:
       mov  lpt,1
     lea   di,lpt_2
     jmp   do_lpt
set_lpt3:
       mov  lpt,2
     lea   di,lpt_3
     jmp   do_lpt
do_lpt:
     lea   si,lpt_mess
     call  pmess
     ret
get_p1:
       mov    printer,0
       mov    lines_per_byte,8
     lea   di,prt_1
     jmp   do_prt
get_p2:
       mov    printer,1
       mov    lines_per_byte,1
     lea   di,prt_2
     jmp   do_prt
get_p3:
       mov    printer,2
       mov    lines_per_byte,1
     lea   di,prt_3
     jmp   do_prt
get_p4:
       mov    printer,3
       mov    lines_per_byte,8
     lea   di,prt_4
     jmp   do_prt
get_p5:
public get_p5
       mov    printer,4
       mov    lines_per_byte,8
     lea   di,prt_5
     jmp   do_prt
get_p6:
public get_p6
       mov    printer,5
       mov    lines_per_byte,1
     lea   di,prt_6
     jmp   do_prt
get_p7:
public get_p7
       mov    printer,6
       mov    lines_per_byte,24
     lea   di,prt_7
     jmp   do_prt
get_p8:
public get_p8
       mov    printer,7
       mov    lines_per_byte,6
     lea   di,prt_8
     jmp   do_prt
get_p9:
public get_p9
       mov    printer,8
       mov    lines_per_byte,7
     lea   di,prt_9
     jmp   do_prt
get_p10:
public get_p10
       mov    printer,9
       mov    lines_per_byte,6
     lea   di,prt_10
     jmp   do_prt
get_p11:
public get_p11
       mov    printer,10
       mov    lines_per_byte,8
     lea   di,prt_11
     jmp   do_prt
get_p12:
public get_p12
       mov    printer,11
       mov    lines_per_byte,24
     lea   di,prt_12
     jmp   do_prt
do_prt:
     lea   si,prt_mess
     call  pmess
     ret
get_p13:
public get_p13
       mov    printer,12
       mov    lines_per_byte,24
     lea   di,prt_13
     jmp   do_prt
get_p14:
public get_p14
       mov    printer,13
       mov    lines_per_byte,24
     lea   di,prt_14
     jmp   do_prt

set_1skew:
public set_1skew
     mov   skew,0
     lea   di,skew_1
     jmp   do_skew
set_2skew:
public set_2skew
     mov   skew,1
     lea   di,skew_2
     jmp   do_skew
set_hskew:
public set_hskew
     mov   skew,2
     lea   di,skew_3
;    jmp   do_skew
do_skew:
     lea   si,skew_mess
     call  pmess
     ret
;
set_attrib0:
    mov   attribute,0
    lea   di,att_0
    jmp   do_att
set_attrib1:
    mov   attribute,1
    lea   di,att_1
    jmp   do_att
set_attrib2:
    mov   attribute,2
    lea   di,att_2
    jmp   do_att
set_attrib3:
    mov   attribute,3
    lea   di,att_3
    jmp   do_att
set_attrib4:
    mov   attribute,4
    lea   di,att_4
    jmp   do_att
set_attrib5:
    mov   attribute,5
    lea   di,att_5
    jmp   do_att
set_attrib6:
    mov   attribute,6
    lea   di,att_6
    jmp   do_att
set_attrib7:
    mov   attribute,7
    lea   di,att_7
do_att:
     lea   si,att_mess
     call  pmess
     ret
; set default baud rates
set_baud1:
     mov   baud,80h
     lea   di,baud_1
     jmp   do_baud
set_baud2:
     mov   baud,0a0h
     lea   di,baud_2
     jmp   do_baud
set_baud3:
     mov   baud,0c0h
     lea   di,baud_3
     jmp   do_baud
set_baud4:
     mov   baud,0e0h
     lea   di,baud_4
do_baud:
     lea   si,baud_mess
     call  pmess
     ret
; set breakpoints
set_break0:
     mov   debug,0
     lea   di,deb_0
     jmp   do_break
set_break1:
     mov   debug,1
     lea   di,deb_1
     jmp   do_break
set_break2:
     mov   debug,2
     lea   di,deb_2
     jmp   do_break
set_break3:
     mov   debug,3
     lea   di,deb_3
     jmp   do_break
set_break4:
     mov   debug,4
     lea   di,deb_4
     jmp   do_break
set_break5:
     mov   debug,5
     lea   di,deb_5
     jmp   do_break
set_break6:
     mov   debug,6
     lea   di,deb_6
     jmp   do_break
set_break7:
     mov   debug,7
     lea   di,deb_7
     jmp   do_break
set_break8:
     mov   debug,8
     lea   di,deb_8
     jmp   do_break
set_break9:
     mov   debug,9
     lea   di,deb_9
do_break:
     lea   si,deb_mess
     call  pmess
     ret
; set com line
set_com1:
       mov  lpt,3
     lea   di,com1
     jmp   do_com
set_com2:
       mov  lpt,4
     lea   di,com2
     jmp   do_com
set_com3:
       mov  lpt,5
     lea   di,com3
do_com:
     lea   si,com_mess
     call  pmess
     ret
; set the macro strings
get_macro:
   call reset_segs
   push  di
   call  present
   pop   di
   push  di
   mov   si,di
   lea   di,strg
   mov   cx,72
   cld
rep movsb
; reads a macro
    mov  curx,0
    mov  cury,100
    mov  cx,8
    lea  dx,mac_enter
    call print_string
    mov  str_len,72
    call gstring
    pop   di
    cmp  strg,0
    je   exit_macro
    cmp  al,27
    je   exit_macro
    call  reset_segs
    ret
exit_macro:
   call present
   call goback
   ret
set_macro0:
     lea   di,macro0
     call  get_macro
     jmp   end_macro
set_macro1:
     lea   di,macro1
     call  get_macro
     jmp   end_macro
set_macro2:
     lea   di,macro2
     call  get_macro
     jmp   end_macro
set_macro3:
     lea   di,macro3
     call  get_macro
     jmp   end_macro
set_macro4:
     lea   di,macro4
     call  get_macro
     jmp   end_macro
set_macro5:
     lea   di,macro5
     call  get_macro
     jmp   end_macro
set_macro6:
     lea   di,macro6
     call  get_macro
     jmp   end_macro
set_macro7:
     lea   di,macro7
     call  get_macro
     jmp   end_macro
set_macro8:
     lea   di,macro8
     call  get_macro
     jmp   end_macro
set_macro9:
     lea   di,macro9
     call  get_macro
end_macro:
       lea  si,strg
       mov  cx,72
       cld
rep    movsb
       lea   si,mac_mess
       lea   di,mac_line
       call  pmess
       ret
; set the parity for com printers
set_parity1:
     mov   parity,3
     lea   di,par_1
     jmp   do_par
set_parity2:
     mov   parity,0e7h
     lea   di,par_2
     jmp   do_par
set_parity3:
     mov   parity,2
     lea   di,par_3
do_par:
     lea   si,par_mess
     call  pmess
     ret
; set fonts
extrn do_font0:near,do_font1:near,do_font2:near,do_font3:near
extrn do_font4:near
fontcall dw do_font0,do_font1,do_font2,do_font3,do_font4
public set_font0,set_font1,set_font2,set_font3,set_font4
set_font0:
     mov   bx,0
     lea   di,font_1
     jmp   do_font
set_font1:
     mov   bx,1
     lea   di,font_1
     jmp   do_font
set_font2:
     mov   bx,2
     lea   di,font_2
     jmp   do_font
set_font3:
     mov   bx,3
     lea   di,font_3
     jmp   do_font
set_font4:
     mov   bx,4
     lea   di,font_4
;    jmp   do_font
do_font:
; check to see if font exists
     shl   bx,1
     call  cs:fontcall[bx]
     jc    no_fonts
     lea   si,font_mess
     call  pmess
     ret
no_fonts:
; can't set font
     ret
; set line width
width1:
public width1
     mov   linew,1
     lea   di,width_1
     jmp   do_width
width2:
public width2
     mov   linew,2
     lea   di,width_2
     jmp   do_width
width3:
public width3
     mov   linew,3
     lea   di,width_3
     jmp   do_width
width4:
public width4
     mov   linew,4
     lea   di,width_4
     jmp   do_width
width5:
public width5
     mov   linew,5
     lea   di,width_5
     jmp   do_width
width6:
public width6
     mov   linew,6
     lea   di,width_6
     jmp   do_width
width7:
public width7
     mov   linew,7
     lea   di,width_7
     jmp   do_width
width8:
public width8
     mov   linew,8
     lea   di,width_8
     jmp   do_width
do_width:
     lea   si,width_mess
     call  pmess
     ret
; set scan neg/pos options
;
set_sneg1:
public set_sneg1
    mov sneg,0
    lea  di,sneg_1
    jmp  do_sneg
set_sneg2:
public set_sneg2
    mov sneg,1
    lea  di,sneg_2
;   jmp  do_sneg
do_sneg:
     lea   si,sneg_mess
     call  pmess
     ret
;
; set apply pattern
;
sappl  macro cnt
set_appl&cnt:
public set_appl&cnt
    mov appl_sw,cnt
    lea  di,apply_&cnt
    jmp  do_apply
    endm
do_apply:
     lea   si,apply_mess
     call  pmess
     ret
sappl  0
sappl  1
sappl  2
sappl  3
sappl  4
sappl  5
;
; set color pattern
;
scolor macro cnt
color&cnt:
public color&cnt
    mov colori,cnt
    lea  di,color_&cnt
    jmp  do_color
    endm
do_color:
     lea   si,color_mess
     call  pmess
     ret
scolor 0
scolor 1
scolor 2
scolor 3
scolor 4
scolor 5
scolor 6
scolor 7
scolor 8
scolor 9
scolor 10
scolor 11
scolor 12
scolor 13
scolor 14
scolor 15
scolor 16
scolor 17
; set scale factor for letters
set_scale1:
     mov   scale,1
     lea   di,scale_1
     jmp   do_scale
set_scale2:
     mov   scale,2
     lea   di,scale_2
     jmp   do_scale
set_scale4:
     mov   scale,4
     lea   di,scale_3
     jmp   do_scale
set_scaleh:
     mov   scale,0
     lea   di,scale_h
do_scale:
     lea   si,scale_mess
     call  pmess
     ret
; set virtual page width
set_v128:
     mov   vwid,128
     lea   di,vwid_128
     jmp   do_vwid
set_v256:
     mov   vwid,256
     lea   di,vwid_256
     jmp   do_vwid
set_v512:
     mov   vwid,512
     lea   di,vwid_512
     jmp   do_vwid
set_v1024:
     mov   vwid,1024
     lea   di,vwid_1024
;    jmp   do_vwid
do_vwid:
     push  di
; calculate maxlines, total number of lines in pic
            MOV   AX,segmentsize
            mov   dx,0
            mov   cx,tot_mem
            mul   cx
            div   vwid
            mov   maxlines,ax
     call  calc_last
     call  erase_mem
     mov   siloc,0
     mov   curr_seg,0
     pop   di
     lea   si,vwid_mess
     call  pmess
     ret
; set voice sounds on and off
;set_voice_on:
;     mov   voice_switch,0
;     lea   di,voice_on
;     jmp   do_voice
;set_voice_off:
;     mov   voice_switch,1
;     lea   di,voice_off
;do_voice:
;     lea   si,voice_mess
;     call  pmess
;     ret
; planes
set_plane_1:
     mov   plane_switch,1
     lea   di,plane_1
     jmp   do_plane
set_plane_4:
     mov   plane_switch,4
     lea   di,plane_4
     jmp   do_plane
set_plane_8:
     mov   plane_switch,8
     lea   di,plane_8
     jmp   do_plane
set_plane_16:
     mov   plane_switch,16
     lea   di,plane_16
;    jmp   do_plane
public set_plane_1,set_plane_4,set_plane_16,set_plane_8
do_plane:
     mov   ax,1
     cmp   planesa,1
     je    no_mode_change
     mov   al,plane_switch
no_mode_change:
     mov   planes,ax
     lea   si,plane_mess
     call  pmess
     ret
set_tone_on:
public set_tone_on
     mov   tone_on,0
     lea   di,tone_on_mess
     jmp   do_tone
set_tone_off:
public set_tone_off
     mov   tone_on,1
     lea   di,tone_off_mess
do_tone:
     lea   si,tone_mess
     call  pmess
     ret
;
;
set_destroy_on:
public set_destroy_on
     mov   destroy,1
     lea   di,destroy_on_mess
     jmp   do_destroy
set_destroy_off:
public set_destroy_off
     mov   destroy,0
     lea   di,destroy_off_mess
do_destroy:
     lea   si,destroy_mess
     call  pmess
     ret


public SAVE_CONFIG
public SET_BAUD1
public SET_BAUD2
public SET_BAUD3
public SET_BAUD4
public SET_BREAK0
public SET_BREAK1
public SET_BREAK2
public SET_BREAK3
public SET_BREAK4
public SET_BREAK5
public SET_BREAK6
public SET_BREAK7
public SET_BREAK8
public SET_BREAK9
public SET_COM1
public SET_COM2
public SET_COM3
public SET_MACRO1
public SET_MACRO2
public SET_MACRO3
public SET_MACRO4
public SET_MACRO5
public SET_MACRO6
public SET_MACRO7
public SET_MACRO8
public SET_MACRO9
public SET_PARITY1
public SET_PARITY2
public SET_PARITY3
public SET_SCALE1
public SET_SCALE2
public SET_SCALE4
public SET_SCALEH
public SET_V128
public SET_V256
public SET_V512
public SET_V1024
;ublic SET_VOICE_OFF
;ublic SET_VOICE_ON
public plane_switch
CSEG ends
     end
