; OKCOPY is the routine which does the move of image data from one
; area to another. The major callable routine is MOVE_RANGE

;
segmentsize equ 8000h
DSEG segment public 'DATA'
assume cs:cseg,ds:dseg,es:dseg
extrn   work_seg:word,work2_seg:word
extrn   p_xor:byte,vwid:word,debug:byte
extrn   height_pix:word,width_bytes:word
extrn   vwid:word,srow:word,scol:word,left_margin:word
extrn   curx:word,cury:word,lrow:word,lcol:word
extrn   fux:word,fuy:word,flx:word,fly:word
extrn   olay:byte
;
; local data
;
waitc  db 0
function db 0
;
dseg ends
;
cseg segment public 'CODE'
assume cs:cseg,ds:dseg,es:dseg
extrn   present:near,quit:near,get_next_seg:near,get_curr_seg:near
extrn   get_next2_seg:near,get_curr2_seg:near,get_prev2_seg:near
extrn   reset_segs:near,get_prev_seg:near
extrn   do_wait:near,next_wait:near
extrn   blip:near,blop:near,calc_file_size:near
extrn   goback:near
extrn  setup_start:near
;

; move lines is the routine to move according to size etc
movelines dw  fmove,fmoveb,fmoveo,fmovebo,fmovex,fmovebx
inclines  dw  godown,goup,godown,goup,godown,goup
move_range proc  near
copy_range:
public copy_range
;
; check for debug
;
      call reset_segs
      cmp  debug,9
      jne  no_debug
      int  3    ; debug break
no_debug:
      mov   function,0
;
;
;
      call  setup_first
      call  setup_second
      cmp   height_pix,0
      jl    bad_range
      cmp   width_bytes,0
      jl    bad_range
      jmp   ok_range
bad_range:
      call  reset_segs
      call  blip
      call  blip
      call  blip
      ret
ok_range:
       call  do_wait
; there are two ways to do this,
; if fuy is greater than srow then do a normal
;     int   3
      mov   ax,srow
      cmp   ax,fuy
      jl    done_func
      je    check_equ
      jmp   go_backwards ; this forces no other changes
      cmp   ax,fly
      jg    done_func
; also if the flx is gt than scol its ok
      mov   ax,scol
      cmp   ax,flx
      jg    done_func
; if fux is greater than lcol its ok also
      mov   ax,fux
      cmp   ax,lcol
      jg    done_func
; its too bad but we must go left to right and bottom up
      jmp   go_backwards
check_equ:
; starting rows are equal
; if the scol is less than the fux then its ok
      mov   ax,scol
      cmp   ax,fux
      jle   done_func
go_backwards:

      mov   function,1
      call  back_set
done_func:
       mov   bl,function
       add  bl,olay
       mov   bh,0
       shl   bx,1
      mov   cx,height_pix
      mov   waitc,16
      cmp   cx,1
      jg    move_loop
      mov   cx,1
move_loop:
       push  cx
       push  bx
       mov   cx,width_bytes
       push  si
       push  di
       push  ds
       mov   ds,bp
       push  bx
       call  cs:movelines[bx]
       pop   bx
       pop   ds
       pop   di
       pop   si
       call  cs:inclines[bx]
       dec   waitc
       jnz   ok_wait
       mov   waitc,16
       call  next_wait
ok_wait:
       pop   bx
       pop   cx
       loop  move_loop
       call  present
       call  reset_segs
       ret
;
;
move_range  endp
;
;
godown proc  near
       add   di,vwid
       cmp   di,0
       jge   ok_di
       sub   di,segmentsize
       call  get_next2_seg
       mov   es,ax
ok_di:
       add   si,vwid
       cmp   si,0
       jge   ok_si
       sub   si,segmentsize
       call  get_next_seg
       mov   bp,ax
ok_si:
      ret
godown  endp
;
;
;
goup   proc  near
       sub   di,vwid
       cmp   di,0
       jge   ok_did
       add   di,segmentsize
       call  get_prev2_seg
       mov   es,ax
ok_did:
       sub   si,vwid
       cmp   si,0
       jge   ok_sid
       add   si,segmentsize
       call  get_prev_seg
       mov   bp,ax
ok_sid:
      ret
goup    endp
;
;
back_set  proc near
; calculates the es and di of the last segs on each
;
       call  reset_segs
; now calc the es:di for flx,fuy
       mov  ax,segmentsize
       mov  dx,0
       div  vwid
       mov  cx,ax
       mov  ax,fly
       mov  dx,0
       div  cx
; ax has the number of segments, dx the remainder lines
       mov  work_seg,ax
       call get_curr_seg
       mov  bp,ax
       mov  ax,dx
       mul  vwid
       add ax,fux
       mov  si,ax
;
;
; now calc the es:di for scol,lrow
       mov  ax,segmentsize
       mov  dx,0
       div  vwid
       mov  cx,ax
       mov  ax,lrow
       mov  dx,0
       div  cx
; ax has the number of segments, dx the remainder lines
       mov  work2_seg,ax
       call get_curr2_seg
       mov  es,ax
       mov  ax,dx
       mul  vwid
       add ax,scol
       mov  di,ax
;
;
;
      ret
back_set  endp
;
;
;
;
setup_second  proc near
; setup the from move stuff
;extrn   fux:word,fuy:word,flx:word,fly:word
; get fux, fuy in upper left hand corner
        push  di
        push  es
       mov  ax,fux
       mov  bx,flx
       cmp  ax,bx
       jle  ok_fux
       mov  fux,bx
       mov  flx,ax
ok_fux:
       mov  ax,fuy
       mov  bx,fly
       cmp  ax,bx
       jle  ok_fuy
       mov  fuy,bx
       mov  fly,ax
ok_fuy:
; now calc the es:di for fux,fuy
       mov  ax,segmentsize
       mov  dx,0
       div  vwid
       mov  cx,ax
       mov  ax,fuy
       mov  dx,0
       div  cx
; ax has the number of segments, dx the remainder lines
       mov  work_seg,ax
       call get_curr_seg
       mov  bp,ax
       mov  ax,dx
       mul  vwid
       add ax,fux
       mov  si,ax
        pop   es
        pop   di

       ret
setup_second  endp
setup_first   proc near
; sets up the to location suff
       mov  ax,scol
       mov  bx,lcol
       cmp  ax,bx
       jle  ok_scol
       mov  scol,bx
       mov  lcol,ax
ok_scol:
       mov  ax,srow
       mov  bx,lrow
       cmp  ax,bx
       jle  ok_srow
       mov  srow,bx
       mov  lrow,ax
ok_srow:
; now calc the es:di for scol,srow
       mov  ax,segmentsize
       mov  dx,0
       div  vwid
       mov  cx,ax
       mov  ax,srow
       mov  dx,0
       div  cx
; ax has the number of segments, dx the remainder lines
       mov  work2_seg,ax
       call get_curr2_seg
       mov  es,ax
       mov  ax,dx
       mul  vwid
       add ax,scol
       mov  di,ax
       mov  cx,lcol
       sub  cx,scol
       mov  width_bytes,cx
       mov  cx,lrow
       sub  cx,srow
       mov  height_pix,cx
        ret
setup_first   endp


fmoveb    proc  near
      call  get_curr_seg
      call  get_curr2_seg
      add  di,cx
      dec  di
      add  si,cx
      dec  si
      std
rep   movsb
      cld
      ret
fmoveb    endp



fmove     proc  near
      call  get_curr_seg
      call  get_curr2_seg
      cld
rep   movsb
      ret
fmove     endp




fmoveo    proc  near
      cld
      call  get_curr_seg
      call  get_curr2_seg
fmb1_loop:
      lodsb
      or  byte ptr es:[di],al
      inc  di
      loop  fmb1_loop
      ret
fmoveo    endp


fmovebo   proc  near
      call  get_curr_seg
      call  get_curr2_seg
      add  di,cx
      dec  di
      add  si,cx
      dec  si
      std
fmb0_loop:
      lodsb
      or  byte ptr es:[di],al
      dec  di
      loop  fmb0_loop
      cld
      ret
fmovebo   endp



fmovex    proc  near
      call  get_curr_seg
      call  get_curr2_seg
      cld
fmb2_loop:
      lodsb
     xor  byte ptr es:[di],al
      inc  di
      loop  fmb2_loop
      ret
fmovex    endp



fmovebx   proc  near
      call  get_curr_seg
      call  get_curr2_seg
      add  di,cx
      dec  di
      add  si,cx
      dec  si
      std
fmb3_loop:
      lodsb
     xor  byte ptr es:[di],al
      dec  di
      loop  fmb3_loop
      cld
      ret
fmovebx   endp

cseg ends
    end
