; OKTIF.ASM reads tif packed
;
;
;
;
dseg segment public 'DATA'
    ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
extrn   buffer:word
    ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
    EXTRN   TIF_HEADER:WORD
    EXTRN   WIDTH_PIX:WORD
    EXTRN   HEIGHT_PIX:WORD
    EXTRN   WIDTH_BYTES:WORD
    extrn   vwid:word,color:byte
    extrn   handle:word
;
;
tif_reverse  db  0   ; 0 if intel, 1 if motorola
;
tif_ifd dw 0
; this is the area where the ifd is read into
; An IFD consists of a 2-byte count of the number of entries (i.e., the
; number of fields), followed by a sequence of 12-byte field entries,
; followed by a 4-byte offset of the next Image File Directory (or 0 if
; none).  Each 12-byte field entry has the following format:


tagdir  db 12 dup(0)

tif_strip db  0  ; contains the data of whether or not its a strip file
tif_compr dw 0  ; compression method
tif_rows  dw 0   ; rows per strip
tif_scount dw 0  ; count of strips in a file
tif_fillorder dw 0;
public tif_fillorder
remainder  dw 0 ; for badly shifted tifs
cremain    dw 0
bad_count  dw 0
bps    dw 1
xor_view  db 0
;
curr_strip dw 0,0  ; length of current strip
curr_stripb dw 0
extrn hash_segment:word

; alternate fillorder table
filltable db 000h,080h,040h,0c0h,020h,0a0h,060h,0e0h
          db 010h,090h,050h,0d0h,030h,0b0h,070h,0f0h
          db 008h,088h,048h,0c8h,028h,0a8h,068h,0e8h
          db 018h,098h,058h,0d8h,038h,0b8h,078h,0f8h
          db 004h,084h,044h,0c4h,024h,0a4h,064h,0e4h
          db 014h,094h,054h,0d4h,034h,0b4h,074h,0f4h
          db 00ch,08ch,04ch,0cch,02ch,0ach,06ch,0ech
          db 01ch,09ch,05ch,0dch,03ch,0bch,07ch,0fch
          db 002h,082h,042h,0c2h,022h,0a2h,062h,0e2h
          db 012h,092h,052h,0d2h,032h,0b2h,072h,0f2h
          db 00ah,08ah,04ah,0cah,02ah,0aah,06ah,0eah
          db 01ah,09ah,05ah,0dah,03ah,0bah,07ah,0fah
          db 006h,086h,046h,0c6h,026h,0a6h,066h,0e6h
          db 016h,096h,056h,0d6h,036h,0b6h,076h,0f6h
          db 00eh,08eh,04eh,0ceh,02eh,0aeh,06eh,0eeh
          db 01eh,09eh,05eh,0deh,03eh,0beh,07eh,0feh
;
          db 001h,081h,041h,0c1h,021h,0a1h,061h,0e1h
          db 011h,091h,051h,0d1h,031h,0b1h,071h,0f1h
          db 009h,089h,049h,0c9h,029h,0a9h,069h,0e9h
          db 019h,099h,059h,0d9h,039h,0b9h,079h,0f9h
          db 005h,085h,045h,0c5h,025h,0a5h,065h,0e5h
          db 015h,095h,055h,0d5h,035h,0b5h,075h,0f5h
          db 00dh,08dh,04dh,0cdh,02dh,0adh,06dh,0edh
          db 01dh,09dh,05dh,0ddh,03dh,0bdh,07dh,0fdh
          db 003h,083h,043h,0c3h,023h,0a3h,063h,0e3h
          db 013h,093h,053h,0d3h,033h,0b3h,073h,0f3h
          db 00bh,08bh,04bh,0cbh,02bh,0abh,06bh,0ebh
          db 01bh,09bh,05bh,0dbh,03bh,0bbh,07bh,0fbh
          db 007h,087h,047h,0c7h,027h,0a7h,067h,0e7h
          db 017h,097h,057h,0d7h,037h,0b7h,077h,0f7h
          db 00fh,08fh,04fh,0cfh,02fh,0afh,06fh,0efh
          db 01fh,09fh,05fh,0dfh,03fh,0bfh,07fh,0ffh
public filltable
;
dseg  ends
buffersize  equ 4000h
;
CSEG    SEGMENT PUBLIC 'CODE'
    ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
EXTRN   reset_segs:near
extrn   read_file:near
extrn   flush_buffer:near
extrn  huffr1:near,huffr2:near
extrn  huffr:near,next_wait:near
;
;
TIF_IN    PROC    NEAR
    PUBLIC  TIF_IN
; tif_in will decode all types of TIF headers (hopefully)
;
    call    reset_segs
    mov    bad_count,0
; initialize variable fields
    mov    curr_strip,0
    mov    curr_strip+2,0
    mov    curr_stripb,0
    mov    tif_compr,0
    mov    tif_strip,0
    mov  bps,1
; check out the header
    cmp    tif_header[2],'II'
    je    tif_intel
    cmp    tif_header[2],'MM'
    jne    bad_tiff_head
    mov    tif_reverse,1
tif_intel:
    lea    si,tif_header[4]
    call    tif_word
    cmp    ax,002ah  ; version
    jne    bad_tiff_head
    lea    si,tif_header[6]
    call    tif_dword
; dx:ax has the dword in it, which is offset from start of file
; we must position in file at this location
    mov    bx,handle
    mov    cx,dx      ; high word
    mov    dx,ax      ; low word
    mov    ax,4200h
    int    21h
    jc    bad_tiff_head
; here we have positioned at the start of the IFD?
; we have to process the ifd
; ifd format is in TIF_IFD above
    lea   dx,tif_ifd
    mov   cx,2
    call  read_file
    cmp   ax,2
    jne   bad_tiff_head
    lea   si,tif_ifd
    call  tif_word
    mov   cx,ax
    cmp   cx,0
    jle   bad_tiff_head
;
;  cx has the number of tags to process
tag_loop:
    push    cx
    call   process_tag
    pop    cx
    jnc   ok_tiff_head
    jmp   done_tag_loop
bad_tiff_head:
    STC
    RET
ok_tiff_head:
    loop  tag_loop
; here we process after tags
;
; calculate number of strips
;
done_tag_loop:
    mov   tif_scount,1   ; default
;
    cmp   tif_rows,0    ; number of rows in a strip
    jle   no_strips
    mov   ax,height_pix
    add   ax,tif_rows  ; rows per strip
    dec   ax
    mov   dx,0
    div   tif_rows
    mov   tif_scount,ax
no_strips:
; if there are strips we must get them
; required there be a strip offset
    cmp   curr_strip,1
    jg    get_curr_strip
    jmp   no_curr_strip
get_curr_strip:
    push   es
    mov    es,hash_segment
    mov   dx,word ptr es:[0]    ; low word
    mov   cx,word ptr es:[2]    ; high word
    mov    bx,handle
    mov    ax,4200h
    int    21h
    pop   es
    jc    bad_tiff_head
    mov   cx,curr_strip
    shl   cx,1
    shl   cx,1
    push   ds
    mov    ds,hash_segment
    mov   dx,0
    call  read_file
    pop   ds
    jc    bad_tiff_head
    cmp   curr_stripb,1
    jle   no_curr_strip
    push   ds
    mov    ds,hash_segment
    mov   dx,word ptr ds:[2000h]
    mov   cx,word ptr ds:[2002h]
    pop    ds
    mov    bx,handle
    mov    ax,4200h
    int    21h
    jc    bad_tiff_head2
    mov   cx,curr_stripb
    push   ds
    mov    ds,hash_segment
    mov   dx,2000h
    shl   cx,1
    shl   cx,1
    call  read_file
    pop   ds
    jc    bad_tiff_head2
;    jmp   got_curr_strip
no_curr_strip:
got_curr_strip:
;check Compression
; 1 = none    handle
; 2 = group 3 1-d    handle
; 3 = group 3 (2d?   can only handle 1d.
; 4 = group 4 fax    give it a try
; 8003h = no compress, word align rows
; 8005h = packbits
    cmp   tif_compr,0
    je    bad_tiff_head2
; finished processing the tags, return to set up the read of the file
    cmp   tif_compr,1
    je    check_bps
    cmp   tif_compr,8003h
    je    check_bps
no_bps:
    mov   bps,1
    clc
    ret
check_bps:
    cmp   bps,1
    jle   no_bps
    cmp   bps,4
    jne   bad_tiff_head2
    mov   ax,height_pix
    mul   bps
    mov   height_pix,ax
    clc
    ret
bad_tiff_head2:
    STC
    RET

;
;
;
;
process_tag:
    lea   dx,tagdir
    mov   cx,12
    call  read_file
    cmp   ax,12
    je    good_tag_read
    stc
    ret
good_tag_read:
    lea   si,tagdir
; si point to tag id
    call  tif_word
    cmp  ax,0
    jl   bad_tif_header
    cmp  ax,301
    jg   bad_tif_header
    sub  ax,255    ; bypass the guy starting at 255
    cmp  ax,0
    jl   unknown_header
    mov   bx,ax
    shl   bx,1
    call get_tval  ; returns the tag value in dx:ax
    call  cs:tags[bx]
    ret
;
unknown_header:
    call get_tval  ; returns the tag value in dx:ax
    clc
    ret
bad_tif_header:
    STC
    RET
;
get_tval:
; si points to the type of a tag
    mov   dx,0
    call  tif_word ; this is the type
    mov   cx,ax
    call  tif_dword ; this is the count of how many items
    xchg  ax,cx
    cmp   ax,1
    je    t_byte
    cmp   ax,2
    je    a_byte
    cmp   ax,3
    je    s_byte
    cmp   ax,4
    je    l_byte
    cmp   ax,5
    je    r_byte
    jmp   bad_tif_header
r_byte:
; real which I can't handle
    mov   dx,0
    mov   ax,0
    ret
l_byte:
; 32 bit integer
    call  tif_dword
    ret
s_byte:
; 16 bit short
    call  tif_word
    mov   dx,0
    ret
a_byte:
    mov   dx,0
    mov   ax,0
; can't handle ascii data now
    ret
t_byte:
    lodsb
    mov ah,0
    ret
tags  dw   t255,t256,t257,t258,t259,tbad,tbad,t262,t263,t264
    dw   t265,t266,t267,t268,t269,t270,t271,t272,t273,t274
    dw   t275,t276,t277,t278,t279,t280,t281,t282,t283,t284
    dw   t285,t286,t287,t288,t289,t290,t291,t292,t293,t294
    dw   t295,t296,t297,t298,t299,t300,t301,tbad,tbad,tbad
;
;
tbad:
; unknown tag
   stc
   ret
t255:
;SubfileType
;  ax has the subfile type, 1 and 2 means it has strips
    mov   tif_strip,al
    clc
    ret
t256:
; ax has the width in bits of the file
    push  cx
    mov  width_pix,ax
    mov   dx,0
    add   ax,7
    mov   cx,8
    div   cx
    mov  width_bytes,ax
    mov  remainder,dx
    mov  cremain,0
    pop   cx
    clc
    ret
t257:
;ImageLength
; ax has the long length of the file
    mov  height_pix,ax
    clc
    ret  ; for now
t258:
;BitsPerSample
; for colors has the number of bits per sample
    mov  bps,ax
    clc
    ret  ; for now
t259:
;Compression
    mov  tif_compr,ax
    clc
    ret  ; for now
t262:
;PhotometricInterpretation
    cmp   al,0
    je    no_xor
    mov   xor_view,0ffh
    clc
    ret
no_xor:
    mov   xor_view,0
    clc
    ret
t263:
;Threshholding
t264:
;CellWidth
t265:
;CellLength
    clc
    ret
t266:
;FillOrder
    mov  tif_fillorder,ax
    clc
    ret  ; for now
t267:
t268:
t269:
;DocumentName
t270:
;ImageDescription
t271:
;Make
t272:
;Model
    clc
    ret

t273:
;StripOffsets
;Tag	= 273  (111)
;Type	= SHORT or LONG
;N	= StripsPerImage for PlanarConfiguration equal to 1.
;	= SamplesPerPixel * StripsPerImage for PlanarConfiguration equal to 2
;
; these strips are used to read the image (the only way to read image)
; I can save up to 128 of them. More than that and I am screwed
    push   ds
    mov    ds,hash_segment
    mov   word ptr ds:[0],ax
    mov   word ptr ds:[2],dx
    pop   ds
    mov   curr_strip,cx
    clc
    ret
; when we are done this will have to be loaded into strip_locs
t274:
;Orientation
    clc
    ret
t275:
t276:
   stc
   ret

t277:
;SamplesPerPixel
    clc
    ret

t278:
;RowsPerStrip
; this figure is how many lines of data live in a strip
    mov  tif_rows,ax
    clc
    ret

t279:
;StripByteCounts
;Tag	= 279  (117)
;Type	= LONG
;N	= StripsPerImage for PlanarConfiguration equal to 1.
;	= SamplesPerPixel * StripsPerImage for PlanarConfiguration equal to 2
; this is how many bytes in a strip, I am assuming there is a one
; per one correspondence with stip offset and strip bytes
    push   ds
    mov    ds,hash_segment
    mov   word ptr ds:[2000h],ax
    mov   word ptr ds:[2002h],dx
    pop    ds
    mov   curr_stripb,cx
    clc
    ret
t280:
;MinSampleValue
t281:
;MaxSampleValue
t282:
;XResolution
t283:
;YResolution
t284:
;PlanarConfiguration
t285:
;PageName
t286:
;XPosition
t287:
;YPosition
t288:
;FreeOffsets
t289:
;FreeByteCounts
t290:
;GrayResponseUnit
t291:
;GrayResponseCurve
t292:
;Group3Options
t293:
;Group4Options
    clc
    ret
t294:
t295:
   stc
   ret


t296:
;ResolutionUnit
t297:
;PageNumber
    clc
    ret
t298:
t299:
   stc
   ret

t300:
;ColorResponseUnit
t301:
;ColorResponseCurves
t302:
t303:
    clc
    ret
tif_dword:
; gets a double word into dx,ax
    call   tif_word
    mov    dx,ax           ; low byte
    call   tif_word        ; high byte
    cmp    tif_reverse,1
    je    exit_tif_dword
    xchg   dx,ax
exit_tif_dword:
    ret
tif_word:
; gets a word from ds:[si]
    lodsw
    cmp    tif_reverse,1
    jne    exit_tif_word
    xchg   al,ah
exit_tif_word:
    ret
TIF_IN    ENDP


TIF_READ    PROC    NEAR
public tif_read
    call    reset_segs
; xyzzy
; here we must set up the loop to read the strips
    mov    cx,tif_scount  ; count of strips
    mov    bx,0
tifr_loop:
    push    cx
    push   bx
;
; bx has the strip number
; first get the strip offset
    shl   bx,1
    shl   bx,1
    push   ds
    mov    ds,hash_segment
    mov   dx,word ptr ds:[bx]
    mov   cx,word ptr ds:[bx+2]
    pop    ds
    mov    bx,handle
    mov    ax,4200h
    int    21h
    jnc    good_s_loc
bad_strip_p:
    pop    bx
    pop    cx
    stc
    ret
good_s_loc:
; found the strip
    pop   bx
    push  bx
    shl   bx,1
    shl   bx,1
    push   es
    mov    es,hash_segment
    mov   ax,word ptr es:[2000h][bx]
    mov   curr_strip,ax
    mov   ax,word ptr es:[2002h][bx]
    pop   es
    mov   curr_strip+2,ax
    cmp   curr_strip+2,0
    jne   good_strip_size
    cmp   curr_strip,0
    jl    good_strip_size
    cmp   curr_strip,1
    jg    good_strip_size
    mov   curr_strip,-1
    mov   curr_strip+2,-1
good_strip_size:
; cx has how many bytes are in the strip
    call   process_strip
    jc    bad_strip_p
    pop    bx
    pop    cx
    inc    bx
    loop   tifr_loop
    stc
    ret
;
;
process_strip:
    mov  di,6000h
    mov  si,6000h
    mov  bp,6000h
    call  get_strip_buffer ; gets a buffer from strip
    jnc   ps1
ps0:
    stc
    ret
ps1:
    cmp   ax,0
    je    ps0
    mov  si,6000h
    mov  di,0
; set up the loop, we will do a line at a time through the loop
; si points ot location in buffer
    mov   cx,tif_rows  ; rows in a strip
    cmp    tif_compr,1
    je    stripr_loop
    cmp    tif_compr,8003h
    je    stripr_loop
    cmp    tif_compr,8005h
    je    stripr_loop
; it may also ne necessary to do a flip on the buffer
    call   huffr1
    mov   cx,tif_rows  ; rows in a strip
stripr_loop:
    push   cx
; several ways of doing the strip
    cmp    tif_compr,1
    je    read_t_raw
    cmp    tif_compr,8003h
    je    read_t_raw
    cmp    tif_compr,8005h
    je    read_t_packbits
    cmp    tif_compr,3
    je     read_t_group3
;    jmp  read_tif_comp
; tif group 3 fax stuff
read_tif_comp:
; here the huffman stuff is doen
;
;    inc    bad_count
;    cmp    bad_count,799
;    jne    no_bad
;o_bad:
read_t_group3:
    mov    di,0

;    call    set_segs
    cld
    call  huffr
    jnc   good_huff
    pop   cx
;    call  reset_segs
    stc
    ret
good_huff:
    call  reset_segs
    jmp   stripr_bloop1
read_t_packbits:
; this is for the packbits stuff
; read a line at a time for packbits
    mov    bx,width_bytes ; bx for packbits
    mov    di,0
    call    set_segs
    cld
    mov    dl,xor_view
    mov    dh,0
    call    un_packbits
    call    reset_segs
    jmp    stripr_bloop1
read_t_raw:
; here have a buffer with a direct move (as long as its less than 800h
    cmp    bps,1
    je    read_t_rawp
    jmp    gray_scale
read_t_rawp:
    mov    cx,width_bytes
    mov    di,0
    call    set_segs
    cld
rep   movsb
    jmp    stripr_bloop1
gray_scale:
; each rwo is 4 planes so we use width_bytes
; here the width is 4 times as wide
    mov    cx,width_bytes
    mov    bx,cx
    mov    di,0   ; si is set by move_down stuff
    call    set_segs
gray_loop:
    push   di
    push   cx
    mov    cx,4
gl0:
    push   di
    push   cx
    cld
    lodsb
    mov    cx,2
gl1:
    push   di
    push   cx
    mov    cx,4
gl2:
    mov    ah,byte ptr ds:[di]
    shl    ax,1
    mov    byte ptr ds:[di],ah
    add    di,bx
    loop   gl2
    pop    cx
    pop    di
    loop   gl1
    pop    cx
    pop    di
    loop   gl0
    pop    cx
    pop    di
    inc    di
    loop   gray_loop
    call   reset_segs
    mov    cx,width_bytes
    shl    cx,1
    shl    cx,1
    dec    si
    push   si
    push   bp
    call   flush_buffer
    pop    bp
    pop    si
    jc    stripr_bloop2
; have to check the si to see if he's ok
    call   move_tif_down
    jmp    stripr_bloop2
stripr_bloop1:
; got a line, flush it
    call   reset_segs
    mov    cx,width_bytes
    push   si
    push   bp
    call   flush_buffer
    pop    bp
    pop    si
    jc    stripr_bloop2
; have to check the si to see if he's ok
    call   move_tif_down
stripr_bloop2:
    pop    cx
    jc    all_done_loop
    loop   stripr_loopx
    jmp    stripr_loopb
stripr_loopx:
    jmp    stripr_loop
stripr_loopb:
    clc
all_done_loop:
    ret
;
;
;
move_tif_down:
; this moves down the tif, resets si and sees if filling is needed
    cmp   si,6400h
    jl    no_moved
    cmp   bp,6400h
    jl    no_moved
    mov   di,6000h
    mov   cx,bp
    sub   cx,si
    cmp   cx,0
    jg    do_moved
no_moved:
    mov   di,0
    clc
    ret
do_moved:
    cld
    call  set_segs
rep  movsb
    call  reset_segs
    mov   si,6000h
    mov   bp,di
    cmp   bp,6500h ; time to file?
    jl    get_strip_buffer
    mov   di,0
    clc
    ret
get_strip_buffer:
; reads a strip into the buffer
; if the tif_strip=3 then ignores curr_strip info
; di is here it goes
    mov   cx,1000h    ; 4K at a time
    mov   ax,buffer
    push  es
    push  di
    mov   es,ax
    cld
    mov  al,0
rep stosb
    pop   di
    pop   es
    mov   cx,1000h    ; 4K at a time
    mov   ax,buffer
    push  ds
    mov   ds,ax
    mov   dx,di    ; di has the location
    push   si
    push   di
    push   bp
    call  read_file
    pop   bp
    pop   di
    pop   si
    pop   ds
exit_strip_buffer:
    cmp   ax,0
    jne   ok_strip_buffer
    cmp   bp,si
    jg    ok_strip_buffer
    cmp   di,6000h
    jg    ok_strip_buffer
    clc
    ret
ok_strip_buffer:
    mov   bp,di
    add   bp,ax
    mov   di,0
    clc
    ret
;
;
;
set_segs:
    push  ax
    mov   ax,buffer
    mov   ds,ax
    mov   es,ax
    pop   ax
    ret
;
;
un_packbits:
    call  upb
    cmp   bx,0
    jg    un_packbits
    ret
upb:
; bx has the length of line to unpack
; dl has the xor byte
    XOR   CH,CH
    LODSB
    TEST  AL,80h
    JZ    mac_no_hi
    NEG   AL
    MOV   CL,AL
    INC   CX
    LODSB
    sub   bx,cx
    XOR   AL,dl
    REP   STOSB
    ret
mac_no_hi:
    MOV   CL,AL
    INC   CX
; move loop here to xor each byte
    CLD
mac_xor_loop:
    LODSB
    XOR   AL,dl
    STOSB
    dec   bx
    LOOP  mac_xor_loop
    ret

TIF_READ    ENDP


CSEG    ENDS
    END
