; OKFILE12.ASM has the read and write routines for various files
;
;
;
include f:\ok\okfiles.asm
;
dseg segment public 'DATA'
     ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
extrn   vint:word,vphase:word,buffer:word
     ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
     EXTRN   DEG_HEADER:WORD
     EXTRN   IMG_HEADER:WORD
     EXTRN   IMG_HEADERo:WORD
     EXTRN   PIG_HEADER:WORD
     EXTRN   PIG_HEADERo:WORD
     EXTRN   RAS_HEADER:WORD
     EXTRN   RAS_HEADERo:WORD
     EXTRN   RAW_HEADER:WORD
     EXTRN   RAW_HEADERo:WORD
     EXTRN   ART_HEADER:WORD
     EXTRN   ART_HEADERo:WORD
     EXTRN   PCT_HEADER:WORD
     EXTRN   PCT_HEADERo:WORD
     EXTRN   NWS_HEADER:WORD
     EXTRN   DCOPY_HEADER:WORD
     EXTRN   DCOPY_HEADERo:WORD
     EXTRN   PEL_SIZE:WORD
     EXTRN   WIDTH_PIX:WORD
     EXTRN   HEIGHT_PIX:WORD
     EXTRN   WIDTH_BYTES:WORD
divisor  dw  0,1
ten     dw  10,100,1000,10000
grayshade equ 0
flags    dw  0
color   dw  0
gem_headerx db  0,1,0,8
;
;
; *********  GRAY 16 SHADES MAP ***********************8
;
gray_map_16a db 0,7,56,63,0,7,56,63,0,7,56,63,0,7,56,63,0
;
;
;
dseg  ends
buffersize  equ 4000h
;
CSEG     SEGMENT PUBLIC 'CODE'
     ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
EXTRN   WRITE_RAW:NEAR,reset_segs:near,write_file:near
EXTRN   READ_RAW:NEAR,calc_file_size:near
extrn   read_file:near,write_file:near,next_wait:near
extrn   flush_buffer:near,fill_buffer:near
extrn  decomp:word,move_raw:word
;
;
;     IMAGE IN
;
     PUBLIC  IMG_IN
IMG_IN:
     call    reset_segs
     lea     ax,move_raw
     mov     cs:decomp,ax
     MOV     AX,IMG_HEADER.IMG_WIDTH_BYTE
     MOV     WIDTH_BYTES,AX     ;SAVE AS BYTES
     SHL     AX,1
     SHL     AX,1
     SHL     AX,1
     MOV     WIDTH_PIX,AX     ;SAVE AS PIXELS
     MOV     AX,IMG_HEADER.IMG_HEIGHT
     MOV     HEIGHT_PIX,AX     ;SAVE AS PIXELS
     MOV     AX,IMG_HEADER.IMG_COLOR
;    MOV     COLOR,AX
     MOV     AX,IMG_HEADER.IMG_PIX_SIZE
     MOV     PEL_SIZE,AX
II100:
     CLC
     RET

;
;     IMAGE OUT
;
     PUBLIC  IMG_OUT
IMG_OUT:
     call    reset_segs
     call    calc_file_size
     MOV     AX,WIDTH_BYTES
     MOV     IMG_HEADERo.IMG_WIDTH_BYTE,AX
     MOV     AX,WIDTH_PIX
     MOV     IMG_HEADERo.IMG_WIDTH,AX
     MOV     AX,HEIGHT_PIX
     MOV     IMG_HEADERo.IMG_HEIGHT,AX
;    MOV     AX,COLOR
     MOV     IMG_HEADERo.IMG_COLOR,AX
; write file routine
     mov    cx,img_headero
     lea    dx,img_headero+2
     call   write_file
     RET

;
;     IMAGE READ
;
     PUBLIC  IMG_READ
     PUBLIC  PIG_READ
     PUBLIC  RAS_READ
     PUBLIC  RAW_READ
     PUBLIC  NWS_READ
NWS_READ:
IMG_READ:
RAS_READ:
PIG_READ:
RAW_READ:
     stc
     RET




;
;     IMAGE WRITE
;
     PUBLIC  IMG_WRITE
IMG_WRITE:

     call    reset_segs
     mov    vint,0
     CALL    WRITE_RAW
     RET

;
;     PIG   IN
;
     PUBLIC  PIG_IN
PIG_IN:
     call    reset_segs
     lea     ax,move_raw
     mov     cs:decomp,ax

     TEST   PIG_HEADER.PIG_MODE2,1
     JNZ     PI050
     MOV     PEL_SIZE,4
     OR     FLAGS,GRAYSHADE
PI050:
     MOV     SI,OFFSET PIG_HEADER.PIG_WIDTH
     MOV     AX,4     ;CONVERT 4 ASCII CHARACTERS
     CALL    ASC2BIN     ;
     MOV     WIDTH_BYTES,AX     ;SAVE AS BYTES

     SHL     AX,1     ;CONVERT TO PIXELS
     TEST    FLAGS,GRAYSHADE     ;
     JNZ     PI100     ;IF GRAYSCALE DIVIDE BY 4
     SHL     AX,1     ;2
     SHL     AX,1     ;4
PI100:
     MOV     WIDTH_PIX,AX     ;SAVE AS PIXELS

     MOV     SI,OFFSET PIG_HEADER.PIG_HEIGHT
     MOV     AX,5     ;CONVERT 5 ASCII CHARACTERS
     CALL    ASC2BIN
     MOV     HEIGHT_PIX,AX     ;SAVE AS PIXELS
PI900:
     CLC
     RET


;
;     PIG   OUT
;
;
;     SI = HEADER STRUCTURE
;
     PUBLIC  PIG_OUT
PIG_OUT:

     PUSH    AX
     PUSH    BX
     PUSH    DI
     call    reset_segs
     call    calc_file_size

     MOV     DI,OFFSET PIG_HEADERo.PIG_WIDTH
     MOV     BX,4     ;CONVERT 4 ASCII CHARACTERS
     MOV     AX,WIDTH_BYTES
     CALL    BIN2ASC

     MOV     DI,OFFSET PIG_HEADERo.PIG_HEIGHT
     MOV     BX,5     ;CONVERT 5 ASCII CHARACTERS
     MOV     AX,HEIGHT_PIX
     CALL    BIN2ASC

     TEST    FLAGS,GRAYSHADE
     JNZ     PO100
     MOV     PIG_HEADERo.PIG_MODE2,1  ;BINARY MODE
PO100:
     CLC
     POP     DI     ;RESTORE REGISTERS
     POP     BX
     POP     AX
; write file routine
     mov    cx,pig_headero
     lea    dx,pig_headero+2
     call   write_file
     RET

     RET


;
;     PIG WRITE
;
     PUBLIC  PIG_WRITE
PIG_WRITE:

     call    reset_segs
     mov    vint,0
     CALL    WRITE_RAW
     RET

;  ASCII TO BINARY 
;
;     DS:SI = START OF ASCII STRING
;     AX = NUMBER OF CHARACTER IN STRING (1-5)
;
;     AX = RETURNS BINARY NUMBER
;
ASC2BIN:

     PUSH    BX
     PUSH    CX
     PUSH    DX
     PUSH    SI

     SHL     AX,1     ;MAKE INTO WORD OFFSET
     MOV     BX,AX
     PUSH    SI
     MOV     SI,OFFSET DIVISOR
     MOV     CX,[SI+BX]     ;DIVISOR
     POP     SI
     XOR     BX,BX     ;CLEAR BINARY HOLD REGISTER

ASC100:
     LODSB     ;GET ASCII NUMBER
     AND     AL,0FH     ;STRIP ASCII PART
     XOR     AH,AH
     MUL     CX
     ADD     BX,AX
     CMP     CX,1     ;DONE?
     JE     ASC300
     MOV     AX,CX     ;GET DIVISOR
     XOR     DX,DX
     DIV     TEN     ;DIVIDE IT BY TEN
     MOV     CX,AX     ;PUT BACK IN DX
     JMP     SHORT ASC100
ASC300:
     MOV     AX,BX     ;PUT BINARY NUMBER IN AX
     POP     SI     ;RESTORE REGISTERS
     POP     DX
     POP     CX
     POP     BX
     RET

;  BINARY TO ASCII 
;
;     AX = BINARY NUMBER
;     BX = NUMBER OF ASCII CHARACTERS TO FILL  (1-5)
;     ES:DI = WHERE TO PUT ASCII STRING
;
BIN2ASC:

     PUSH    AX
     PUSH    BX
     PUSH    CX
     PUSH    DX
     PUSH    DI
     PUSH    SI
     PUSH    ES

     SHL     BX,1     ;MAKE INTO WORD OFFSET
     MOV     SI,OFFSET DIVISOR
     MOV     CX,[SI+BX]     ;DIVISOR

BIN100:
     XOR     DX,DX     ;CLEAR DX FOR DIVIDE
     DIV     CX
     ADD     AL,'0'
     STOSB
     CMP     CX,1
     JE     BIN300
     PUSH    DX     ;SAVE REMAINDER
     MOV     AX,CX     ;GET DIVISOR
     XOR     DX,DX
     DIV     TEN     ;DIVIDE IT BY TEN
     MOV     CX,AX     ;PUT BACK IN DX
     POP     AX     ;GET REMAINDER IN AX
     JMP     SHORT BIN100
BIN300:
     POP     ES
     POP     SI
     POP     DI
     POP     DX
     POP     CX
     POP     BX
     POP     AX
     RET

;  PROGRAM = DEG.ASM 
;
;     DEG   IN
;
     PUBLIC  DEG_IN
DEG_IN:
     call    reset_segs

     MOV     WIDTH_PIX,640
     MOV     WIDTH_BYTES,80     ;SAVE AS BYTES
     MOV     HEIGHT_PIX,200     ;SAVE AS PIXELS
     mov     ax,DEG_HEADER.DEG_MODE
     xchg    al,ah
     cmp     al,1
     jg     bad_deg
     cmp     al,0
     jl     bad_deg
; have to read in the full buffer
     mov     dx,0
     mov     ax,buffer
     push    ds
     mov     ds,ax
     mov     cx,16000
     call    read_file
     pop     ds
     jc     bad_deg
     cmp     ax,16000
;     jne     bad_deg
     CLC
     RET
bad_deg:
     stc
     RET


;
;     DEG READ
;
     PUBLIC  DEG_READ
DEG_READ:

     call    reset_segs
     mov     di,0
     mov     si,0
; there are two modes, write one and do the other as a dupe
     mov     ax,DEG_HEADER.DEG_MODE
     xchg    al,ah
     cmp     ax,0
     je     deg_mode0
     jmp     deg_mode1
deg_mode0:
; this is the low resolution mode which is 4 words long or 8 bytes
     mov     cx,16000/8
     mov     ax,buffer
     mov     ds,ax
     mov     es,ax
deg0_loop:
     push    cx
     lodsw
     xchg    al,ah
     mov     bx,ax
     lodsw
     xchg    al,ah
     mov     dx,ax
     lodsw
     xchg    al,ah
     mov     bp,ax
     lodsw
     xchg    al,ah
     mov     cx,ax
; regs are lined up    bx,dx,bp,cx
deg0_loop2:
     rcl     cx,1
     rcl     ax,1
     rcl     bp,1
     rcl     ax,1
     rcl     dx,1
     rcl     ax,1
     rcl     bx,1
     rcl     ax,1
; 4  bits in  ax
     rcl     cx,1
     rcl     ax,1
     rcl     bp,1
     rcl     ax,1
     rcl     dx,1
     rcl     ax,1
     rcl     bx,1
     rcl     ax,1
; 8  bits in  ax
     stosb
     test    di,7
     jnz     deg0_loop2
     pop     cx
     loop    deg0_loop
     jmp     deg_exit
deg_mode1:
; this is the med resolution mode which is 2 words long or 4 bytes
     mov     cx,16000/4
     mov     ax,buffer
     mov     ds,ax
     mov     es,ax
deg1_loop:
     lodsw
     xchg    al,ah
     mov     bx,ax
     lodsw
     xchg    al,ah
     mov     dx,ax
; regs are lined up    bx,dx
deg1_loop2:
     rcl     dx,1
     rcl     ax,1
     rcl     bx,1
     rcl     ax,1
; 2  bits in  ax
     rcl     dx,1
     rcl     ax,1
     rcl     bx,1
     rcl     ax,1
; 4  bits in  ax
     rcl     dx,1
     rcl     ax,1
     rcl     bx,1
     rcl     ax,1
; 6  bits in  ax
     rcl     dx,1
     rcl     ax,1
     rcl     bx,1
     rcl     ax,1
; 8  bits in  ax
     stosb
     test    di,3
     jnz     deg1_loop2
     loop    deg1_loop
deg_exit:
     mov     cx,16000
     mov     dx,0
     mov     si,0
     mov     di,0
     call    flush_buffer
     call    reset_segs
     stc
     RET


 ; this is read for Doodle files
;     doo   IN
doo_IN:
     PUBLIC  doo_IN

doo_READ:
     PUBLIC  doo_READ


;     RAS   IN
     PUBLIC  RAS_IN
RAS_IN:
     call    reset_segs

     lea     ax,move_raw
     mov     cs:decomp,ax
     MOV     WIDTH_PIX,640     ;SAVE AS PIXELS
     MOV     WIDTH_BYTES,80     ;SAVE AS BYTES
     MOV     HEIGHT_PIX,184     ;SAVE AS PIXELS
     CLC
     RET


;
     PUBLIC  RAS_OUT
RAS_OUT:
     call    reset_segs
     call    calc_file_size

     MOV     WIDTH_PIX,640     ;SAVE AS PIXELS
     MOV     WIDTH_BYTES,80     ;SAVE AS BYTES
     MOV     HEIGHT_PIX,184     ;SAVE AS PIXELS
     CLC
     RET


     PUBLIC  RAS_WRITE
RAS_WRITE:

     call    reset_segs
     mov    vint,0
     CALL    WRITE_RAW
     RET

;
;
;
;
;
     PUBLIC  RAW_IN
RAW_IN:
     lea     ax,move_raw
     mov     cs:decomp,ax
     call    reset_segs
     MOV     AX,RAW_HEADER.RAW_WIDTH
     MOV     WIDTH_PIX,AX     ;SAVE AS BYTES
     add     ax,7
     SHR     AX,1
     SHR     AX,1
     SHR     AX,1
     MOV     WIDTH_bytes,ax     ;SAVE AS PIXELS
     MOV     AX,RAW_HEADER.RAW_HEIGHT
     MOV     HEIGHT_PIX,AX     ;SAVE AS PIXELS
     CLC
     RET

;
;     RAW   OUT
;
     PUBLIC  RAW_OUT
RAW_OUT:
     call    reset_segs
     call    calc_file_size

     MOV     AX,WIDTH_BYTES
     shl     ax,1
     shl     ax,1
     shl     ax,1
     MOV     RAW_HEADERo.RAW_WIDTH,AX
     MOV     AX,HEIGHT_PIX
     MOV     RAW_HEADERo.RAW_HEIGHT,AX
; write file routine
     mov    cx,raw_headero
     lea    dx,raw_headero+2
     call   write_file
     RET

;


;     RAW   WRITE
     PUBLIC  RAW_WRITE
RAW_WRITE:

     call    reset_segs
     mov    vint,0
     CALL    WRITE_RAW
     RET


;
PCT_IN:
     PUBLIC  PCT_IN
     call    reset_segs
     MOV     AX,PCT_HEADER.PCT_WID
     MOV     WIDTH_PIX,AX     ;SAVE AS BYTES
     add     ax,7
     SHR     AX,1
     SHR     AX,1
     SHR     AX,1
     MOV     WIDTH_bytes,ax     ;SAVE AS PIXELS
     MOV     AX,PCT_HEADER.PCT_LEN
     MOV     HEIGHT_PIX,ax     ;SAVE AS PIXELS
     CLC
     RET
;
;
;
ART_IN:
     PUBLIC  ART_IN
     call    reset_segs
     MOV     AX,ART_HEADER.ART_WIDTH
     sub     AX,ART_HEADER.ART_X
     MOV     WIDTH_PIX,AX     ;SAVE AS BYTES
     add     ax,15
     SHR     AX,1
     SHR     AX,1
     SHR     AX,1
     SHR     AX,1
     SHL     AX,1
     MOV     WIDTH_bytes,ax     ;SAVE AS PIXELS
     MOV     AX,ART_HEADER.ART_HEIGHT
     SUB     AX,ART_HEADER.ART_Y
     MOV     HEIGHT_PIX,AX     ;SAVE AS PIXELS
     CLC
     RET

;
;     RAW   OUT
;
     PUBLIC  ART_OUT
ART_OUT:
     call    reset_segs
     call    calc_file_size

     MOV     AX,WIDTH_BYTES
     inc     ax     ; make it even word boundary
     shr     ax,1
     shl     ax,1
     mov     width_bytes,ax
     shl     ax,1
     shl     ax,1
     shl     ax,1
     MOV     ART_HEADERo.ART_WIDTH,AX
     MOV     AX,HEIGHT_PIX
     MOV     ART_HEADERo.ART_HEIGHT,AX
; write file routine
     mov    cx,art_headero
     lea    dx,art_headero+2
     call   write_file
     RET
;
;     RAW   OUT
;
     PUBLIC  PCT_OUT
PCT_OUT:
     call    reset_segs
     call    calc_file_size

;    MOV     AX,WIDTH_BYTES
;    inc     ax
;    shr     ax,1
;    shl     ax,1
     mov     width_bytes,80
     shl     ax,1
     shl     ax,1
     shl     ax,1
     MOV     PCT_HEADERo.PCT_WID,AX
     MOV     AX,HEIGHT_PIX
     MOV     PCT_HEADERo.PCT_LEN,AX
; write file routine
     mov    cx,PCT_headero
     lea    dx,PCT_headero+2
     call   write_file
     RET

;
;     RAW   READ
;
ART_READ:
     PUBLIC  ART_READ
PCT_READ:
     PUBLIC  PCT_READ
     call    reset_segs
     mov    vint,0
     CALL    READ_RAW
     RET
;
;     RAW   READ




;
;     RAW   WRITE
;
ART_WRITE:
PCT_WRITE:
     PUBLIC  ART_WRITE
     PUBLIC  PCT_WRITE

     call    reset_segs
     mov    vint,0
     CALL    WRITE_RAW
     RET


     PUBLIC  NWS_IN
NWS_IN:
     call    reset_segs
     cmp     NWS_header.NWS_t,'T'
     je     NWS_HEAD_OK
     stc
     ret
NWS_HEAD_OK:
     MOV     AX,NWS_HEADER.NWS_right
     sub     AX,NWS_HEADER.NWS_left
     add     ax,8
     SHR     AX,1
     SHR     AX,1
     SHR     AX,1
     MOV     WIDTH_bytes,ax     ;SAVE AS bytes
     MOV     AX,NWS_HEADER.NWS_bot
     sub     AX,NWS_HEADER.NWS_top
     inc     ax
     MOV     HEIGHT_PIX,ax      ;SAVE AS PIXELS
     lea     ax,move_raw
     mov     cs:decomp,ax
     CLC
     RET

;
;




CSEG     ENDS
     END
