; OKFILE13.ASM has the write routines for draw stuff
;
include e:\ok\okfiles.asm
;
dseg segment public 'DATA'
     ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
extrn   vint:word,vphase:word,buffer:word
     ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
     EXTRN   GDW_HEADERo:WORD
     EXTRN   CGM_HEADERo:WORD
     EXTRN   WIDTH_PIX:WORD
     EXTRN   HEIGHT_PIX:WORD
     EXTRN   WIDTH_BYTES:WORD
     extrn   hash_segment:word
     extrn   sld_headero:word
     extrn   dxf_headero:word
     extrn   dxb_headero:word
last_ff  dw 0ffffh
gem_poly   dw 6,2,0,0
gem_x1     dw 0
gem_y1     dw 0
gem_x2     dw 0
gem_y2     dw 0
;
; these vectors used by sld and dxb
dxb_vec db 1
vector  equ this byte
fromx  dw 0
fromy  dw 0
tox    dw 0
toy    dw 0
dxb_nul dw 0
;
;
; length is 20
dxf_end db '0',13,10,'ENDSEC',13,10,'0',13,10,'EOF',13,10,26
;
; this is a draw line for dxf
dxf_oline db '0',13,10,'LINE',13,10,'8',13,10,'0',13,10,'10',13,10  ;19
dxf_fromx db '   0',13,10,'20',13,10  ;10
dxf_fromy db '   0',13,10,'11',13,10  ;10
dxf_tox   db '   0',13,10,'21',13,10  ;10
dxf_toy   db '   0',13,10              ;6     19+10+10+10+6=55
;
;
dseg  ends
buffersize  equ 4000h
;
CSEG     SEGMENT PUBLIC 'CODE'
     ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
EXTRN   reset_segs:near,write_file:near
EXTRN   calc_file_size:near
extrn   write_file:near,next_wait:near
extrn   fill_buffer:near


drawer  dw  0  ; draw routine to create a string of black dots
drawcol dw  0  ; x coordinate of current write
line_no dw  0  ; current line number
;
hexax:
    push  di
    mov  dx,0
    mov  cx,100
    div  cx
    mov  cl,10
    div  cl
    or  ax,3030h
    stosw
    mov  ax,dx
    div  cl
    or  ax,3030h
    stosw
    pop  di
    push di
    mov  al,20h
    mov  cx,3
ha_1:
    cmp  byte ptr es:[di],'0'
    jne  ha_2
    stosb
    loop ha_1
ha_2:
    pop  di
    ret
;
;
DXF_line:
; enter here to create a DXF file
; line is in cs:line_no, column is in cs:drawcol, length is in bp
;
;
   push  ds
   push  es
   push  di
   call  reset_segs
   mov   ax,height_pix
   sub   ax,cs:line_no
; have the convert the word in ax to 4 bytes
   push  ax
   lea   di,dxf_fromy
   call  hexax
   pop   ax
   lea   di,dxf_toy
   call  hexax
   mov   ax,cs:drawcol
   lea   di,dxf_fromx
   push  ax
   call  hexax
   pop   ax
   add   ax,bp
   dec   ax
   lea   di,dxf_tox
   call  hexax
;
   lea   si,dxf_oline
   mov   cx,55
   mov  es,buffer
   pop  di
rep  movsb
   pop  es
   pop   ds
   ret
;
; DXF OUT
;
     PUBLIC  DXF_OUT
DXF_OUT:
     call    reset_segs
     call    calc_file_size
     mov    cx,dxf_headero
     lea    dx,dxf_headero+2
     call   write_file
     RET
     stc
     RET
;
;
     PUBLIC  DXF_WRITE
DXF_WRITE:
   call  reset_segs
   lea   dx,dxf_line
   mov   cs:drawer,dx
   call  do_lines
   call reset_segs
   lea  dx,dxf_end
   mov  cx,20
   call write_file
   stc
   ret

;
;
;
DXB_line:
; enter here to create a DXB file
; line is in cs:line_no, column is in cs:drawcol, length is in bp
;
;
   push  ds
   push  es
   call  reset_segs
   mov   ax,height_pix
   sub   ax,cs:line_no
   mov   fromy,ax
   mov   toy,ax
   mov   ax,cs:drawcol
   mov   fromx,ax
   add   ax,bp
   dec   ax
   mov   tox,ax
   lea   si,dxb_vec
   mov   cx,9
   mov  es,buffer
rep  movsb
   pop  es
   pop   ds
   ret
;
; DXB OUT
;
     PUBLIC  DXB_OUT
DXB_OUT:
     call    reset_segs
     call    calc_file_size
     mov    cx,dxb_headero
     lea    dx,dxb_headero+2
     call   write_file
     RET
     stc
     RET
;
;
     PUBLIC  DXB_WRITE
DXB_WRITE:
   call  reset_segs
   lea   dx,dxb_line
   mov   cs:drawer,dx
   call  do_lines
   call reset_segs
   lea  dx,dxb_nul
   mov  cx,2
   call write_file
   stc
   ret

;
;
sld_line:
; enter here to create a gem draw file
; line is in cs:line_no, column is in cs:drawcol, length is in bp
;
;
   push  ds
   push  es
   call  reset_segs
   mov   ax,height_pix
   sub   ax,cs:line_no
   mov   fromy,ax
   mov   toy,ax
   mov   ax,cs:drawcol
   mov   fromx,ax
   add   ax,bp
   dec   ax
   mov   tox,ax
   lea   si,vector
   mov   cx,8
   mov  es,buffer
rep  movsb
   pop  es
   pop   ds
   ret
;
; SLIDE OUT
;
     PUBLIC  SLD_OUT
SLD_OUT:
     call    reset_segs
     call    calc_file_size
     MOV     ax,WIDTH_BYTES
     shl   ax,1
     shl   ax,1
     shl   ax,1
     mov     sld_headero.sld_wid,ax
     MOV     ax,HEIGHT_PIX
     mov     sld_headero.sld_len,ax
; write file routine
     mov    cx,sld_headero
     lea    dx,sld_headero+2
     call   write_file
     RET
;
;
;     IMAGE WRITE
;
     PUBLIC  SLD_WRITE
SLD_WRITE:
   call  reset_segs
   lea   dx,sld_line
   mov   cs:drawer,dx
   call  do_lines
   call reset_segs
   stc
   ret
;
;
;
;
;     GEM DRAW HEADER WRITE
     PUBLIC  GDW_OUT
GDW_OUT:
     call    reset_segs
     call    calc_file_size
     MOV     ax,WIDTH_BYTES
     shl   ax,1
     shl   ax,1
     shl   ax,1
     mov     gdw_headero.gdw_minx,0
     mov     gdw_headero.gdw_maxx,ax
     MOV     ax,HEIGHT_PIX
     mov     gdw_headero.gdw_miny,0
     mov     gdw_headero.gdw_maxy,ax
; write file routine
     mov    cx,gdw_headero
     lea    dx,gdw_headero+2
     call   write_file
     RET


gdw_write:
public  gdw_write
; write a gem file
   call  reset_segs
   lea   dx,gem_line
   mov   cs:drawer,dx
   call  do_lines
   call reset_segs
   mov  cx,2
   lea  dx,last_ff
   call write_file
   stc
   ret
;
gem_line:
; enter here to create a gem draw file
; line is in cs:line_no, column is in cs:drawcol, length is in bp
;
;
   push  ds
   push  es
   call  reset_segs
   mov   ax,cs:line_no
   mov   bx,cs:drawcol
   mov   gem_x1,bx
   mov   gem_y1,ax
   mov   gem_y2,ax
   add   bx,bp
   dec   bx
   mov   gem_x2,bx
   lea  si,gem_poly
   mov  cx,16
   mov  es,buffer
rep  movsb
   pop  es
   pop  ds
;
   ret
;
;
do_lines:
; this is the generic line drawer for lines
   call reset_segs
   mov   cs:line_no,-1 ; current line number
draw_loop0:
     call  reset_segs
     call  next_wait
     call  reset_segs
     call  fill_buffer       ; cx returns bytes in buffer:0
     call  reset_segs
     cmp   cx,0
     jg    draw1
     stc
     ret
draw1:
; cx has the amount to send out the buff
     mov  ax,cx
     mov  dx,0
     div  width_bytes
     mov  cx,ax  ; number of lines to send
     mov  dx,width_bytes
     mov  ax,buffer
     mov  ds,ax
     mov  es,ax
     mov  di,buffersize
     mov  si,0
     cld
draw_loop1:
; do this once for each line
     inc  cs:line_no
     push cx
     push dx
     push si
     mov  bx,0
;------------------------------------------------------------
; Strategy:
;   dx has the remaining bytes on the line
;   bp has the run length
;   cx has the number of unexamined bits in the current byte
;   bx has the count of the bit we are examining
;
; examine bytes until a non-white dot is found.
; rotate through the non-white byte until dot is found
; rotate again until a white dot is found
; if no white dot,
;   get new bytes until a white dot appears
;   rotate the found byte until the white dot is found
; process dot
; start rotating looking for a black dot again.
;
;------------------------------------------------------------
white_loop:
; do this until the line runs out
     mov  bp,0     ; bp has the length of the string
     mov  cx,8     ; cx has the remaining in the current byte
     lodsb         ; get a byte
     dec   dx      ; everytime we read a byte decrement the line count
; check for a a black dot
white_loop1:
     inc   bx
     shl   al,1
     jnc   got_dot   ; dots are zeors
     loop  white_loop1
     jmp   bot_loop
got_dot:
     dec   bx
     mov   cs:drawcol,bx
     inc   bx
     inc   bp
     cmp   cx,1
     jle   got_dot2
     dec   cx
got_dot1:
; find the white dot
     inc   bx
     shl   al,1
     jc    got_white_dot
     inc   bp
     loop  got_dot1
     mov   cx,1
got_dot2:
; here the current dot does not have a white spot
     cmp   dx,0
     jle   got_white_dot
     lodsb
     dec   dx
     mov   cx,8
     jmp   got_dot1
;
got_white_dot:
; found a white dot, bp has the count of black dots
     dec   cx
;
; have to process the string of guys in bp
;
     push  ax
     push  bx
     push  cx
     push  dx
     push  si
     call  cs:drawer
     pop  si
     pop  dx
     pop  cx
     pop  bx
     pop  ax
     cmp  cx,0
     je   bot_loop
     mov  bp,0  ; zero out length of black run
     jmp  white_loop1
bot_loop:
;here we are after a run, do we need to do more?
     cmp   dx,0
     jle   done_w_line
     jmp   white_loop
done_w_line:
; we have a line in buffer:0
     mov  cx,di
     sub  cx,buffersize
     mov  dx,buffersize
     cmp  cx,0
     jle  not_this_line
     call write_file
     jmp  check_carry
not_this_line:
     clc
check_carry:
     pop  si
     pop  dx
     pop  cx
     jc   bad_draw_write
     add  si,dx
     mov  di,buffersize
     loop draw_loop1x
     jmp  draw_loop1y
; found a white loop
draw_loop1x:
     jmp draw_loop1
draw_loop1y:
     jmp draw_loop0
     ret
bad_draw_write:
     stc
     ret
;

CSEG     ENDS
     END
