; OKFILE8.ASM has the read and write routines for various files
;
;  Included here are:
;    SDL
;
;
include okfiles.asm
;
dseg segment public 'DATA'
     ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
extrn   vint:word,vphase:word,buffer:word
     ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
extrn sld_header:word
     EXTRN   HEIGHT_PIX:WORD
     EXTRN   WIDTH_BYTES:WORD
extrn srow:word,scol:word,sy:word,sx:word,epnt:word,spnt:word,ex:word,ey:word
extrn  planes:word,plane_switch:byte
;
;
;
curr_color db 0
orgx   dw 0
orgy   dw 0
sldx   dw 0
sldy   dw 0
oper   dw 0
vector equ this byte
fromx  dw 0
fromy  dw 0
tox    dw 0
toy    dw 0
ovector equ this byte
fromxb db 0
fromyb db 0
toxb   db 0
toyb   db 0
lastb  db 0
lcolor db 0,0
;
sld_compare db 'AutoCAD Slide',13,10,26,0
;
dseg  ends
buffersize  equ 4000h
;
CSEG     SEGMENT PUBLIC 'CODE'
     ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
extrn  reset_segs_far:far,read_file_far:far,blip_far:far,blop_far:far
extrn  xor_liner_far:far
;
;
SLD_IN:

   call far ptr SLD_IN_FAR
    ret
SLD_READ:
    call far ptr SLD_READ_FAR
    ret
public sld_in,sld_read
CSEG ends
CSEG2    SEGMENT PUBLIC 'TEXT'
     ASSUME  CS:CSEG2,DS:DSEG,ES:DSEG
;
;
;     SLD IN
;
SLD_IN_FAR PROC    FAR
     call far ptr    reset_segs_far
     lea    si,sld_header.sld_sig
     lea    di,sld_compare
     mov    cx,17
     cld
repe cmpsb
     je  got_sld_head
bad_sld_head:
     stc
     ret
got_sld_head:
     mov     ax,SLD_HEADER.SLD_WID
     SHr     AX,1
     SHr     AX,1
     SHr     AX,1
     MOV     WIDTH_BYTES,AX     ;SAVE AS BYTES
     mov     ax,SLD_HEADER.SLD_len
     MOV     HEIGHT_PIX,AX     ;SAVE AS PIXELS
     cmp     sld_header.sld_level,1
     jne     got_sld
     lea     dx,sld_header.sld_fill
     mov     cx,3
     call far ptr    read_file_far
     ret
got_sld:
     CLC
     RET
SLD_IN_FAR ENDP
;
;     IMAGE READ
;
SLD_READ_FAR    PROC    FAR
     call far ptr    reset_segs_far
;

; for now, we will assume x = 1024
; y = 768
; this will map us onto a double wide and high screen which
; can easily be shrunk
          mov   sldx,0
          mov   sldy,0     ; current pointer position
toploop:
          lea   dx,oper
          mov   cx,2
          call far ptr  read_file_far  ; get an operand
          jc    exit_sld
          cmp   ax,2
          jne   exit_sld
; have an operand in oper
          mov   ax,oper
          cmp   ah,0
          jge   got_vector
          cmp   ah,0ffh
          je    got_ff
          cmp   ah,0fdh
          je    got_fd
          cmp   ah,0feh
          je    got_fe
          cmp   ah,0fbh
          jne   exit_sld
          jmp   got_fb
exit_sld:
        stc
        ret
got_ff:
        and   al,0fh
        mov   curr_color,al
        call far ptr  blip_far
        call far ptr  blop_far
        jmp   toploop
got_vector:
        mov  word ptr vector,ax
        lea  dx,vector+2
        mov  cx,6
        call far ptr read_file_far
        jc   exit_sld
          cmp   ax,6
          jne   exit_sld
        jmp  draw
got_fd:
        call far ptr  blip_far
        call far ptr  blop_far
; solid fill, ignore
        lea  dx,vector
        mov  cx,4
        call far ptr read_file_far
        jc   exit_sld
          cmp   ax,4
          jne   exit_sld
        jmp   toploop
got_fe:
; common endpoint vector
; there are three bytes in ovector
; byte 1 = x adder, byte 2 = y adder
        mov  ovector,al
        lea  dx,ovector+1
        mov  cx,1
        call far ptr read_file_far
        jc   exit_sld
          cmp   ax,1
          jne   exit_sld
        mov  bx,sldx
        mov  tox,bx
        mov  al,ovector
        cbw
        add  bx,ax
        mov  fromx,bx
        mov  bx,sldy
        mov  toy,bx
        mov  al,ovector+1
        cbw
        add  bx,ax
        mov  fromy,bx
        jmp  draw
;
exit_sldx:
     jmp  exit_sld
got_fb:
; offset vector
; four bytes in ovector
        mov  ovector,al
        lea  dx,ovector+1
        mov  cx,3
        call far ptr read_file_far
        jc   exit_sldx
          cmp   ax,3
          jne   exit_sldx
; offset draw
        mov  bx,sldx
        mov  al,ovector+2
        cbw
        add  bx,ax
        mov  tox,bx
        mov  bx,sldy
        mov  al,ovector+3
        cbw
        add  bx,ax
        mov  toy,bx
        mov  bx,sldx
        mov  al,ovector
        cbw
        add  bx,ax
        mov  fromx,bx
        mov  bx,sldy
        mov  al,ovector+1
        cbw
        add  bx,ax
        mov  fromy,bx
        jmp  draw
draw:
; here we have to draw a line from here to there
;
        call far ptr  draw_line
        jmp   toploop

SLD_READ_FAR    ENDP


;
;
draw_line proc  far
; this draws a line in sldx,sldy from the two points in oper
;
     mov  ax,fromx
     mov  sldx,ax
     mov  dx,ax
     and  dx,7
     mov  spnt,dx
     mov  cx,3
     shr  ax,cl
     add  ax,scol
     mov  sx,ax
     mov  ax,fromy
     mov  sldy,ax
     mov  ax,height_pix
     sub  ax,fromy
     add  ax,srow
     mov  sy,ax
; now the end point
     mov  ax,tox
     mov  dx,ax
     and  dx,7
     mov  epnt,dx
     mov  cx,3
     shr  ax,cl
     add  ax,scol
     mov  ex,ax
     mov  ax,height_pix
     sub  ax,toy
     add  ax,srow
     mov  ey,ax
     call far ptr xor_liner_far
     call far ptr reset_segs_far
     clc
     ret
draw_line endp

CSEG2    ENDS
     END
