print macro string  ; used for printing error messages
     call  reset_segs
     mov   curx,8
     mov   cury,52
     lea   dx,string
     call  prbox
     endm
;
;OKFMAIN.ASM is the main calling place for file reading and writing
;
; OKFMAIN contains the publics used by tree to access files and the
; common procedures and data areas

; this has the structure for use with this area
segmentsize equ 8000h
;
; THESE are the files in OKFILES
;
include okfiles.asm
;
;
;
DSEG segment public 'DATA'
buffersize=4000h
assume  cs:cseg,es:dseg,ds:dseg
extrn strg:byte,pass:word,curx:word,cury:word,file_size:word
extrn  srow:word,scol:word,maxlines:word,vwid:word,lrow:word,lcol:word
extrn buffer:word,width_bytes:word,height_pix:word
extrn debug:byte,work_seg:word,lpoint:word,spoint:word
extrn xor_read:byte,tdir:byte,left_margin:word
extrn info_sw:byte

; local data
;
;
dswitch  db 0 ; if 0 then no dither, if 1 then 4 planes, if 2 then bytes
public dswitch
;
;
;
x_loc     dw  0  ; temporary place for pcc pcx loc of last byte
file_off  dw  0
no_erase  db  0
err7     db  'Bad file spec, press any key to continue',0
err8     db  'Bad file name, press any key to continue',0
err9     db  'Error opening file, Press any key to continue.',10
         db  'Error file = '
err9a     db  36 dup(0)
err10     db  'Error reading file header or unsupported file type',0
WR_SWITCH db  0  ; this is the switch which tells if its read or write
read_prog dw  0
write_prog dw 0
public wr_switch,file_off,read_prog,write_prog
;
info  db 'File information:',10
      db 'Height = '
iheight db '0000 lines',10
      db 'Width = '
iwidth db '0000 pixels'
izero  db 0
      db 'Press any key to continue',0
cwait  dw 0


DSEG ENDS


CSEG segment public 'CODE'
assume  cs:cseg,es:dseg,ds:dseg
; the following table is a jump table for reading and writing
; the various file types
;
; table is 15 bytes long
;
; this is a macro for creating the data labels for various files
;
extrn getkey:near,present:near
extrn reset_segs:near,open_in:near,create_file:near,close_file:near
extrn set_range:near,prbox:near,erase_mem:near
extrn  read_file:near
extrn  do_wait:near,next_wait:near,do_display:near
extrn  get_curr_seg:near,get_next_seg:near,list_files:near
public flush_buffer

;
; the following is used for the common decompress routines
decomp  dw 0
public decomp
;
xor_byte  db 0
;
;
check_wait:
; this routine keeps tabs on bytes written and checks the keyboard
     push  ds
     push  es
     call  reset_segs
     push  ax
     push  cx
     push  si
     push  di
     push  bp
;
    mov  ax,work_seg
    push ax
    mov  ah,1
    int   16h
    jz    no_keyw
    mov   ah,0
    int   16h
    cmp   al,27
    je    bad_keyw
    cmp   ah,2eh
    jne   no_keyw
    call  present
    call  next_wait
    pop   ax
    mov   work_seg,ax
    call  get_curr_seg
    push   ax
no_keyw:
    pop   ax
    pop   bp
    pop   di
    pop   si
    pop   cx
    pop   ax
    add   cwait,cx
    cmp   cwait,1280
    jl    no_wait
    call  next_wait
    mov   cwait,0
no_wait:
    pop   es
    pop   ds
    clc
    ret
bad_keyw:
    pop   ax
    pop   bp
    pop   di
    pop   si
    pop   cx
    pop   ax
    pop   es
    pop   ds
    stc
    ret

;
;
;
; the fdecomp procedure is used to decompress a file using a common
; routine for I/O and looping
; the fdecomp routine sets up SI and DI and BP. The called routine
; cannot mess with these guys. SI must always point to the next byte
; BP must always have the buffer size and DI must be the target
fdecomp:
public fdecomp
; set up for loop

     call    reset_segs
;
;
     mov  di,6000h
     mov  si,6000h
     mov  bp,6000h
     call get_buffer ; gets a buffer from strip
     jnc   ps1
ps0:
     stc
     ret
ps1:
     cmp   ax,0
     je    ps0
     mov  si,6000h
     mov  di,0
; set up the loop, we will do a line at a time through the loop
; si points ot location in buffer
     mov   cx,height_pix   ; height of picture
strip_loop:
     push   cx
; strip is decompressed here
     mov    dswitch,0
     mov    bx,width_bytes  ; some schemes require bx has width
     mov    cx,width_bytes  ; some cx
     call   cs:[decomp]  ; one of the decompression schemes
     jnc   good_strip
leave_fdecomp:
; done, but are there any lines left
     cmp    di,0
     jle    all_done_loopa
     mov   cx,di
     call  flush_buffer
all_done_loopa:
     pop   cx
     stc
     ret
good_strip:
     cmp   di,0   ; is it time to flush
     jle   all_done_loopa
     mov   cx,di
     push  si
     push  bp
     call  flush_buffer
     pop   bp
     pop   si
     jc    all_done_loopa
     mov  di,0
by_dflush:
; have to check the si to see if he's ok
     call   move_down  ; moves down if needed and refiles buffer
     jnc    bdc_loop
     pop    cx
     jmp   end_dc
bdc_loop:
     pop    cx
     loop   strip_loop
end_dc:
     cmp    di,0
     jge    all_done_loop
     mov   cx,di
     call  flush_buffer
all_done_loop:
     stc
     ret
;
move_raw:
public move_raw
; this is the raw move
   call   set_segs
   cld
rep  movsb
   call   reset_segs
   clc
   ret
;
;
move_down:
     push  di
; this moves down the tif, resets si and sees if filling is needed
     cmp   si,bp
     jge   bad_moved
     cmp   si,6c00h
     jl    no_moved
     cmp   bp,6c00h
     jl    no_moved
     mov   cx,bp
     sub   cx,si
     cmp   cx,0
     jg    do_moved
no_moved:
     pop   di
     clc
     ret
bad_moved:
     pop   di
     stc
     ret
do_moved:
     cld
     mov   di,6000h
     call  set_segs
rep  movsb
     call  reset_segs
     mov   si,6000h
     mov   bp,di
     cmp   di,7000h ; time to fill?
     jg    no_get_buffer
     call  get_buffer
;    cmp   info_sw,0
;    jne   no_get_buffer
;    call  next_wait
no_get_buffer:
     pop   di
     clc
     ret
get_buffer:
; reads a strip into the buffer
; di is here it goes
     mov   cx,7fffh    ; max 8k read
     sub   cx,di     ; fill to brim
     mov   ax,buffer
     push  ds
     mov   ds,ax
     mov   dx,di     ; di has the location
     push   si
     push   di
     push   bp
     call  read_file
     pop   bp
     pop   di
     pop   si
     pop   ds
exit_buffer:
     cmp   ax,0
     jne   ok_buffer
     cmp   bp,si
     jg    ok_buffer
     cmp   di,6000h
     jg    ok_buffer
     clc
     ret
ok_buffer:
     mov   bp,di
     add   bp,ax
     clc
     ret
;
;
;
set_segs:
     push  ax
     mov   ax,buffer
     mov   ds,ax
     mov   es,ax
     pop   ax
     ret
;



extrn file_type:byte
public merge_file,get_file
merge_file:
; merge stuff
     call  reset_segs
     mov   no_erase,1
     call  set_range
     jc    mf_nok
     cmp   al,27
     je    mf_nok
     cmp   ah,27
     je    mf_nok
     jmp   got_in_range
mf_nok:
     mov   al,27
     mov   ah,27
     stc
     ret

get_file:
; get file information
     mov  no_erase,0
     jmp  by_fonts
get_fonts:
public get_fonts
     mov   no_erase,1
by_fonts:
     mov  srow,0
     mov  scol,0
     mov  ax,maxlines
     dec  ax
     mov  lrow,ax
     mov  ax,vwid
     dec  ax
     mov  lcol,ax
;
got_in_range:
     mov   x_loc,0
     cmp   info_sw,0
     jne   get_in_range2
     call  present
get_in_range2:
; from here on in both get and merge are the same
     mov  tdir,'*'
     mov  tdir+1,'.'
     lea  di,tdir+2
     mov  bx,file_off
     push  ds
     mov   ax,cs
     mov   ds,ax
     lea  si,cs:file_type
     add  si,bx
     mov  cx,3
     cld
rep   movsb
     mov   al,0
     stosb
     pop  ds
     dec  di
     dec  di
     mov   x_loc,0
     cmp   wr_switch,1
     je   get_in_range
     cmp  byte ptr es:[di],'X'
     jne  get_in_range
     mov   x_loc,di
     mov  byte ptr es:[di],'?'
get_in_range:
     mov  bx,0
     mov  ax,0
     call list_files
     jc   bad_spec
     cmp  ah,27
     je   get_in_exit
     cmp  al,27
     jne  got_comm_name
get_in_exit:
     ret
bad_spec:
     print err7
     call  getkey
     call  present
     jmp   got_in_range
bad_file:
     print err8
     call  getkey
     call  present
     jmp   get_in_range2
bad_open:
     lea  di,err9a
     mov  cx,34
     lea  si,strg
rep    movsb
     print err9
     call getkey
     jmp  get_in_range2
got_comm_name:
     cmp   strg,0
     je    bad_file
; check to see if there is a period in file name
     mov   cx,40
     lea   di,strg
     mov   al,'.'
repne  scasb
     jne   no_ext
     mov   x_loc,0
     jmp   found_ext
no_ext:
; there is no extension
     mov   cx,40
     lea   di,strg
     mov   al,0
repne  scasb
     dec   di
; we are pointing to first character after name
     mov   al,'.'
     stosb
     mov  bx,file_off
     push  ds
     mov   ax,cs
     mov   ds,ax
     lea  si,cs:file_type
     add  si,bx
     mov  cx,3
     cld
rep   movsb
     mov   al,0
     stosb
     pop  ds
     cmp  x_loc,0
     je   found_ext
; have to fix the pcc loc here
     dec  di
     dec  di
     mov  x_loc,di
found_ext:
; have to open the file here
     cmp   wr_switch,0
     je    open_it_in
     cmp   info_sw,1
     je    open_it_in
     clc
     call  create_file
     jnc   got_comm_file
     jmp   bad_open
open_it_in:
     clc
     call  open_in
     jnc   got_comm_file
     cmp   x_loc,0
     jne   try_pcc
     cmp   info_sw,1
     jne   try_pcc
     jmp   bad_open
try_pcc:
     mov   di,x_loc
; scan for the .
     mov   byte ptr es:[di],'C'
     mov   x_loc,0
     jmp   open_it_in
got_comm_file:
     mov   x_loc,0
     cmp   info_sw,0
     jne   no_wait1
     call  do_wait
no_wait1:
     mov   pass,0
     cmp   no_erase,1
     je    by_no_erase
     cmp   info_sw,1
     je    by_no_erase
     call erase_mem
by_no_erase:
     cmp   wr_switch,0
     jne  put_file
     call  decompress
     call  close_file
     call  present
     jmp   do_display
put_file:
     call  compress
     pushf
     push  dx
     call  close_file
     call  present
     pop   dx
     popf
     ret

;
pass_line  dw  pass_0,pass_1,pass_2,pass_3,pass_x,pass_x,pass_x
;
; DATA areas for CS: overrides in flush buffer
;
buffcount dw  0   ; amount in buffer
fill_wid  dw  0   ; width of window to fill
run_wid   dw  0   ; amount to run off of buffer
fill_len  dw  0   ; count of lines to fill
curr_di   dw  0   ; current location on screen
curr_line dw  0   ; line we are working on
curr_cx   dw  0   ; current count of bytes in cx
 public  fill_wid,run_wid,fill_len,curr_di,curr_cx,curr_line
;
;
;
;
;
fill_buffer:
 public fill_buffer
; this routine takes a buffer full of picture and puts in into
; the buffer. This program has to remember where is is in the
; picture at all times. It returns the bytes in the buffer in
; cx and ax. The buffer starts at 0:
     call  reset_segs
     mov    ax,cs:curr_line
     cmp    cs:fill_len,ax
     jg     fill_pass_0
     mov   cx,0
     mov   ax,0
     stc
     ret
fill_pass_0:
     call  setup_pass
     push   es
     push   ds
     call  reset_segs
     mov   pass,0
; setup_pass was created for flush
     pop   es  ;pop in wrong order to switch
     pop   ds
     xchg  si,di
; always assume there is enough room to pass the current line
fb_1:
     mov   cx,cs:fill_wid
     cld
rep     movsb
     mov   cx,cs:run_wid
     cmp   cx,0
     jle   no_run
     mov   al,0
     cld
rep     stosb
no_run:
; check to see if we can do another run
     cmp   di,buffersize-512
     jl    cc_next_line
; set up to return
     jmp   cc_exit_line
cc_next_line:
; now we have finished a line we must go onto next line
     inc    cs:curr_line
     mov    ax,cs:curr_line
     cmp    cs:fill_len,ax
     jg     cc_not_done
     jmp    cc_done
cc_not_done:
     add    cs:curr_di,dx ; vwid has been sitting in dx
     cmp    cs:curr_di,0
     jge    ok_curr_si1
     sub    cs:curr_di,segmentsize
     push   ax
     call   get_next_seg
     mov    ds,ax
     pop    ax
ok_curr_si1:
     mov   si,cs:curr_di  ; current location of place in picture
     jmp     fb_1
cc_exit_line:
; here we have finished a line and have to go back
     inc    cs:curr_line
     mov    ax,cs:curr_line
     cmp    cs:fill_len,ax
     jg     by_done_fill
     jmp    cc_done_fill
by_done_fill:
     add    cs:curr_di,dx ; vwid has been sitting in dx
     cmp    cs:curr_di,0
     jge    ok_curr_si
     sub    cs:curr_di,segmentsize
     call   get_next_seg
ok_curr_si:
     mov    cx,di
     mov    ax,di
     call  check_wait
     ret
cc_done_fill:
     mov    pass,1
cc_done:
     cmp   di,0
     jne   ok_curr_si
     mov   cx,0
     mov   ax,0
     stc
     ret

;
flush_buffer:
; 
; FLUSH_BUFFER is called by each routine to get the buffer into
; the segments. This routine is called and the box to fill is
; defined by SROW,SCOL,LROW,SCOL which must be in the range
; of the virtual page. The picture will merge into this range
; If the range is too large, bytes outside will be truncated.
; if the range is too small bytes will left alone.
; AT ENTRY,
;  CX has the count of bytes in BUFFER which can be transfered.
;  The in routine of the program must have set WIDTH_BYTES and
;  HEIGHT_PIX, all other items from the file are not needed here
;
; entry here:
     call  reset_segs
     call  check_wait
     jnc   f1
     mov   pass,5
     mov   cx,0
     mov   ax,0
     stc
     ret
f1:
     mov   cs:xor_byte,0
     cmp   xor_read,1
     jne   normal_flush
     mov   cs:xor_byte,0ffh
;  extrn flush_bufferx:near
;     jmp   flush_bufferx
normal_flush:
     mov   cs:buffcount,cx
     mov   bx,pass
     shl   bx,1
     jmp   cs:pass_line[bx]
pass_x:
; unknown pass
     mov   pass,5
     mov   cx,0
     mov   ax,0
     stc
     ret
pass_0:
     call  cc_setup
; we are all set to go
;
;
pass_1:
; setup_pass sets the es and ds registers
; dx has the vwid in it
; si and di have the buffer and vid buff locs
     call  setup_pass
pass_1a:
     mov   cx,cs:fill_wid
; check to see if we can do the fill
     cmp   cs:buffcount,cx
     jge   move_fill   ; yes we can
; this is where an unfulfilled fill is thought about
     cmp   cs:buffcount,0  ; here we may not have anything to move
     jg    ok_bc
; get some more buffer
     call  reset_segs
     mov   pass,1
     clc
     ret
ok_bc:
     mov   cx,cs:buffcount  ; do what we can
     mov   cs:curr_cx,cx
     mov   cs:buffcount,0
     cld
     cmp   cs:xor_byte,0
     jne   bc1
rep  movsb
     jmp   bc1a
bc1:
     lodsb
     xor es:[di],al
     inc  di
     loop  bc1
bc1a:
     call  reset_segs
     mov   pass,2
     clc
     ret
;
move_fill:
     sub   cs:buffcount,cx
     cld
     cmp   cs:xor_byte,0
     jne   bc2
rep  movsb
     jmp   bc2a
bc2:
     lodsb
     xor es:[di],al
     inc  di
     loop  bc2
bc2a:
; check now to see if there is any need to run out fill
; here is where we are messing up the run wid on a buffer boundary
     cmp   cs:run_wid,0
     je    no_fill
     mov   cx,cs:run_wid
     cmp   cs:buffcount,cx
     jle   get_on_fill     ; changed to jle
; here run out the fill
     sub   cs:buffcount,cx
     add   si,cx
; check that we have not drained the buffer
     jmp   no_fill
get_on_fill:
;
;  not enough in buffer to run out the run
; do what we can
; run_wid-buff_count will give the amount we have tp start with later
     mov   cx,cs:run_wid
     sub   cx,cs:buffcount
     mov   cs:curr_cx,cx   ; cx is how much left to run
     call  reset_segs
; have to get on pass 3
     mov   pass,3
     clc
     ret
;
no_fill:
; now we have finished a line we must go onto next line
     inc    cs:curr_line
     mov    ax,cs:curr_line
     cmp    cs:fill_len,ax
     jg     not_done_fill
     jmp    done_fill
not_done_fill:
     add    cs:curr_di,dx ; vwid has been sitting in dx
     cmp    cs:curr_di,0
     jge    ok_curr_di1
     sub    cs:curr_di,segmentsize
     push   ax
     call   get_next_seg
     mov   es,ax
     pop   ax
ok_curr_di1:
     mov   di,cs:curr_di  ; current location of place in picture
     jmp     pass_1a

pass_2:
; this is where we come in with the rest of an unfinished fill
     call  setup_pass
; have to finish off the fill we never finished
     add   di,cs:curr_cx
     mov   cx,cs:fill_wid  ; how much we need to do now
     sub   cx,cs:curr_cx   ; how much we finished last time
     jmp   move_fill  ; assume there is enough in the buffer
pass_3:
;
; could not run out entire amount, do it now
     call  setup_pass
; have to finish off the fill we never finished
     mov   cx,cs:curr_cx   ; how much left from last time
     sub   cs:buffcount,cx  ; run it off buffer
     add   si,cx     ; run it off si, too
     jmp   no_fill    ; assume there is enough in the buffer
next_line:
; here we have finished a line and have to get the next line
     inc    cs:curr_line
     mov    ax,cs:curr_line
     cmp    cs:fill_len,ax
     jle    done_fill
     add    cs:curr_di,dx ; vwid has been sitting in dx
     cmp    cs:curr_di,0
     jge    ok_curr_di
     sub    cs:curr_di,segmentsize
     push   ax
     call   get_next_seg
     pop    ax
ok_curr_di:
     jmp    pass_1
done_fill:
     jmp    pass_x
setup_pass:
     call  reset_segs
; need to have a few things in the registers
     mov   pass,1
     mov   dx,vwid
     call  get_curr_seg
     mov   es,ax
     mov   ax,buffer
     mov   ds,ax     ; set up buffer
     mov   si,0     ; head of buffer
     mov   di,cs:curr_di  ; current location of place in picture
;
     ret

;
;
;
cc_setup:
public cc_setup
; this is called by both compress and decompress routines
; it sets up all od the range, dun and fill info for the
; system. Decompress calls it by using pass in flushbuffer
; compress calls it directly
; first time through, initialize a few things
     mov   ax,lcol
     sub   ax,scol
     cmp   ax,0
     jge   no_neg_col
     neg   ax   ; lcol was less than scol
; have to swap lcol and scol here also
     push  ax
     mov   ax,scol
     mov   bx,lcol
     mov   scol,bx
     mov   lcol,ax
     mov   bx,lpoint
     mov   ax,spoint
     mov   lpoint,ax
     mov   spoint,bx
     pop   ax
no_neg_col:
     cmp   lpoint,0
     je    no_0_l
     inc   ax
no_0_l:
; ax has the column of the area we are filling up
 public  fill_wid,run_wid,fill_len,curr_di,curr_cx
     mov   cs:fill_wid,ax
     mov   cs:run_wid,0    ; amount to run off at end
     cmp   width_bytes,ax ; is the width greater than fill area
     jle   ok_w_1
     mov   bx,width_bytes
     sub   bx,ax
     mov   cs:run_wid,bx   ; amount to run off
     jmp   ok_w_2
ok_w_1:
     mov   ax,width_bytes
     mov   cs:fill_wid,ax   ; only move in the width of the picture
ok_w_2:
;
; now the same routine for the length
     mov   ax,lrow
     sub   ax,srow
     jnb   no_neg_row
     neg   ax
; have to swap lcol and scol here also
     push  ax
     mov   ax,srow
     mov   bx,lrow
     mov   srow,bx
     mov   lrow,ax
     pop   ax
no_neg_row:
     mov   cs:fill_len,ax
     cmp   height_pix,ax
     jge   ok_l_1
     mov   ax,height_pix
     mov   cs:fill_len,ax
ok_l_1:
; length and width are set up, now the si and seg have to
; be set up
     mov   dx,0
     mov   ax,srow
     mul   vwid
     mov   cx,segmentsize
     div   cx
     add   dx,scol
; dx has the start si and ax has the start seg
     mov   cs:curr_di,dx
     mov   work_seg,ax
     call  get_curr_seg
;
; now initialize a couple of more things
     mov   cs:curr_line,0
     mov   cs:curr_cx,0
     mov   pass,1
;
;
     ret
;
;

;
;
;
;
compress:
; compress calls the write procedure and lets that do the rest
;
     call    reset_segs
     lea     di,cs:file_type
     add     di,file_off
     cmp     cs:[di.output],0
     jne     ok_out_type
     mov     dx,"KG"
     stc
     ret
ok_out_type:
     MOV     BX,cs:[DI.DISK_out]     ;GET DISK outputPROGRAM
     MOV     write_PROG,BX
     push    ds
     push    es
     cmp     debug,6
     jne     no_debug6
     int   3  ; debug
no_debug6:
     call    cs:[DI.output]
     jc     leave_comp
     call    reset_segs
     cmp     debug,7
     jne     no_debug7
     int   3  ; debug
no_debug7:
     call   cc_setup
     mov     pass,0
     clc
     call    write_prog
leave_comp:
     pop     es
     pop     ds
     ret

;
;
;  DECOMPRESS is the routine which gets the data from the
; the various files. It is decompresses job to call
; the in_file routine and the read_file routine and
; do any housekeeping. DECOMPRESS is a loop that fills
; the buffer from the file routine and empties it in
; the flush buffer routine.
;
; much of this loop was lifted off of picutil stuff
;
decompress:
;
     call    reset_segs
     lea     di,cs:file_type
     add     di,file_off
     MOV     SI,cs:[DI.HEADER]     ;GET LOCATION OF HEADER INFO
     MOV     CX,cs:[di.disk_count]  ;GET NUMBER OF BYTES IN HEADER
     cmp     cx,0
     JE     decomp_eof
     MOV     DX,SI     ;
     ADD     DX,2     ;GET PAST BYTES IN HEADER
     call    read_file     ;READ HEADER
     jnc     decomp_eof
     lea     bX,err10
     jmp     error
decomp_eof:
     clc
     MOV     BX,cs:[DI.DISK_IN]     ;GET DISK INPUT PROGRAM
     MOV     read_PROG,BX
     mov     cs:decomp,0
     push    ds
     push    es
     call    reset_segs
     cmp     debug,4
     jne     no_debug4
     int   3  ; debug
no_debug4:
     clc
     call    cs:[DI.INPUT]
     pop     es
     pop     ds
     JNC     good_header
     lea     bX,err10
     JMP     ERROR
good_header:
;
;     FIND FILE SIZE
;
     MOV     AX,WIDTH_BYTES
     MUL     HEIGHT_PIX
     MOV     FILE_SIZE,AX
     MOV     FILE_SIZE+2,DX
     mov     pass,0
; print file status
;
     mov   ax,width_bytes
     shl   ax,1
     shl   ax,1
     shl   ax,1
     mov   dx,0
     mov   cx,100
     div   cx
     mov   cl,10
     div   cl
     or   ax,3030h
     mov  word ptr iwidth,ax
     mov  ax,dx
     div   cl
     or   ax,3030h
     mov  word ptr iwidth+2,ax
     mov   ax,height_pix
     mov   dx,0
     mov   cx,100
     div   cx
     mov   cl,10
     div   cl
     or   ax,3030h
     mov  word ptr iheight,ax
     mov  ax,dx
     div   cl
     or   ax,3030h
     mov  word ptr iheight+2,ax
     mov   left_margin,80
     mov   curx,80
     mov   cury,16
     lea  dx,info
     mov  izero,0
     cmp  info_sw,0
     je    i_cont
     mov  izero,10
i_cont:
     call prbox
;
;     MOVE PICTURE DATA BETWEEN FILES
;
     cmp   info_sw,1
     jne   dc_cont0
     mov   info_sw,0
     call  getkey
     mov     ah,27
     clc
     ret
dc_cont0:
     call  next_wait
     clc
decomp_top:
; the state must be saved here
     push    ds
     push    es
     call    reset_segs
     cmp     debug,5
     jne     no_debug5
     int   3  ; debug
no_debug5:
     cmp    cs:decomp,0
     je     decomp_old
     call   fdecomp
     pop     es
     pop     ds
     jmp     exit
decomp_old:
     clc
     CALL    ds:[read_PROG]
     pop     es
     pop     ds
; program must return with buffer full and cx set to bytes in buffer
     jc     exit
     cmp     cx,0
     je     exit
; must have a way of showing time passing
     push  cx
     call    next_wait
     clc
     pop   cx
;     the cx register is passed to flush_buffer
     push    ds
     push    es
     call    flush_buffer
     pop     es
     pop     ds
     jc     exit
; check for pass>4
     cmp    pass,4
     Jg     exit
     Jmp    decomp_top
EXIT:
     call reset_segs
     stc
     RET
ERROR:
     print  [bx]
     call    getkey
     mov     ah,27
     ret

;
CSEG  ends
    end
