;
;OKFMAIN.ASM is the main calling place for file reading and writing
;
; OKFMAIN contains the publics used by tree to access files and the
; common procedures and data areas

; this has the structure for use with this area
segmentsize equ 8000h
;
; THESE are the files in OKFILES
;
include c:\ok\okfiles.asm
;
;
;
DSEG segment public 'DATA'
buffersize=4000h
assume  cs:cseg,es:dseg,ds:dseg
extrn pass:word,curx:word,cury:word,file_size:word
extrn  srow:word,scol:word,maxlines:word,vwid:word,lrow:word,lcol:word
extrn buffer:word,width_bytes:word,height_pix:word
extrn debug:byte,work_seg:word,lpoint:word,spoint:word

; local data
x_loc     dw  0  ; temporary place for pcc pcx loc of last byte
file_off  dw  0
no_erase  db  0


DSEG ENDS


CSEG segment public 'CODE'
assume  cs:cseg,es:dseg,ds:dseg
; the following table is a jump table for reading and writing
; the various file types
;
; table is 15 bytes long
;
; this is a macro for creating the data labels for various files
;
extrn getkey:near,present:near,say_enter_file:near
extrn reset_segs:near,open_in:near,create_file:near,close_file:near
extrn set_range:near,print_string:near,erase_mem:near
extrn  quit:near,read_file:near
extrn  do_wait:near,next_wait:near,do_display:near
extrn  get_curr_seg:near,get_next_seg:near
extrn  cc_setup:near

public flush_bufferx

extrn file_type:byte
;
pass_line  dw  pass_0,pass_1,pass_2,pass_3,pass_x,pass_x,pass_x
;
; DATA areas for CS: overrides in flush buffer
;
extrn fill_wid:word,run_wid:word,fill_len:word,curr_di:word,curr_line:word
extrn curr_cx:word
buffcount dw  0   ; amount in buffer
;
;
flush_bufferx proc near
; 
; FLUSH_BUFFER is called by each routine to get the buffer into
; the segments. This routine is called and the box to fill is
; defined by SROW,SCOL,LROW,SCOL which must be in the range
; of the virtual page. The picture will merge into this range
; If the range is too large, bytes outside will be truncated.
; if the range is too small bytes will left alone.
; AT ENTRY,
;  CX has the count of bytes in BUFFER which can be transfered.
;  The in routine of the program must have set WIDTH_BYTES and
;  HEIGHT_PIX, all other items from the file are not needed here
;
; entry here:
       call  reset_segs
       mov   cs:buffcount,cx
       mov   bx,pass
       shl   bx,1
       jmp   cs:pass_line[bx]
pass_x:
; unknown pass
       mov   pass,5
       mov   cx,0
       mov   ax,0
       stc
       ret
pass_0:
       call  cc_setup
; we are all set to go
;
;
pass_1:
; setup_pass sets the es and ds registers
; dx has the vwid in it
; si and di have the buffer and vid buff locs
        call  setup_pass
pass_1a:
        mov   cx,cs:fill_wid
; check to see if we can do the fill
        cmp   cs:buffcount,cx
        jge   move_fill   ; yes we can
; this is where an unfulfilled fill is thought about
        cmp   cs:buffcount,0  ; here we may not have anything to move
        jg    ok_bc
; get some more buffer
        call  reset_segs
        mov   pass,1
        clc
        ret
ok_bc:
        mov   cx,cs:buffcount  ; do what we can
        mov   cs:curr_cx,cx
        mov   cs:buffcount,0
        cld
mloop1:
      lodsb
      xor byte ptr es:[di],al
      inc  di
      loop mloop1
        call  reset_segs
        mov   pass,2
        clc
        ret
;
move_fill:
        sub   cs:buffcount,cx
        cld
mloop2:
      lodsb
      xor byte ptr es:[di],al
      inc  di
      loop mloop2
; check now to see if there is any need to run out fill
; here is where we are messing up the run wid on a buffer boundary
        cmp   cs:run_wid,0
        je    no_fill
        mov   cx,cs:run_wid
        cmp   cs:buffcount,cx
        jle   get_on_fill     ; changed to jle
; here run out the fill
        sub   cs:buffcount,cx
        add   si,cx
; check that we have not drained the buffer
        jmp   no_fill
get_on_fill:
;
;  not enough in buffer to run out the run
; do what we can
; run_wid-buff_count will give the amount we have tp start with later
        mov   cx,cs:run_wid
        sub   cx,cs:buffcount
        mov   cs:curr_cx,cx   ; cx is how much left to run
        call  reset_segs
; have to get on pass 3
        mov   pass,3
        clc
        ret
;
no_fill:
; now we have finished a line we must go onto next line
        inc    cs:curr_line
        mov    ax,cs:curr_line
        cmp    cs:fill_len,ax
        jg     not_done_fill
        jmp    done_fill
not_done_fill:
        add    cs:curr_di,dx ; vwid has been sitting in dx
        cmp    cs:curr_di,0
        jge    ok_curr_di1
        sub    cs:curr_di,segmentsize
        push   ax
        call   get_next_seg
        mov   es,ax
        pop   ax
ok_curr_di1:
        mov   di,cs:curr_di  ; current location of place in picture
       jmp     pass_1a

pass_2:
; this is where we come in with the rest of an unfinished fill
        call  setup_pass
; have to finish off the fill we never finished
        add   di,cs:curr_cx
        mov   cx,cs:fill_wid  ; how much we need to do now
        sub   cx,cs:curr_cx   ; how much we finished last time
        jmp   move_fill  ; assume there is enough in the buffer
pass_3:
;
; could not run out entire amount, do it now
        call  setup_pass
; have to finish off the fill we never finished
        mov   cx,cs:curr_cx   ; how much left from last time
        sub   cs:buffcount,cx  ; run it off buffer
        add   si,cx     ; run it off si, too
        jmp   no_fill    ; assume there is enough in the buffer
next_line:
; here we have finished a line and have to get the next line
        inc    cs:curr_line
        mov    ax,cs:curr_line
        cmp    cs:fill_len,ax
        jle    done_fill
        add    cs:curr_di,dx ; vwid has been sitting in dx
        cmp    cs:curr_di,0
        jge    ok_curr_di
        sub    cs:curr_di,segmentsize
        push   ax
        call   get_next_seg
        pop    ax
ok_curr_di:
        jmp    pass_1
done_fill:
        jmp    pass_x
setup_pass:
        call  reset_segs
; need to have a few things in the registers
        mov   pass,1
        mov   dx,vwid
        call  get_curr_seg
        mov   es,ax
        mov   ax,buffer
        mov   ds,ax       ; set up buffer
        mov   si,0        ; head of buffer
        mov   di,cs:curr_di  ; current location of place in picture
;
        ret
flush_bufferx endp
;
;
;
CSEG  ends
    end
