LSEG segment public 'DATA'
extrn font1:word
LSEG ends
DSEG segment public 'DATA'
extrn left_margin:word,curx:word,cury:word
extrn helps:word  ; source of help
extrn font:word,attribute:byte,lscale:byte
DSEG ends

CSEG  segment public 'CODE'
assume cs:cseg
extrn tprint_string_far:far,getkey_far:far,present_far:far
extrn reset_segs_far:far,highlight_far:far,charget_far:far
CSEG ENDS
;
CSEG2 segment public 'TEXT'
assume cs:cseg2,ds:dseg
;
;
; local data
;
helpline  dw  help1,help2,help3,help4,help5,help6
;
go_line dw  0,ret_key,right_key,left_key,home_key,up_key,end_key
        dw down_key,pgup_key,pgdn_key
;
help proc far
public help
     push  ax
     push  bx
     push  cx
     push  dx
     push  bp
     push  si
     push  di
     push  ds
     push  es
     call  reset_segs_far
; get the current font and save it
        mov   al,lscale
        mov   lscale,1
        push  ax
        mov   al,attribute
        push  ax
        mov   ax,font
        push  ax
        assume  es:lseg
        lea   ax,es:font1
        assume  es:dseg
        mov   font,ax
        mov   attribute,0
    call  charget_far
; print the book
     mov    left_margin,bookx
     mov    curx,bookx
     mov    cury,booky
     assume ds:tseg
     lea    dx,book
     assume ds:dseg
     call   tprint_string_far
     call   tabh
; determine the source
     call   ret_key
get_entry:
     call   getkey_far
     cmp    al,'q'
     je     leave_q
     cmp    al,'Q'
     je     leave_q
     cmp    al,27
     jne    cont_get
     jmp    exit_help
cont_get:
     cmp    helps,4
     jne    cont_get2
     cmp    al,13
     jne    cont_get2
leave_q:
     jmp    exit_help
cont_get2:
     cmp    bx,18
     jle    ok_entry
; put first letter stuff here
     cmp    al,'z'
     jg     get_entry
     cmp    al,'A'
     jl     get_entry
     cmp    al,'Z'
     jle    ok_upper
     cmp    al,'a'
     jl     get_entry
     sub    al,32
ok_upper:
     push   ax
     call   tabh
     pop    ax
     mov    cx,helps
     mov    helps,0
     mov    bx,2
     cmp    al,'C'
     je     go_cap
     mov    helps,1
     cmp    al,'R'
     je     go_cap
     mov    helps,2
     cmp    al,'M'
     je     go_cap
     mov    helps,3
     cmp    al,'F'
     je     go_cap
     mov    helps,4
     cmp    al,'Q'
     je     go_cap
     mov    helps,5
     cmp    al,'K'
     je     go_cap
     mov    helps,cx
     call   tabh
     jmp    get_entry
go_cap:
     call   ret_key
     call   tabh
go_entry:
     jmp    get_entry
ok_entry:
     cmp    bx,0
     jle    go_entry
     push   bx
     cmp    al,13
     je     nohi
     call   tabh
nohi:
     pop    bx
     call   cs:go_line[bx]
     jmp    get_entry
exit_help:
     call  reset_segs_far
        pop   ax
        mov   font,ax
        pop   ax
        mov   attribute,al
        pop   ax
        mov   lscale,al
    call  charget_far
     call  present_far
     pop   es
     pop   ds
     pop   di
     pop   si
     pop   bp
     pop   dx
     pop   cx
     pop   bx
     pop   ax
     ret
help endp
nearprocs proc near
right_key:
     inc    helps
     inc    helps
     inc    helps
     jmp    check_helps
left_key:
     dec    helps
     dec    helps
     dec    helps
     jmp    check_helps
home_key:
     mov    helps,0
     jmp    check_helps
up_key:
     dec    helps
     jmp    check_helps
end_key:
     mov    helps,5
     jmp    check_helps
down_key:
     inc    helps
     jmp    check_helps
pgup_key:
     cmp    helps,2
     jg     pur
     mov    helps,0
     jmp    check_helps
pur:
     mov    helps,3
     jmp    check_helps
pgdn_key:
     cmp    helps,2
     jg     pdr
     mov    helps,2
     jmp    check_helps
pdr:
     mov    helps,5
     jmp    check_helps
check_helps:
; check to see if helps is valid
      cmp    helps,0
      jge    not_lt_0
      add    helps,6
      jmp    check_helps
not_lt_0:
      cmp    helps,5
      jle    not_gt_5
      sub    helps,6
      jmp    check_helps
not_gt_5:
; highlight_far the right area
     call   tabh
     ret
ret_key:
     mov    left_margin,textx
     mov    curx,textx
     mov    cury,texty
     mov    bx,helps
     shl    bx,1
     CALL   cs:helpline[bx]
     call   tprint_string_far
     ret
help1:
     assume  ds:tseg
     lea    dx,chelp
     ret
help2:
     assume  ds:tseg
     lea    dx,rhelp
     ret
help3:
     assume  ds:tseg
     lea    dx,mhelp
     ret
help4:
     assume  ds:tseg
     lea    dx,fhelp
     ret
help5:
; this is quit for now. soon to be an index
help6:
     assume  ds:tseg
     lea    dx,khelp
     ret
tabh:
 assume  ds:dseg
; this highlight_fars a tab
       mov    bx,helps
       shl    bx,1
       shl    bx,1
       assume ds:tseg
       push   ds
       mov    ax,tseg
       mov    ds,ax
       mov    ax,tab1x[bx]
       mov    bp,tab1x[bx+2]
       pop    ds
       assume ds:dseg
       mov    curx,ax
       mov    cury,bp
        mov   cx,4
tabhl:
        push  cx
        mov   cx,1
        call  highlight_far  ; this is supposed to highlight_far the 8 bytes
        add   cury,8
        pop   cx
        loop  tabhl
        ret
nearprocs endp
CSEG2 ends
tseg  Segment public  'DATA'
 assume  ds:tseg
book  equ this byte
db '   ˻   ',13,10
db '   ~~   ',13,10
db '  н~~ Ŀ',13,10
db '   C~~   F ',13,10
db '   U~~   I ',13,10
db '   R~~   L ',13,10
db '   S~~   E ',13,10
db '  ҷ~~ ',13,10
db ' н~~ Ŀ ',13,10
db '  R ~~  Q  ',13,10
db '  A ~~  U  ',13,10
db '  N ~~  I  ',13,10
db '  G ~~  T  ',13,10
db ' ҷ~~  ',13,10
db 'Ľ~~ п  ',13,10
db ' M ~~  K   ',13,10
db ' E ~~  E   ',13,10
db ' N ~~  Y   ',13,10
db ' U ~~  S   ',13,10
db 'ķ~~   ',13,10
db '   Ⱥ~~    ',13,10
db '    Ⱥ~~    ',13,10
db '     ͼ     ',13,10
db 0
; the book locates are as follows
bookx  equ 48
booky  equ 32
tab1x   dw 32+bookx
tab1y   dw 24+booky
tab2x   dw 24+bookx
tab2y   dw 72+booky
tab3x   dw 16+bookx
tab3y   dw 120+booky
tab6x   dw (66*8)+bookx
tab6y   dw 24+booky
tab5x   dw (65*8)+bookx
tab5y   dw 72+booky
tab4x   dw (64*8)+bookx
tab4y   dw 120+booky
textx  equ (8*7)+bookx
texty  equ 8+booky
;
;
;
; resident help text
;
;Cursor Controls
;
Chelp  equ this byte
db '       VIEW MODE CURSOR CONTROLS HELP PANEL             ',13,10,10
db ' The Cursor controls on the numeric keypad control the  ',13,10
db ' movement of picture on the screen whenever the menu    ',13,10
db ' is not visible. The keys have the following functions: ',13,10
db '     -  The up key moves you up through the picture.   ',13,10
db '         It moves the picture down.                     ',13,10
db '     -  The down key is the opposite of the up key.    ',13,10
db '     -  The left key moves you through the picture     ',13,10
db '         towards the left (the picture moves right).    ',13,10
db '   ',26,'  -  The right key is the opposite of the left key.',13,10
db ' Home -  The home key moves to the upper left corner    ',13,10
db '  End -  The End key moves to the lower right corner    ',13,10
db ' PgUp -  Moves up in chunks.                            ',13,10
db ' PgDn -  Moves down in chunks.                          ',13,10
db ' Ctrl -  The Ctrl key along with left and right moves   ',13,10
db '         to the left or right margin.                   ',13,10
db ' Esc, / and F9 get the menu back. Alt-L is Line drawing.',13,10
db 'Alt-G - Turns on the GRID.  Alt-T - Enters "TYPE" mode. ',13,10
db 'Alt-F1 - Alt-F4 & Alt-F10 -Font selection while typing. ',13,10
db 0
rhelp  equ this byte
db '               SETTING RANGE HELP PANEL                 ',13,10,10
db ' Many functions require that a range be set to select   ',13,10
db ' an area of the screen. You will be shown a pointer and ',13,10
db ' you will have to move it around. Some DRAW functions   ',13,10
db " don't need a range but just want you to point. The tip ",13,10
db ' of the finger is the point that counts. Move the finger',13,10
db ' by using the cursor controls. If you try to move out of',13,10
db ' the range of the page OPTIKS will make a blop sound.   ',13,10
db ' Using the shift and the right and left arrows will let ',13,10
db ' the finger move only one dot at a time for very fine   ',13,10
db ' movements. (Draw only). The F2 key selects the entire  ',13,10
db ' picture. The F7 key will move you to the last starting ',13,10
db ' range selected and the F8 key will move you to the last',13,10
db ' ending range selected. The Esc key exits. The Del key  ',13,10
db ' will toggle the floating range feature.                ',13,10
db ' Move the finger to the start of the range and then     ',13,10
db ' anchor the finger by pressing enter or ".". As you move',13,10
db ' the finger to select the range the area selected will  ',13,10
db ' be highlighted. Press enter to make the selection.     ',13,10
db 0
mhelp  equ this byte
db '               MENU SELECTION HELP PANEL                ',13,10,10
db ' OPTIKS uses a menu "tree" for selection of its options.',13,10
db ' You may traverse the tree by moving the left and right ',13,10
db ' arrows to the selection you want. The selection will be',13,10
db ' highlighted and a short description of the funtion will',13,10
db ' be displayed under the menu. Press the return key to   ',13,10
db ' select this item. Most of the time you will be shown   ',13,10
db ' another menu, but if you are at the bottom of the tree ',13,10
db ' OPTIKS will do what you have asked it to do. You may   ',13,10
db ' use the Esc key to back out of wherever you are. If you',13,10
db ' back out too far you will get into VIEW mode. You may  ',13,10
db ' press the / key or F9 or Esc to get the menu back.     ',13,10
db ' Once you learn your way through the menus you can use  ',13,10
db ' the first letter of the selection instead of the arrows',13,10
db ' and the return key. This is much faster. The F10 key   ',13,10
db ' is the quick way out of the menus and into the VIEW    ',13,10
db ' MODE. In the future comprehensive help on each menu    ',13,10
db ' item will be available.                                ',13,10
db '                                                        ',13,10
db 0
khelp  equ this byte
db '             FUNCTION KEYS    HELP PANEL                ',13,10,10
db ' Function keys are used in VIEW, MENU and RANGE modes   ',13,10
db " to speed up certain things. Some modes don't use all of",13,10
db ' the function keys (yet). These are some functions and  ',13,10
db ' when they are active:                                  ',13,10
db '   F1 - HELP. Always active. (except in help.)          ',13,10
db '   F2 - SELECT WHOLE PICTURE. RANGE mode only.          ',13,10
db '   F3 - TOGGLE COLORS. VIEW mode only.                  ',13,10
db '   F4 - TOGGLE PALETTE. VIEW mode only.                 ',13,10
db '   F5 - CGA High Resolution black and white.            ',13,10
db '   F6 - CGA Medium Resolution color.                    ',13,10
db '   F7 - Last start range. RANGE mode only.              ',13,10
db '   F8 - Last ending range. RANGE mode only.             ',13,10
db '   F9 - Get menu. View mode only.                       ',13,10
db '   F10 - Exit or return to view mode.                   ',13,10
db ' Ctrl-Break stops anything. mode.                       ',13,10
db ' Alt-1 to Alt-9 are keyboard macros.                    ',13,10
db ' Alt-G will toggle the grid. Del toggles floating range.',13,10
db ' Alt-C will clear the screen when in range mode.        ',13,10
db 0
fhelp  equ this byte
db '             FILE NAME        HELP PANEL                ',13,10,10
db ' In order to load or save files you have to enter a file',13,10
db ' name. OPTIKS will do a quick DIR on the current drive  ',13,10
db ' and directory to help you out by showing you what is   ',13,10
db ' there. You do not have to enter the extension if it is ',13,10
db ' the default extension. For PC paintbrush you do have to',13,10
db ' enter .PCC if you want the file with that extension    ',13,10
db ' instead of .PCX. For PC PAINT+ use the CGA BLOAD to get',13,10
db ' the file but use the .PIC extension instead of .BAS.   ',13,10
db ' A file name can be its first name, or first name +     ',13,10
db ' extension or it can be the full disk and path name of  ',13,10
db ' the file. If a file has no extension just follow the   ',13,10
db ' filename with a dot (.) to tell OPTIKS not to use the  ',13,10
db ' default extension. For listing files, do it exactly as ',13,10
db ' if you were doing a dir command. For changing disks and',13,10
db ' directories enter the new disk and path as though you  ',13,10
db ' were entering a CHDIR command or changing default      ',13,10
db ' disks. OPTIKS will change directories and disks, but   ',13,10
db ' forgets where you came from.                           ',13,10
db 0
TSEG ends
     end
