get_bytem macro string
local by_swap
     push  ds
     mov   ds,buffer
     lodsb
     pop   ds
     cmp   tif_fillorder,2
     jne   by_swap
     push  bx
     mov   bl,al
     mov   bh,0
     mov   al,filltable[bx]
     pop   bx
by_swap:
     dec   max_byte
     endm
get_wordm macro string
local by_swap
     push  ds
     mov   ds,buffer
     lodsw
     pop   ds
     cmp   tif_fillorder,2
     jne   by_swap
     push  bx
     mov   bl,al
     mov   bh,0
     mov   al,filltable[bx]
     mov   bl,ah
     mov   ah,filltable[bx]
     pop   bx
by_swap:
     dec   max_byte
     dec   max_byte
     endm


; OKHUFF is an alternative to reading the fax modified huffman
; I will try it instead of the CCITTR program.
dseg segment para public 'DATA'
extrn width_pix:word
curr_color  db 0
max_bits  dw 0

extrn  filltable:byte,tif_fillorder:word


dseg ends

CSEG segment public 'CODE'
assume cs:cseg,ds:dseg,es:dseg
extrn  reset_segs:near
;
string_it:
; try again at stringit
    call reset_segs
    push  es
    mov   es,buffer
;   cx has the length of bits to string, last_bits has the number
;   of bits already sent down
    mov   bl,0ffh
    mov   bh,curr_color
    cmp    bh,0
    jne   not_black
    mov   bl,0
not_black:
    cmp   last_bits,0
    jne   finish_last_bits
string_zero_bits:
; here we are on a even bit boundary
    mov   ax,cx
    mov   dx,0
    mov   cx,8
    div   cx
    mov   cx,ax
    mov   al,bl
    cmp   cx,0
    je    no_reps
    cld
rep  stosb
no_reps:
    mov    last_bits,dx
    mov    byte ptr es:[di],al
    jmp  good_string
finish_last_bits:
; the last bits have to be finished up
    push  cx
    mov   ah,byte ptr es:[di]
    mov   al,bl
    mov   cx,8
    sub   cx,last_bits
    shr   ah,cl
    shl   ax,cl
    mov   byte ptr es:[di],ah
    pop   cx
    add   last_bits,cx
    cmp   last_bits,8
    jl    more_string_bits
    je    one_string_byte
    mov   cx,last_bits
    sub   cx,8
    inc   di
    jmp   string_zero_bits
more_string_bits:
;  no increment or anything
     jmp  good_string
one_string_byte:
;  finished off a string
     mov   last_bits,0
     inc   di
;    jmp  good_string
good_string:
    pop   es
    clc
    ret
; code here to do stringing
; dh has the color and cx has the length to string in bits
;
;
     call reset_segs
     cmp  cx,0
     jg   not_z_string
     clc
     ret
not_z_string:
     push  ax
     push  bx
     push  cx
     push  dx
     mov   dh,curr_color
     mov   bl,0
     cmp   dh,0
     je    by_ff
     mov   bl,0ffh
by_ff:
     push es
     mov  es,buffer
; always check to see if last bits needs to be worked on
     cmp   last_bits,0
     jne   last_bits_nz
; last bits were 0 so we are on an even byte boundary
;    cx has the number of bits to write
;   bl has an ff or a 00 , doesn' matter to me
write_string:
; cx must have the length to unstring
     mov   ax,cx
     mov   dx,0
     mov   cx,8
     div   cx
     mov   last_bits,dx
     mov   cx,ax
     cld
     mov   al,bl
     cmp   cx,0
     jle   no_rep
rep  stosb
no_rep:
     mov    ah,al
     xor    al,0ffh
    mov    es:[di],al
     cmp   dx,0
     jle   no_last_bits
; th final bits have to be resolved
     mov   cx,8
     sub   cx,dx
     shl   ax,cl
    mov    es:[di],ah
no_last_bits:
    pop   es
    pop   dx
    pop   cx
    pop   bx
    pop   ax
    clc
    ret

last_bits_nz:
; here there are  some bits left over in the byte
; pointed to by es:di
;
; there are two situations, 1) is that last_bits + cx will not finish
; the current byte, 2) is that it will
   mov   ax,last_bits
   add   ax,cx
   cmp   ax,8
   jl    byte_not_done
   je    byte_is_done
; here there is more than enough to move into next byte
   add   cx,last_bits  ; add in bits left over
   sub   cx,8       ; last byte
   inc   di
   jmp   write_string
byte_is_done:
   inc   di
   mov   last_bits,0
   mov   al,bl
   xor   al,0ffh
   mov   es:[di],al
   jmp   no_last_bits
byte_not_done:
; the byte at es:di will not be finished this pass
   add   last_bits,cx
   mov   cx,8
   sub   cx,last_bits
   mov   ah,es:[di]
   mov   al,bl
   xor   al,0ffh
   shr   ah,cl
   shl   ax,cl
;
   mov    es:[di],ah
   jmp   no_last_bits
;
; entry points are huffr1 which sets up the first read of a line
; and huffr which reads a line
huffr1:
public huffr1
; set up stuff
     push  ax
     push  cx
     mov saveax,0
     mov  dh,0
     mov  dl,16
     mov savedx,dx     ; save the color ind
     mov last_bits,0
     mov curr_color,0
     mov  ax,width_pix
     mov  max_bits,ax
     pop  cx
     pop  ax
     ret
;
huffr:
public huffr
; read a line
; ax has the max bytes we are allowed to read
; cx has the length of line to read
     mov   last_bits,0
huffr2a:
public huffr2a
     mov   dx,savedx
     mov   dh,0
     mov   savedx,dx
huffr2:  ; entry without force white
     cld
public huffr2
     call  next_byte
     jc    bad_huff
     cmp   cx,0
     je   huffr2
; returns with the number of bits to string in cx
;    dh has a 1 or a 0 depending on the color
;    carry is set if a bad read
; if ch is 254 then it is an eol character
     cmp   cx,253
     je    leave_huffr
     cmp   cx,254
     jne   not_a_eol
     jmp   leave_huffr
not_a_eol:
; cx has the count of characters
; dh has a 1 or a zero, 1 for black, 0 for white
     mov   bx,max_bits
     sub   max_bits,cx
     push  cx
     call  string_it
     pop   cx
     cmp   max_bits,0
     jg    not_done_line
; here we have finished the line, but we have an eol?
; no because tif don't do eol's
; if the cx is a make-up then the next guy has to be the no-makeuo
     cmp   cx,63
     jle   leave_huffr
     mov  ax,saveax
     mov  dx,savedx
     call  next_byte
;
leave_huffr:
     mov   ax,width_pix
     mov   max_bits,ax
     mov last_bits,0
     mov  dx,savedx
     mov  ax,saveax
     call check_dl
     mov  dh,0
; here, si points to the next byte to get
; if dl is zero we have a full word in in primer
; if dl is less than that we have less than a full word
     cmp  dl,0
     je   save_savedx1
     jmp  save_savedx2
save_savedx1:
     dec  si
save_savedx2:
     dec  si
     mov  dl,16
     mov  savedx,dx
     mov  saveax,ax
     clc
     ret
not_done_line:
     jmp   huffr2
good_huffx:
     clc
     ret
bad_huff:
     stc
     ret
;
;
next_byte:
;
     call reset_segs
     mov  ax,saveax
     mov  dx,savedx
     call check_dl
; something less than 8 shifted so far
; here there are at least 9 bits to check
; there is still some more than 8 bits of information so we go on
;
;  there may be an EOL which is the same for both black and white
     jmp  nb_1
; xyzzy
     cmp  al,0  ; eol is 11 zeroes and a 1 there are no 8 zero
     jne  nb_1
     jne  nb_1
; we have an eol   eol
     mov   cl,dl
     shr   ah,cl
     get_bytem
     shl   ax,cl
     xchg  al,ah
; here we know we have an eol, but we need 0001xxxx in ah
check_for_eolb:  ; check for last bit of eol, some formats
                 ; byte or word justify the eol characters
     test  al,11110000b
     jnz   nb_2
     xchg  al,ah
     shl   ax,1
     xchg  al,ah
     inc   dl
     call  check_dl
     jmp   check_for_eolb
nb_2: ;found the eol bit now get rid of it
; have shifted 8, now the other 4
     mov   cl,4
     xchg  al,ah
     shl   ax,cl
     add   dl,4
     xchg  al,ah
     call  check_dl
     mov   dh,0
     mov   saveax,ax
     mov   savedx,dx
     mov   cx,254  ; eof flag for calling procedures
     clc
     ret
; all done, leave with an eol
nb_1:
     mov  curr_color,0
     cmp  dh,0  ; white/black indicator, 1 is white
     je   do_white
     jmp  do_black
do_white:
; find the match to the guy in al
     mov    curr_color,1
     mov    dh,1    ; next is black
; look up in table to get the next
     mov    bh,0
     mov    bl,al   ; al has the sig bits
     mov    ch,white_tab1[bx]    ; number
     mov    cl,white_tabl[bx]    ; length
do_lookup: ; same for black and white after here
     cmp    ch,255
     jne    good_w1
leave_look:
     stc
     ret
good_w1:
;
     cmp    ch,253
     jne    not_long
; the long character has been identified
; we must do the shift
; if black the size is 4, if white the size is 8
long4:
     xchg  al,ah
     shl   ax,cl
     xchg  al,ah
     add   dl,cl
     call check_dl  ; make sure we have a good guy in al
     mov   bh,0
     mov   bl,al
     mov   cl,4
     shr   bx,cl
     mov    ch,long_tab1[bx]    ; number
     mov    cl,long_tabl[bx]    ; length
; got the long string in cx now - good for tiff
;   cl is always less than 8
     jmp    w_not_8a
not_long:
     cmp    cl,8
     jl     w_not_8
     cmp    cl,8
     je     w_is_8
; white 9's have a 0 in next byte if they are
     test   ah,80h
     jz     w_is_8
     inc    ch
     cmp    ch,89
     jne    w_is_8
     inc    ch
w_is_8:
     mov   al,ah
     add   dl,8
     sub   cl,8
     call  check_dl
w_not_8:
; cl has the amount to shift
; ch has the string count
     cmp   cl,0
     je   w_by_8
w_not_8a:
     xchg  al,ah
     shl   ax,cl
     xchg  al,ah
     add   dl,cl
     call  check_dl
w_by_8:
; check to see if ch>64
     mov   cl,ch
     mov   ch,0
     cmp   cx,63     ; cx has the unstring length
     jg    cx_gt_64
     jmp   do_save
cx_gt_64:
     push  ax
     sub   cx,63
     xor   dh,1
     mov   ax,cx
     mov   cl,6
     shl   ax,cl
     mov   cx,ax
     pop   ax
do_save:
; this is the area where we have a length in cx and we can return
     mov   saveax,ax
     mov   savedx,dx
;
     clc
     ret
;
;
; these guys are by brute force
;  db 00010000b      ; 9     6    000100
;  db 00010100b      ; 8     6    000101
;  db 00011000b      ; 7     5    00011
;  db 00100000b      ; 6     4    0010
;  db 00110000b      ; 5     4    0011
;  db 01000000b      ; 1     3    010
;  db 01100000b      ; 4     3    011
;  db 10000000b      ; 3     2    10
;  db 11000000b      ; 2     2    11
;
;
do_black:
     mov    dh,0    ; next is white
; black strategy is sligthly different than white.
; almost all black strings are 12 bits long.
; we have to identify the short ones and do them by hand
; check for eol
     test al,0f0h
     jnz  black_short
     jmp  black_long
black_short:
; here we have one of the short strings
; there are 9  of them
; length of 6
     mov   cl,2
     test  al,80h
     jz    not_2_3
;  2 is 11
;  3 is 10
     test  al,40h
     jnz   got_2
; got a 11  in al
     mov   ch,3
     jmp   black_s_hit
got_2:
; got a 10  in al
     mov   ch,2
     jmp   black_s_hit
not_2_3:
; high bit is not on
     inc   cl    ; cl is now 3
     test  al,40h
     jz    not_1_4
; got either 010 for 1 or 011 for 4
     test  al,20h
     jnz   got_4
; got 010 in al
     mov   ch,1
     jmp   black_s_hit
got_4:
; got 011 in al
     mov   ch,4
     jmp   black_s_hit
not_1_4:
; first two bits are 00
     inc   cl    ; cl is now 4
     test  al,20h
     jz   not_5_6
     test  al,10h
     jz    got_6
; got 0011 in al
     mov   ch,5
     jmp   black_s_hit
got_6:
; got 0011 in al
     mov   ch,6
     jmp   black_s_hit
not_5_6:
; have 0001 in al
     inc   cl     ; now has a 5 in cl
     test  al,08h
     jz    got_8_9
; got 00011 in al
     mov   ch,7
     jmp   black_s_hit
got_8_9:
; can have 8=000101
;          9=000100
     inc   cl       ; now has a 6
     test  al,04h
     jnz   got_8
; got 000100 in al
     mov   ch,9
     jmp   black_s_hit
got_8:
; got 000101 in al
     mov   ch,8
;    jmp   black_s_hit
black_s_hit:
; got a short hit on one of the 14
; dl has the length
    call  check_dl
    xchg  al,ah
    shl   ax,cl
    xchg  al,ah
    add   dl,cl
    mov   cl,ch
    mov   ch,0
; di has the hit in it
    call  check_dl
    jmp   do_save
;
black_long:
; these are long strings
; black long strings have to be shifted
   xchg  al,ah
   mov   cl,4
   shl   ax,cl
   add   dl,4
   xchg  al,ah
   call check_dl
; the ax has been shifted right 4
; more or less mimic the white lookup
; look up in table to get the next
     mov    bh,0
     mov    bl,al   ; al has the sig bits
     mov    ch,black_tab1[bx]
     mov    cl,black_tabl[bx]
     jmp    do_lookup
check_dl:
; on entry, dl has the total of all shifts made so far.
; if dl is greater equal to 8 we have to get a new byte
; if dl is greater than 8 we have to shift into the existing byte
     push  cx
     cmp  dl,16   ; dl has the amount we have shifted since the last lod
     jne  no_new_word
new_word:
; get a new word from the input stream - first time though
     mov   dl,0
     get_wordm
; al has the first byte of word
     pop  cx
     ret
no_new_word:
     cmp  dl,8
     je   new_byte
     jl   do_lowshift
; more than 8 bits shifted
     mov   ah,al
     get_bytem
     sub  dl,8
     mov  cl,dl
     shr  ah,cl
     shl  ax,cl
; now we have to shift ah to the right
     xchg al,ah
     jmp  do_lowshift
new_byte:
; last guy was exactly 8 bytes long
; have to get a new byte
     mov  ah,al
     get_bytem
     xchg al,ah
     mov  dl,0
do_lowshift:
     pop  cx
      ret
;
CSEG ends
DSEG segment public 'DATA'
assume cs:cseg,ds:dseg,es:dseg
extrn  buffer:word,width_bytes:word,vwid:word
;
saveax  dw  0  ; contains the code we are working with
savedx  dw  0  ; saves length informations
last_bits dw 0 ; number of bits left over from last fill
max_byte dw 0
;
;
;
; the lookup is to white_tab1
; if there is number less than 65 then it is a good number
; if its greater than 64 then subtract 63 and mult by 64
; if length is 9 then next bit is added to length
; exception is white 88, if next bit is on then add 2 to length
; 254 is the eol character
; 255 is an error due to phase
; white_tabl has the length
; black table rules are similar, except that if first 4
; bits are zero then do a left shift 4 to bypass them
; the 9 items where first 4 bits have a 1 are done brute force
; no 88 exception on black
;
white_tab1  equ  this byte
  db 254,253,29,30,45,46,22,22,23,23,47,48,13,13,13,13
  db 20,20,33,34,35,36,37,38,19,19,31,32,1,1,1,1
  db 12,12,12,12,53,54,26,26,39,40,41,42,43,44,21,21
  db 28,28,61,62,63,00,68,69,10,10,10,10,10,10,10,10
  db 11,11,11,11,11,11,11,11,27,27,59,60,86,88,18,18
  db 24,24,49,50,51,52,25,25,55,56,57,58,66,66,66,66
  db 89,89,89,89,70,71,74,73,72,76,78,80,82,84,67,67
  db 16 dup(2)
  db 16 dup(3)
  db 8 dup(65),8 dup(8)
  db 8 dup(9),4 dup(16),4 dup(17)
  db 16 dup(4)
  db 16 dup(5)
  db 4 dup(14),4 dup(15),8 dup(64)
  db 16 dup(6)
  db 16 dup(7)
white_tabl equ this byte
  db 12,8,8,8,8,8,7,7,7,7,8,8,6,6,6,6
   db 7,7,8,8,8,8,8,8,7,7,8,8,6,6,6,6
   db 6,6,6,6,8,8,7,7,8,8,8,8,8,8,7,7
   db 7,7,8,8,8,8,8,8,5,5,5,5,5,5,5,5
   db 5,5,5,5,5,5,5,5,7,7,8,8,9,9,7,7
   db 7,7,8,8,8,8,7,7,8,8,8,8,6,6,6,6
   db 6,6,6,6,8,8,9,8,8,9,9,9,9,9,7,7
   db 16 dup(4)
   db 16 dup(4)
   db 16 dup(5)
   db 8 dup(5),8 dup(6)
   db 16 dup(4)
   db 16 dup(4)
   db 8 dup(6),8 dup(5)
   db 16 dup(4)
   db 16 dup(4)
black_tab1  equ  this byte
   db 16 dup(254)
   db 16 dup(253)
   db 18,18,18,18,52,73,75,55,56,83,85,59,60,87,24,24
   db 25,25,89,68,69,70,71,53,54,77,79,81,64,64,64,64
   db 13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13
   db 23,23,50,51,44,45,46,47,57,58,61,67,16,16,16,16
   db 17,17,17,17,48,49,62,63,30,31,32,33,40,41,22,22
   db 16 dup(14)
   db 16 dup(10)
   db 16 dup(10)
   db 16 dup(11)
   db 16 dup(11)
   db 15,15,15,15,15,15,15,15,65,66,26,27,28,29,19,19
   db 20,20,34,35,36,37,38,39,21,21,42,43,00,00,00,00
   db 32 dup(12)
black_tabl equ this byte
;  db 0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0
   db 16 dup(8)
   db 16 dup(4)
   db 6,6,6,6,8,9,9,8,8,9,9,8,8,9,7,7
   db 7,7,9,8,8,8,9,8,8,9,9,9,6,6,6,6
   db 4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4
   db 7,7,8,8,8,8,8,8,8,8,8,8,6,6,6,6
   db 6,6,6,6,8,8,8,8,8,8,8,8,8,8,7,7
   db 4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4
   db 16 dup(3)
   db 16 dup(3)
   db 16 dup(3)
   db 16 dup(3)
   db 5,5,5,5,5,5,5,5,8,8,8,8,8,8,7,7
   db 7,7,8,8,8,8,8,8,7,7,8,8,6,6,6,6
   db 32 dup(3)
;
; the long table is when the first 7 bits are zero (black and white)
; when we detect 1 in white mode or xlate a 253 in black we come here
; to further decode
;
long_tab1 equ this byte
     db  91,91,94,95,96,97,98,99,92,92,93,93,100,101,102,103
long_tabl equ this byte
     db  3,3,4,4,4,4,4,4,3,3,3,3,4,4,4,4
public black_tabl,black_tab1
public white_tabl,white_tab1
public long_tabl,long_tab1
dseg  ends
      end
