; OKLINE1 draws a line on the screen
; the program is called from OKRANGE and is passed
; scol,srow,spoint
; rcol,rrow,rpoint
; ecol,erow    ; upper left of screen
dseg  segment para public 'DATA'
assume cs:cseg,ds:dseg,es:dseg
extrn  sx:word,sy:word,spnt:word
extrn  ex:word,ey:word,epnt:word
extrn ecol:word,erow:word
extrn fx:word,fy:word,mode:byte
extrn vid_wid:word,vid_len:word,vbuffer:word,interlace:word
extrn debug:byte,vwid:word,siloc:word
extrn cline:word
;
;  LOCAL DATA
;
; using a local rcol,rrow and rpoint
lrow dw  0
lcol dw  0
lpoint dw  0
srow dw  0
scol dw  0
spoint dw  0
rrow dw  0
rcol dw  0
rpoint dw  0
px   dw  0
py   dw  0
vx   dw  0
vy   dw  0
endx   dw  0
endy   dw  0
ltot dw  0  ; running total of line
color db 128,64,32,16,8,4,2,1
pdir  db 0
dodot db 0
; for vesa have to keep track of x
vesx  dw 0
dseg  ends
;
;
cseg  segment para public 'CODE'
assume cs:cseg,ds:dseg,es:dseg
extrn  calc_bank:near
xor_lines  proc  near
public xor_lines
       cmp   debug,9
       jne   no_debug
       int   3   ; debug break
no_debug:
; calc the rrow and rcol and rpoint
       mov   ax,sx
       mov   scol,ax
       mov   ax,sy
       mov   srow,ax
       mov   ax,spnt
       mov   spoint,ax
       mov   ax,ex
       mov   rcol,ax
       mov   ax,ey
       mov   rrow,ax
       mov   ax,epnt
       mov   rpoint,ax
       mov   ax,rcol
       sub   ax,ecol
       mov   lcol,ax
       mov   ax,rpoint
       mov   lpoint,ax
       mov   ax,rrow
       sub   ax,erow
       mov   lrow,ax
; step one calc the points between the scol and lcol
       mov   cl,3
       mov   ax,scol
       shl   ax,cl
       add   ax,spoint
       mov   bx,ecol
       add   bx,lcol
       shl   bx,cl
       add   bx,lpoint
       sub   ax,bx
       mov   px,ax
; px has the x value points (could be negative)
;
; calculate points between srow and lrow
       mov  ax,srow
       sub  ax,erow
       sub  ax,lrow
       mov  py,ax
; py has the bits vertical
;
; calculate the pd
       mov   ax,py
       mov   bx,px
       mov   pdir,0
       cmp   ax,0
       je    axeqbx
       jg    axpos
       neg   ax
axpos:
       cmp   bx,0
       je    axeqbx
       jg    bxpos
       neg   bx
bxpos:
       mov   pdir,2
       cmp   ax,bx
       jg    axeqbx
       mov   pdir,1
axeqbx:
       mov   dodot,0
; here if the thing is sloping up steep
;
; now set up the absolute bits on screen - vx,vy
       mov  ax,lrow
       mov  vy,ax
       mov  ax,lcol
       mov  cl,3
       shl  ax,cl
       add  ax,lpoint
       mov  vx,ax
; calculate the last point on the screen
       mov  ax,scol
       sub  ax,ecol
       shl  ax,cl
       add  ax,spoint
       mov  endx,ax
       mov  ax,srow
       sub  ax,erow
       mov  endy,ax
       mov   ltot,0
;
; set up the es:di for the first point fix
;
; this must be changed for the real version
       mov   ax,vbuffer        ;
       mov   es,ax             ;
       mov   ax,lrow           ;
       mov   dx,0              ;
       div   interlace         ;
       mul   vid_wid           ;
       add   ax,lcol           ;
       mov   di,ax             ;
       cmp   mode,-1
       jne   not_vesa1
       mov   ax,lcol
       mov   vesx,ax
       mov   ax,vy
       mov   cline,ax
       call  calc_bank
       add   di,vesx
not_vesa1:
;-------------------------------
       cmp   px,0
       jne   nendxt_point
       cmp   py,0
       jne   nendxt_point
       ret
nendxt_point:
;  all set to go
       call  do_point
; now calculate the nendxt point
;
;
       cmp   py,0
       je    nendxt_line1
       cmp   px,0
       je    check_py
       cmp   ltot,0
       jle   nendxt_line1
; vertical   move
       cmp   pdir,1
       jne   okup
       mov   dodot,1
okup:
       mov   ax,px
       cmp   ax,0
       jl    add_px
       sub   ltot,ax
       jmp   check_py
nendxt_line1:
        jmp   nendxt_line
add_px:
       add   ltot,ax
check_py:
       cmp   py,0
       jl    moving_up
; moving down
       inc   vy
       mov   ax,vy
       and   ax,3
       cmp   ax,0
       jz    add_width
       cmp   interlace,1
       je    add_width
       cmp   interlace,2
       je    interlace2a
; interlace must be 4
       jmp   check_bound
interlace2a:
       cmp   ax,2
       je    add_width
       jmp   check_bound
add_width:
       call   add_di
       jmp    check_bound
moving_up:
       dec   vy
       mov   ax,vy
       and   ax,3
       cmp   ax,3
       je    sub_width2
       cmp   interlace,1
       je    sub_width2
       cmp   interlace,2
       je    interlace2b
; interlace must be 4
       jmp   check_bound
interlace2b:
       cmp   ax,1
       je    sub_width2
       jmp   check_bound
sub_width2:
       call   sub_di
       jmp    check_bound
nendxt_line:
; here we must add in the line length to ltot
       cmp   pdir,2
       jne   okside
       mov   dodot,1
okside:
       mov   ax,py
       cmp   ax,0
       jl    sub_py
       add   ltot,ax
       jmp   check_px
sub_py:
       sub   ltot,ax
check_px:
       cmp   px,0
       jl    moving_left
; moving right
       inc   vx
       mov   ax,vx
       and   ax,7
       cmp   ax,0
       jne   check_bound0
       call  inc_di
check_bound0:
       jmp   check_bound
moving_left:
       dec   vx
       mov   ax,vx
       and   ax,7
       cmp   ax,7
       jne   check_bound
       call  dec_di
;      jmp   check_bound
;
check_bound:
; make sure we are still on picture
        cmp   vy,0
        jl    done_line
        cmp   vx,0
        jl    done_line
        mov   ax,vx
        mov   cl,3
        shr   ax,cl
        cmp   ax,vid_wid
        jg    done_line
        mov   ax,vid_len
        mul   interlace
        cmp   ax,vy
        jl    done_line
        cmp   di,0
        je    done_line
        mov   ax,vy
        cmp   ax,endy
        jne   do_nendxt_point
        mov   ax,vx
        cmp   ax,endx
        je   done_line
do_nendxt_point:
        jmp   nendxt_point
done_line:
        clc
        mov   ax,0
        ret
inc_di:
      inc   di
      inc   vesx
      ret
dec_di:
      dec   di
      dec   vesx
      ret
sub_di:
       sub    di,vid_wid
       cmp    mode,-1
       je     is_vesa2
       ret
is_vesa2:
      sub    cline,2
      call   calc_bank
       add   di,vesx
      ret
add_di:
       add    di,vid_wid
       cmp    mode,-1
       je     is_vesa3
       ret
is_vesa3:
      call   calc_bank
       add   di,vesx
      ret
;
getcolor:
; this is used by both line 1, and line 2 and anybody else,
; this will eventually be used for color and thickness stuff
       mov  bx,vx
       and  bx,7
       mov  al,color[bx]
       ret
;
do_point:
; do a point in es:di with the bits in vx,vy
       cmp  dodot,0
       je   gododot
       mov  dodot,0
       ret
gododot:
       call getcolor  ; gets a color in al and a jam in ah
       mov  dx,vy
       and  dl,3
; check out interlace
       mov  si,0
       cmp  dl,0
       jz   ok_interlace
       cmp  interlace,1
       je   ok_interlace
       cmp  interlace,2
       je   interlace2
; interlace is 4
       mov  si,2000h
       cmp  dl,1
       je   ok_interlace
       add  si,2000h
       cmp  dl,2
       je   ok_interlace
       add  si,2000h
       jmp  ok_interlace
interlace2:
       cmp  dl,2
       je   ok_interlace
       add  si,2000h
ok_interlace:
       add  si,di
       xor  byte ptr es:[si],al
       ret
xor_lines endp
cseg  ends
      end
