; OKRANGE.ASM is the vehicle for moving the finger around.
; this gets a keystroke, and moves the finger and then
; executes the proper executable module for that phase, either
; a blind return, or xor or one of the graphics functions
;
dseg segment public 'DATA'
        ASSUME CS:CSEG,DS:DSEG,ES:DSEG
extrn  scol:word,srow:word,lcol:word,lrow:word,fx:word,fy:word
extrn  vid_wid:word,vid_len:word,r_index:word
extrn  clean:byte,interlace:word,vwid:word,vbuffer:word
extrn  curr_seg:word,siloc:word,spoint:word,lpoint:word
extrn  debug:byte,curx:word,cury:word,left_margin:word
extrn  helps:word,maxlines:word,save_font:word,font:word
extrn  lscale:word,scale:word,work_seg:word,fat_on:byte
extrn  Last_si:word,last_seg:word,planes:word
extrn  height_pix:word,width_byteso:word
extrn  cline:word,mode:byte
segmentsize equ 8000h
;
;  LOCAL DATA
;
olay   db  0
public  olay   ; used by copy and overlay
;
index  db '0000,'
index2 db '0000',0
iswitch  db  0
;
fux  dw 0  ; the move from range is in these four words
fuy  dw 0
flx  dw 0
fly  dw 0
public fux,fuy,flx,fly
old_len  dw 0   ; used in floating ranges
old_wid  dw 0
fswitch  db 0   ; if the scol,srow is floating its 1
vid_bits dw 0   ; bits on a screen
len_bits dw 0   ; true len in bits
; this the last time stuff so the f7 and f8 keys will work
lastux   dw 0
lastuy   dw 0
lastusi  dw 0
lastuseg dw 0
lastlx   dw 0
lastly   dw 0
lastlsi  dw 0
lastlseg dw 0
; typeing absolute
ty  dw  0
tx  dw  0
public tx,ty
; this is the setup area for doing xor's and box's to screen
ux   dw  0      ; upper left hand corner
uy   dw  0
lx   dw  0      ; lower right hand corner
ly   dw  0
; this is the save area so we can undo the last ux etc
lux   dw  0      ; upper left hand corner
luy   dw  0
llx   dw  0      ; lower right hand corner
lly   dw  0
public lx,ly,ux,uy
;
rx   dw  0      ; the saved upper left hand corner
ry   dw  0
; rcol and rrrow are real coordinates in the whole page
;
rcol dw  0      ; where we are in the picture
rrow dw  0
rrrow dw  0     ; for local work only
rpoint dw 0
public rcol,rrow,rpoint
zcol dw  0      ; these are the sizing coordinates
zrow dw  0
zpoint dw 0
public zcol,zrow,zpoint
;
ecol   dw 0      ; the absolute now position of upper left hand corner
erow   dw 0      ; of the screen
epoint dw 0
public erow,ecol,epoint
sx     dw 0      ; these are absolute start and endpoints of a line
sy     dw 0
spnt   dw 0
ex     dw 0
ey     dw 0
epnt   dw 0
public sx,sy,spnt
public ex,ey,epnt
;
vesx   dw 0
;
xpass  db  0  ; is a clean byte to tell if we have to xor the
; screen twice. If xpass is 1 then xor the screen with old coords
;
;
;
; the following is for default setting informational messages
;
; =186 =187 =188 =200 =201 =205
range1 db  "Move the pointer to the upper left corner",10
       db  "  and press ENTER. Press Esc to Escape.",10
       db  "  (press Alt-C to clear this message)",0
range2 db  "Move the pointer to the lower right corner",10
       db  "  and press ENTER. Press Esc to Escape.",10
       db  "  (press Alt-C to clear this message)",0
size2  db  "Move the pointer to the range size",10
       db  "and press ENTER. Press Esc to Escape.",10
       db  "(press Alt-C to clear this message)",0
line1  db  "Move the pointer to the starting position",10
       db  "  and press ENTER. Press Esc to Escape.",10
       db  "  (press Alt-C to clear this message)",0
line2  db  "Move the pointer to the ending position",10
       db  "  and press ENTER. Press Esc to Escape.",10
       db  "  (press Alt-C to clear this message)",0
circ1  db  "Move the pointer to the center of ellipse",10
       db  " and press ENTER. Press Esc to Escape.",10
       db  "  (press Alt-C to clear this message)",0
circ2  db  " Move the pointer to size the ellipse",10
       db  "and press ENTER. Press Esc to Escape.",10
       db  " (press Alt-C to clear this message)",0
move1  db  "  Move the pointer to the new location",10
       db  "  and press ENTER. Press Esc to Escape.",10
       db  "  (press Alt-C to clear this message)",0
zoom1  db  " Move the pointer to the dot.",10
       db  " Press enter to turn on fat bit.",10
       db  " Press space bar to turn off fat bit.",10
       db  " (press Alt-C to clear this message ",0
draw1  db  " Move the pointer to the start of a line",10
       db  " Press enter to start drawing. Press",10
       db  " Enter again to stop. Press Esc to Quit",10
       db  " (press Alt-C to clear this message)",0

;
;
;
dseg  ends

CSEG2   SEGMENT PARA PUBLIC 'TEXT'
        ASSUME CS:CSEG2
extrn  help:far
cseg2 ends
CSEG    SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:DSEG,ES:DSEG
extrn reset_segs:near,put_finger:near,getkey:near
extrn up_key:near,down_key:near,left_key:near,right_key:near
extrn home_key:near,end_key:near,present:near,prbox:near
extrn blip:near,get_curr_seg:near
extrn  xor_liner:near
extrn  xor_lines:near
extrn  xor_circr:near
extrn  xor_circs:near
extrn  bin_to_dec:near
extrn  fixplane1:near
extrn  fixplane2:near
extrn  ctright:near,ctleft:near,real_sfp:near
extrn  calc_bank:near

; LOCAL DATA CS overide items
;
fingerline  dw  blind_ret,xor_range,xor_box,xor_line,set_char
            dw  set_zoom,xor_circ,make_sfp,draw_line
;           dw  other graphics items
; this is action line for keystrokes
mf_line  dw  mf_let,mf_ret,mf_left,mf_right,mf_home,mf_up,mf_end,mf_down
         dw  mf_pgup,mf_pgdn,mf_f7,mf_f8
         dw  ct_home,ct_end,ct_left,ct_right,ct_pgup,ct_pgdn
         dw  20 dup(mf_home)
;
set_lbox:
public set_lbox
     call  reset_segs
     lea   ax,xor_box
     mov   cs:fingerline[2],ax
     ret
set_xbox:
public set_xbox
     call  reset_segs
     lea   ax,xor_range
     mov   cs:fingerline[2],ax
     ret
do_index:
; this does an index in upper left hand corner
; finger location is in fx and fy
       test  iswitch,1
       jnz   do_i
       ret
do_i:
; calculate upper left hand corner of screen
      mov   ax,segmentsize
      mov   dx,0
      div   vwid
      mul   curr_seg
      mov   ty,ax
      mov   ax,siloc
      mov   dx,0
      div   vwid
      add   ty,ax
      shl   dx,1
      shl   dx,1
      shl   dx,1
      mov   tx,dx
;  now the screen points are added in
      mov   ax,fx  ; finger x loc
      cmp   fat_on,1
      jne   fati1
      shr   ax,1
      shr   ax,1
      shr   ax,1
fati1:
      add   tx,ax
      mov   ax,fy  ; finger y loc
      cmp   fat_on,1
      jne   fati2
      shr   ax,1
      shr   ax,1
      shr   ax,1
fati2:
      add   ty,ax
; convert to dec and display
       mov   ax,tx
       call  bin_to_dec
       xchg  ax,dx
       lea   di,index
       cld
       stosw
       mov   ax,dx
       stosw
       mov   ax,ty
       call  bin_to_dec
       xchg  ax,dx
       lea   di,index2
       stosw
       mov   ax,dx
       stosw
     mov  curx,520
     mov  cury,0
     mov  left_margin,0
     lea  dx,index
     call prbox
       ret

;
dummy:
blind_ret:
      ret
xor_boxer:
; draw 3rd   line, lower right to lower left
     mov   ax,rcol
     mov   ex,ax
     mov   ax,rrrow
     mov   ey,ax
     mov   ax,rpoint
     mov   epnt,ax
;
     mov   ax,scol
     mov   sx,ax
     mov   ax,rrrow
     mov   sy,ax
     mov   ax,spoint
     mov   spnt,ax
     call  xor_liner
; draw 4th   line,  lower right to upper right
     mov   ax,rcol
     mov   ex,ax
     mov   ax,rrrow
     mov   ey,ax
     mov   ax,rpoint
     mov   epnt,ax
;
     mov   ax,rcol
     mov   sx,ax
     mov   ax,srow
     mov   sy,ax
     mov   ax,rpoint
     mov   spnt,ax
     call  xor_liner
; draw first line, upper right upper left
     mov   ax,spoint
     mov   spnt,ax
     mov   ax,scol
     mov   sx,ax
     mov   ax,srow
     mov   sy,ax
;
     mov   ax,rpoint
     mov   epnt,ax
     mov   ax,rcol
     mov   ex,ax
     mov   ax,srow
     mov   ey,ax
     call  xor_liner
; draw 2nd   line,  lower left to upper left
     mov   ax,scol
     mov   sx,ax
     mov   ax,srow
     mov   sy,ax
     mov   ax,spoint
     mov   spnt,ax
;
     mov   ax,scol
     mov   ex,ax
     mov   ax,rrrow
     mov   ey,ax
     mov   ax,spoint
     mov   epnt,ax
     call  xor_liner
     ret
box_lines:
; draw 3rd   line, lower right to lower left
     mov   ax,rcol
     mov   ex,ax
     mov   ax,rrrow
     mov   ey,ax
     mov   ax,rpoint
     mov   epnt,ax
;
     mov   ax,scol
     mov   sx,ax
     mov   ax,rrrow
     mov   sy,ax
     mov   ax,spoint
     mov   spnt,ax
     call  xor_lines
; draw 4th   line,  lower right to upper right
     mov   ax,rcol
     mov   ex,ax
     mov   ax,rrrow
     mov   ey,ax
     mov   ax,rpoint
     mov   epnt,ax
;
     mov   ax,rcol
     mov   sx,ax
     mov   ax,srow
     mov   sy,ax
     mov   ax,rpoint
     mov   spnt,ax
     call  xor_lines
; draw first line, upper right upper left
     mov   ax,spoint
     mov   spnt,ax
     mov   ax,scol
     mov   sx,ax
     mov   ax,srow
     mov   sy,ax
;
     mov   ax,rpoint
     mov   epnt,ax
     mov   ax,rcol
     mov   ex,ax
     mov   ax,srow
     mov   ey,ax
     call  xor_lines
; draw 2nd   line,  lower left to upper left
     mov   ax,scol
     mov   sx,ax
     mov   ax,srow
     mov   sy,ax
     mov   ax,spoint
     mov   spnt,ax
;
     mov   ax,scol
     mov   ex,ax
     mov   ax,rrrow
     mov   ey,ax
     mov   ax,spoint
     mov   epnt,ax
     call  xor_lines
     ret
xor_box:
         call  reset_segs
     cmp   xpass,1
     jne   no_xpass2
     mov   ax,lux
     mov   ux,ax
     mov   ax,luy
     mov   uy,ax
     mov   ax,llx
     mov   lx,ax
     mov   ax,lly
     mov   ly,ax
     call  box_lines
no_xpass2:
     mov   xpass,1
;  step 1 set up upper left hand corner of screen
      call local_range  ; sets up rrrow and rcol
      call setup_range  ; sets up which area is to be xor'd
; now call the screen to put a new one up
;
     call  box_lines
     mov   ax,ux
     mov   lux,ax
     mov   ax,uy
     mov   luy,ax
     mov   ax,lx
     mov   llx,ax
     mov   ax,ly
     mov   lly,ax
     ret
xor_line:
         call  reset_segs
; here we check to see if we have to erase the old xor
     cmp   xpass,1
     jne   no_xpassl
     mov   ax,lux
     mov   ux,ax
     mov   ax,luy
     mov   uy,ax
     mov   ax,llx
     mov   lx,ax
     mov   ax,lly
     mov   ly,ax
     mov   ax,spoint
     mov   spnt,ax
     mov   ax,scol
     mov   sx,ax
     mov   ax,srow
     mov   sy,ax
     mov   ax,rpoint
     mov   epnt,ax
     mov   ax,rcol
     mov   ex,ax
     mov   ax,rrrow
     mov   ey,ax
     call  xor_lines
no_xpassl:
     mov   xpass,1
;  step 1 set up upper left hand corner of screen
      call local_range  ; sets up rrrow and rcol
      call setup_range  ; sets up which area is to be xor'd
; now call the screen to put a new one up
;
     mov   ax,spoint
     mov   spnt,ax
     mov   ax,scol
     mov   sx,ax
     mov   ax,srow
     mov   sy,ax
     mov   ax,rpoint
     mov   epnt,ax
     mov   ax,rcol
     mov   ex,ax
     mov   ax,rrrow
     mov   ey,ax
     call  xor_lines
     mov   ax,ux
     mov   lux,ax
     mov   ax,uy
     mov   luy,ax
     mov   ax,lx
     mov   llx,ax
     mov   ax,ly
     mov   lly,ax
     ret
xor_circ:
         call  reset_segs
; here we check to see if we have to erase the old xor
     cmp   xpass,1
     jne   no_xpassc
     mov   ax,lux
     mov   ux,ax
     mov   ax,luy
     mov   uy,ax
     mov   ax,llx
     mov   lx,ax
     mov   ax,lly
     mov   ly,ax
     mov   ax,spoint
     mov   spnt,ax
     mov   ax,scol
     mov   sx,ax
     mov   ax,srow
     mov   sy,ax
     mov   ax,rpoint
     mov   epnt,ax
     mov   ax,rcol
     mov   ex,ax
     mov   ax,rrrow
     mov   ey,ax
     call  xor_circs
no_xpassc:
     mov   xpass,1
;  step 1 set up upper left hand corner of screen
      call local_range  ; sets up rrrow and rcol
      call setup_range  ; sets up which area is to be xor'd
; now call the screen to put a new one up
;
     mov   ax,spoint
     mov   spnt,ax
     mov   ax,scol
     mov   sx,ax
     mov   ax,srow
     mov   sy,ax
     mov   ax,rpoint
     mov   epnt,ax
     mov   ax,rcol
     mov   ex,ax
     mov   ax,rrrow
     mov   ey,ax
     call  xor_circs
     mov   ax,ux
     mov   lux,ax
     mov   ax,uy
     mov   luy,ax
     mov   ax,lx
     mov   llx,ax
     mov   ax,ly
     mov   lly,ax
     ret
make_sfp:
; sets up a do on an sfp in buffer
      push  ax
      call  reset_segs
      call  sfp_box
      pop   ax
; tx and ty are where to put the sfp character
      call  real_sfp
      call  sfp_box
      call  do_index
      jmp   mf_bounds
sfp_box:
      call  present
      call  local_range
      call  set_s_stuff
      mov   ax,fx
      mov   curx,ax
      mov   ax,fy
      mov   cury,ax
      mov   ax,segmentsize
      mov   dx,0
      div   vwid
      mul   curr_seg
      mov   ty,ax
      mov   ax,siloc
      mov   dx,0
      div   vwid
      add   ty,ax
      shl   dx,1
      shl   dx,1
      shl   dx,1
      mov   tx,dx
;  now the screen points are added in
      mov   ax,fx  ; finger x loc
      add   tx,ax
      mov   ax,fy  ; finger y loc
      add   ty,ax
      mov   cx,8
      mov   ax,tx
      mov   dx,0
      div   cx
      mov   scol,ax
      add   ax,width_byteso
      mov   rcol,ax
      mov   ax,ty
      mov   srow,ax
      add   ax,height_pix
      mov   rrrow,ax
     call  xor_box
      call  put_finger    ; put finger back
      ret
;
;
;
set_char:
      push  ax
      call  reset_segs
      call  local_range
      call  set_s_stuff
extrn do_char:near,do_rchar:near
      mov   ax,fx
      mov   curx,ax
      mov   ax,fy
      mov   cury,ax
      mov   clean,0
      call  put_finger    ; kill finger
      pop   ax
      cmp   al,8  ; backspace
      jne   no_tbs
      sub   fx,8
      mov   clean,0
      call  put_finger    ; put finger back
      call  do_index
      jmp   mf_bounds
no_tbs:
      push  ax
      call  do_char
; must calculate tx and ty which is the absolute location of
; the x and y
; start by getting the upper left hand corner of screen
      mov   ax,segmentsize
      mov   dx,0
      div   vwid
      mul   curr_seg
      mov   ty,ax
      mov   ax,siloc
      mov   dx,0
      div   vwid
      add   ty,ax
      shl   dx,1
      shl   dx,1
      shl   dx,1
      mov   tx,dx
;  now the screen points are added in
      mov   ax,fx  ; finger x loc
      add   tx,ax
      mov   ax,fy  ; finger y loc
      add   ty,ax
;
      pop   ax
      call  do_rchar
      mov   clean,0
      call  put_finger    ; put finger back
      call  do_index
      add    fx,8
      jmp  mf_bounds
      ret

;
do_fat:
public do_fat
     call  reset_segs
     mov   fat_on,1
     call present
     mov  curx,0
     mov  cury,0
     mov  left_margin,0
     call present
     lea  dx,zoom1
     call prbox
do_fat2:
     mov   r_index,5
     call  move_finger
     cmp  al,27
     jne  got_z_range
     mov   fat_on,0
      call present
     ret
got_z_range:
     cmp  al,13
     jne   do_fat2
     call  set_zoom
     jmp  do_fat2
set_zoom:
     push  ax
; calculate upper left hand corner of screen
      mov   ax,segmentsize
      mov   dx,0
      div   vwid
      mul   curr_seg
      mov   ty,ax
      mov   ax,siloc
      mov   dx,0
      div   vwid
      add   ty,ax
      shl   dx,1
      shl   dx,1
      shl   dx,1
      mov   tx,dx
     mov   ax,fy
     shr   ax,1
     shr   ax,1
     shr   ax,1
     add   ty,ax
     mov   ax,fx
     shr   ax,1
     shr   ax,1
     shr   ax,1
     add   tx,ax
; tx and ty have the absolute posiiton in dots of the finger
; calc the seg and offset of the point in the buffer
     mov   dx,0
     mov   ax,segmentsize
     div   vwid
; ax has the lines in a segment
     mov   cx,ax
     mov   ax,ty
     mov   dx,0
     div   cx
; ax has the segments, dx has the left over lines into segmnet
     mov   bx,ax
     mov   ax,dx
     mul   vwid
     mov   di,ax
; di has the offset into the thing contributed by lines
     mov   ax,tx
     mov   dx,0
     mov   cx,8
     div   cx
;  dx has the bits and ax has the offset
     add   di,ax
     mov   cx,dx
     mov   al,80h
     shr   al,cl   ; mov the dot over
     mov   dl,al
     pop   ax
     cmp   al,13
     je    z_on_bit
     cmp   al,32
     je    z_off_bit
     ret
z_off_bit:
; turn off bit
     xor   dl,0ffh
     mov   work_seg,bx
     call  get_curr_seg
     mov   ds,ax
     and   byte ptr ds:[di],dl
     call  reset_segs
     call  present
     ret
z_on_bit:
; calculate which bit to turn on
     mov   work_seg,bx
     call  get_curr_seg
     mov   ds,ax
     or    byte ptr ds:[di],dl
     call  reset_segs
     call  present
     ret
;
;
;
;
;
;
;
do_sfpt:
public do_sfpt
     call reset_segs
     call present
     mov   r_index,7
     call  move_finger
     cmp   al,27
     jne   do_sfpt
     stc
     ret

;
;
;
;
;
;
do_type:
public do_type
     call reset_segs
     call present
     mov   ax,scale
     mov   lscale,ax
     mov   ax,save_font
     mov   font,ax
     mov   r_index,4
     call  move_finger
     cmp   al,27
     jne   cont_t
     mov   lscale,1
     stc
     ret
cont_t:
     cmp  al,13  ; return key
     jne  no_t13
     mov fx,0
     mov dx,2
     add fy,14
     call mf_bounds
     jmp  do_type
no_t13:
     mov   lscale,1
     clc
     ret
do_draw:
public do_draw
     call reset_segs
     mov  curx,0
     mov  cury,0
     mov  left_margin,0
     call present
     lea  dx,draw1
     call prbox
     call first_range
     cmp  al,27
     jne  got_d_range
      call present
     ret
got_d_range:
     call present
     mov  curx,0
     mov  cury,0
     mov  left_margin,0
     mov   r_index,8
     call  move_finger
     push  ax
     call present
     pop   ax
     cmp   al,27
     je    draw_exit
     cmp   al,13
     je   do_draw
     jmp   got_d_range
draw_exit:
     ret
draw_line:
     call  xor_line
     mov   ax,scol
     mov   sx,ax
     mov   ax,srow
     mov   sy,ax
     mov   ax,spoint
     mov   spnt,ax
;
     mov   ax,rcol
     mov   ex,ax
     mov   scol,ax
     mov   ax,rrrow
     mov   ey,ax
     mov   srow,ax
     mov   ax,rpoint
     mov   epnt,ax
     mov   spoint,ax
     call  xor_liner
     ret

;
; do_box
;
do_box:
public do_box
     call reset_segs
     mov  curx,0
     mov  cury,0
     mov  left_margin,0
     call present
     lea  dx,line1
     call prbox
     call first_range
     cmp  al,27
     jne  got_b_range
      call present
     ret
got_b_range:
; have the starting range
     call present
     mov  curx,0
     mov  cury,0
     mov  left_margin,0
     lea  dx,line2
     call prbox
     mov   r_index,2
     call  move_finger
     push  ax
     call present
     pop   ax
     cmp   al,27
     je    box_exit
     call  xor_boxer
     call  present
     call  local_range
     call  set_s_stuff
     mov   ax,siloc
     mov   lastlsi,ax
     mov   ax,curr_seg
     mov   lastlseg,ax
     mov   ax,13
box_exit:
     ret

;
; do_line
;
do_line:
public do_line
     call reset_segs
     mov  curx,0
     mov  cury,0
     mov  left_margin,0
     call present
     lea  dx,line1
     call prbox
     call first_range
     cmp  al,27
     jne  got_l_range
      call present
     ret
got_l_range:
; have the starting range
     call present
     mov  curx,0
     mov  cury,0
     mov  left_margin,0
     lea  dx,line2
     call prbox
     mov   r_index,3
     call  move_finger
     push  ax
     call present
     pop   ax
     cmp   al,27
     je    line_exit
     call  xor_liner
     call  local_range
     call  set_s_stuff
     mov   ax,siloc
     mov   lastlsi,ax
     mov   ax,curr_seg
     mov   lastlseg,ax
     jmp   got_l_range
line_exit:
     ret

;
;
; do_ellipse
;
do_ellipse:
public do_ellipse
     call reset_segs
     mov  curx,0
     mov  cury,0
     mov  left_margin,0
     call present
     lea  dx,circ1
     call prbox
     call first_range
     cmp  al,27
     jne  got_c_range
      call present
     ret
got_c_range:
; have the starting range
     call present
     mov  curx,0
     mov  cury,0
     mov  left_margin,0
     lea  dx,circ2
     call prbox
     mov   r_index,6
     call  move_finger
     push  ax
     call present
     pop   ax
     cmp   al,27
     je    circ_exit
     call  xor_circr
     call present
;    call  local_range
;    call  set_s_stuff
;    mov   ax,siloc
;    mov   lastlsi,ax
;    mov   ax,curr_seg
;    mov   lastlseg,ax
;    jmp   got_l_range
circ_exit:
     ret

;
;
; select range for moves
;
set_mrange:
public set_mrange
; this is the do for do_copy!
do_overlay:
public do_overlay
     call reset_segs
     mov  olay,2
     jmp  by_olay
do_inlay:
public do_inlay
     call reset_segs
     mov  olay,4
     jmp  by_olay
do_copy:
public do_copy
     mov  olay,0
by_olay:
     call reset_segs
     mov  curx,0
     mov  cury,0
     mov  left_margin,0
     call present
     lea  dx,range1
     call prbox
     call first_range
     cmp  al,27
     jne  got_m_range
      call present
     ret
got_m_range:
; have the starting range
     call present
     mov  curx,0
     mov  cury,0
     mov  left_margin,0
     lea  dx,range2
     call prbox
     mov   r_index,1
     call  move_finger
     cmp   al,13
     je    got_from_range
     stc
     ret
got_from_range:
     call present
     mov   ax,rcol
     mov   lcol,ax
     mov   ax,fx
     mov   lastlx,ax
     mov   ax,rrrow
     mov   lrow,ax
     mov   ax,fy
     mov   lastly,ax
     mov   ax,rpoint
     mov   lpoint,ax
     mov   ax,siloc
     mov   lastlsi,ax
     mov   ax,curr_seg
     mov   lastlseg,ax
; now save this position so it can be used later
     mov   ax,scol
     mov   fux,ax
     mov   ax,srow
     mov   fuy,ax
     mov   ax,lcol
     mov   flx,ax
     mov   ax,lrow
     mov   fly,ax
; now reverse the starting and ending locations for next guy
     mov   ax,scol
     mov   bx,lcol
     mov   scol,bx
     mov   rcol,ax
     mov   lcol,ax
     mov   ax,srow
     mov   bx,lrow
     mov   srow,bx
     mov   rrrow,ax
     mov   lrow,ax
; now relocate the guy back at the scol position to start the square
     call  mf_f7
; calc old_wid and old_len for future ref
     mov   ax,rcol
     mov   cl,3
     shl   ax,cl
     add   ax,rpoint
     mov   bx,scol
     shl   bx,cl
     add   bx,spoint
     sub   ax,bx
     mov   old_wid,ax
     mov   ax,rrrow
     sub   ax,srow
     mov   old_len,ax
next_mrange:
; issue the message
     mov  curx,0
     mov  cury,0
     mov  left_margin,0
     lea  dx,range2
     call prbox
     mov   r_index,1
     mov   fswitch,1   ; makes the guy a fixed range
     call  move_finger
; the to range is now in scol,srow to rcol,rrrow
     cmp   al,13
     je    got_to_range
     stc
     ret
got_to_range:
     call  reset_segs
     call present
; save all 8 of the movers
     mov   ax,scol
     push  ax
     mov   ax,srow
     push  ax
     mov   ax,rcol
     push  ax
     mov   ax,rrrow
     push  ax
     mov   ax,fux
     push  ax
     mov   ax,fuy
     push  ax
     mov   ax,flx
     push  ax
     mov   ax,fly
     push  ax
     pop   ax
     mov   fly,ax
; check to make sure that the scol,srow is always upper left
     mov   ax,scol
     cmp   ax,rcol
     jle   ok_column
     mov   bx,rcol
     mov   rcol,ax
     mov   scol,bx
ok_column:
     mov   ax,srow
     cmp   ax,rrrow
     jle   ok_row
     mov   bx,rrrow
     mov   rrrow,ax
     mov   srow,bx
ok_row:
     mov   ax,rcol
     mov   lcol,ax
     mov   ax,fx
     mov   lastlx,ax
     mov   ax,rrrow
     mov   lrow,ax
     mov   ax,fy
     mov   lastly,ax
     mov   ax,rpoint
     mov   lpoint,ax
     mov   ax,siloc
     mov   lastlsi,ax
     mov   ax,curr_seg
     mov   lastlseg,ax
     extrn copy_range:near
     call  copy_range
     call  reset_segs
; rest all of the 8 data items
     pop   ax
     mov   flx,ax
     pop   ax
     mov   fuy,ax
     pop   ax
     mov   fux,ax
     pop   ax
     mov   rrrow,ax
     pop   ax
     mov   rcol,ax
     pop   ax
     mov   srow,ax
     pop   ax
     mov   scol,ax
; save the last scol etc to do the next guy!
     mov   ax,scol
     mov   fux,ax
     mov   ax,srow
     mov   fuy,ax
     mov   ax,rcol
     mov   flx,ax
     mov   ax,rrrow
     mov   fly,ax
     cmp   olay,0
     jne   exit_copy
     jmp   next_mrange
exit_copy:
;
      ret

;
;
;
; select range for files, printint etc
;
set_range:
public set_range
     call reset_segs
     mov  curx,0
     mov  cury,0
     mov  left_margin,0
     call present
     lea  dx,range1
     call prbox
     call first_range
     cmp  al,27
     jne  got_s_range
      call present
     ret
got_s_range:
     cmp  ah,3ch
     jne  not_all
     mov  scol,0
     mov  srow,0
     mov  spoint,0
     mov  ax,vwid
     dec  ax
     mov  lcol,ax
     mov  ax,maxlines
     dec  ax
     mov  lrow,ax
     mov  lpoint,0
     call present
     mov  ax,13
      ret
not_all:
; have the starting range
     call present
     mov  curx,0
     mov  cury,0
     mov  left_margin,0
     lea  dx,range2
     call prbox
     mov   r_index,1
     call  move_finger
     push  ax
     call present
     mov   ax,rcol
     mov   lcol,ax
     mov   ax,fx
     mov   lastlx,ax
     mov   ax,rrrow
     mov   lrow,ax
     mov   ax,fy
     mov   lastly,ax
     mov   ax,rpoint
     mov   lpoint,ax
     mov   ax,siloc
     mov   lastlsi,ax
     mov   ax,curr_seg
     mov   lastlseg,ax
; fix the rows
     mov   ax,srow
     mul   planes
     mov   srow,ax
     mov   ax,rrrow
     mul   planes
     mov   rrow,ax
     mov   lrow,ax
     pop   ax
     ret

;
;
; select range for scale
;
set_srange:
public set_srange
     call reset_segs
     mov  curx,0
     mov  cury,0
     mov  left_margin,0
     call present
     lea  dx,range1
     call prbox
     call first_range
     cmp  al,27
     jne  got_s_srange
      call present
     ret
got_s_srange:
     cmp  ah,3ch
     jne  not_sall
     mov  scol,0
     mov  srow,0
     mov  spoint,0
     mov  ax,vwid
     dec  ax
     mov  lcol,ax
     mov  ax,maxlines
     dec  ax
     mov  lrow,ax
     mov  lpoint,0
     jmp  size_range
not_sall:
; have the starting range
     call present
     mov  curx,0
     mov  cury,0
     mov  left_margin,0
     lea  dx,range2
     call prbox
     mov   r_index,1
     call  move_finger
     push  ax
     call present
     mov   ax,rcol
     mov   lcol,ax
     mov   ax,fx
     mov   lastlx,ax
     mov   ax,rrrow
     mov   lrow,ax
     mov   ax,fy
     mov   lastly,ax
     mov   ax,rpoint
     mov   lpoint,ax
     mov   ax,siloc
     mov   lastlsi,ax
     mov   ax,curr_seg
     mov   lastlseg,ax
     pop   ax
     cmp   al,27
     jne   size_range
     ret
size_range:
     call present
     mov  curx,0
     mov  cury,0
     mov  left_margin,0
     lea  dx,size2
     call prbox
     mov   r_index,1
     call  move_finger
     push  ax
     call present
     mov   ax,rcol
     mov   zcol,ax
     mov   ax,rrrow
     mov   zrow,ax
     mov   ax,rpoint
     mov   zpoint,ax
     pop   ax
     ret

;
setup_range:
;
       mov   ax,scol
       cmp   ux,ax
       jg    off_left
       cmp   lx,ax
       jl    off_right
; both scol and rcol are on the screen
       cmp   rcol,ax
       jg    rcol_right
       mov   lx,ax
       mov   ax,rcol
       mov   ux,ax
       cmp   spoint,0
       je    check_row
       inc   lx
       jmp   check_row
rcol_right:
       mov   ux,ax
       mov   ax,rcol
       mov   lx,ax
       cmp   rpoint,0
       je    check_row
       inc   lx
       jmp   check_row
off_left:
       mov   bx,rcol
       mov   lx,bx
       cmp   rpoint,0
       je    check_row
       inc   lx
       jmp   check_row
off_right:
       mov   bx,rcol
       mov   ux,bx
check_row:
       mov   ax,srow
       cmp   uy,ax
       jg    off_top
       cmp   ly,ax
       jl    off_bot
; both srow and rrrow are on the screen
       cmp   rrrow,ax
       jg    rrrow_down
       mov   ly,ax
       mov   ax,rrrow
       mov   uy,ax
       jmp   done_check
rrrow_down:
       mov   uy,ax
       mov   ax,rrrow
       mov   ly,ax
       jmp   done_check
off_top:
       mov   bx,rrrow
       mov   ly,bx
       jmp   done_check
off_bot:
       mov   bx,rrrow
       mov   uy,bx
done_check:
;
; here subtract out upper left to get relative in the u's and l's
     mov  ax,rx
     sub  ux,ax
     sub  lx,ax
     mov  ax,ry
     sub  uy,ax
     sub  ly,ax
     ret

;
;
;
xor_range:
         call  reset_segs
; here we check to see if we have to erase the old xor
     cmp   xpass,1
     jne   no_xpass
     mov   ax,lux
     mov   ux,ax
     mov   ax,luy
     mov   uy,ax
     mov   ax,llx
     mov   lx,ax
     mov   ax,lly
     mov   ly,ax
     call  xor_screen
no_xpass:
     mov   xpass,1
; this is meant to xor on the screen the area from
; scol,srow to rcol,rrrow
;
; the strategy is to use the frame stuff to calculate a
; real screen range
;
; the scol,srow rcol,rrrow have been set
;  step 1 set up upper left hand corner of screen
      call local_range  ; sets up rrrow and rcol
      call setup_range  ; sets up which area is to be xor'd
; now call the screen to put a new one up
;
     call  xor_screen
     mov   ax,ux
     mov   lux,ax
     mov   ax,uy
     mov   luy,ax
     mov   ax,lx
     mov   llx,ax
     mov   ax,ly
     mov   lly,ax
     ret

;
;
xor_screen:
;
; this routine xor's a box onto the screen
; the box is set up as ux,uy to lx,ly
;
     mov   ax,ly
     sub   ax,uy
     cmp  ax,0
     jg   ok_ax
     mov  ax,1
ok_ax:
;    ax has the number of lines to do
;    calc the cx to do count
;
     mov   dx,0
     div   interlace
;
; dx has the interlace lines to worry about
; ax has the count of interlace groups to worry about
;
     mov bp,lx
     sub  bp,ux
 ; bp keeps the amount to xor across
     cmp  bp,0
     jg   ok_bp
      mov bp,1
ok_bp:
; need to calc the di offset
;
     push  dx  ; rem lines
     push  ax ; ilines
     mov   dx,0
     mov   ax,ux
     mov   vesx,ax
     mov   ax,uy
     mov   cline,ax
     div   interlace
     mov   si,dx; the lines left over
     mul   vid_wid
     add   ax,ux
     mov   di,ax
     pop   cx   ; the count lines to do
     pop   ax   ; remainder lines from end
     add   ax,si; save remainder lines from begining
     push   ax  ; save it
;
; at the start of the loop
; si has the lines into the range to begin
;    cx has the lines to do
;    bp has the cols to xor
;    di has the offset
     mov  bx,vid_wid
     mov  dx,vbuffer
     cmp  cx,0
     jg   x_loop0
     jmp  end_xor_check
; give it a try
x_loop0:
     cmp  mode,-1
     jne  no_vesa1
     call  calc_bank
     add   di,vesx
no_vesa1:
     push  cx
     push  dx
     push  di
     mov   cx,interlace
     cmp   si,0
     je    x_loop1
     sub    cx,si
xx_l:
     add    dx,200h
     loop   xx_l
     mov    cx,si
     mov    si,0
x_loop1:
     push   cx
     push   di
     mov   cx,bp
x_loop2:
     mov   es,dx
     xor   byte ptr es:[di],0ffh
     inc   di
     loop  x_loop2
     pop   di
     pop   cx
     add   dx,200h
     loop   x_loop1
    pop    di
    pop    dx
    pop    cx
    add    di,bx
    loop   x_loop0
end_xor_check:
    pop    cx
    cmp    cx,0
     jg    finish_loop
     ret
finish_loop:
     push   cx
     push   di
     mov   cx,bp
x_loop4:
     mov   es,dx
     xor   byte ptr es:[di],0ffh
     inc   di
     loop  x_loop4
     pop   di
     pop   cx
     add   dx,200h
     loop   finish_loop
     ret

;
;
first_range:
public first_range
;  this does the range thing for the frist time and calcluates
;  srow scol
;
     mov   fswitch,0
     mov   r_index,0
     call  move_finger
     cmp   al,27
     jne   cont_f
     stc
     ret
cont_f:
     call  local_range ; gets the upper and lower limts into ux,uy
; convert the fx and fy into the s stuff
;
     cmp   ah,3ch
     jne   no_f22
     ret
no_f22:
     call  set_s_stuff
     ret

set_s_stuff:
     mov   ax,rrrow
     mov   srow,ax
     mov   ax,fy
     mov   lastuy,ax
     mov   ax,rcol
     mov   scol,ax
     mov   ax,fx
     mov   lastux,ax
     mov   ax,rpoint
     mov   spoint,ax
     mov   ax,siloc
     mov   lastusi,ax
     mov   ax,curr_seg
     mov   lastuseg,ax
; the scol, srow have been set
      ret

;
local_range:
;  this does the range thing for the second time and calcluates
;  rrrow rcol
;
; this is called from move finger continually it calculates
; rcol and rrrow which are local
;
     push  ax
     push  dx
     call  calc_frame  ; gets the upper and lower limts into ux,uy
; convert the fx and fy into the s stuff
;
     mov   ax,uy
     add   ax,fy
     mov   rrrow,ax
     mov   ax,fx
     mov   cx,8
     mov   dx,0
     div   cx
     add   ax,ux
     mov   rcol,ax
     mov   rpoint,dx
; check to see if the float switch is on
     cmp   fswitch,0
     je    no_float
; have to recalc the scol,srow,spoint stuff
     mov   ax,rcol
     mov   cl,3
     shl   ax,cl
     add   ax,rpoint
     sub   ax,old_wid
     mov   dx,0
     mov   cx,8
     div   cx
     cmp   ax,0
     jge   chk1
     mov   ax,0
     mov   dx,0
chk1:
     cmp   ax,vwid
     jl    chk2
     mov   ax,vwid
     dec   ax
     mov  dx,0
chk2:
     mov   scol,ax
     mov   spoint,dx
     mov   ax,rrrow
     sub   ax,old_len
     cmp   ax,0
     jge   chk3
     mov   ax,0
chk3:
     cmp   ax,maxlines
     jl    chk4
     mov   ax,maxlines
     dec   ax
chk4:
     mov   srow,ax
; recalc scol
;    mov   ax,srow
;    mul   planes
;    mov   srow,ax
no_float:
; recalc the rcol by using planes
;    mov   ax,rrrow
;    mul   planes
;    mov   rrrow,ax
; the rcol, rrrow have been set
; calc old_wid and old_len for future ref
     mov   ax,rcol
     mov   cl,3
     shl   ax,cl
     add   ax,rpoint
     mov   bx,scol
     shl   bx,cl
     add   bx,spoint
     sub   ax,bx
     mov   old_wid,ax
     mov   ax,rrrow
     sub   ax,srow
     mov   old_len,ax
     pop   dx
     pop   ax
     ret

;
;
calc_frame:
; calculate the col row in absolute of upper left
     mov   ax,curr_seg  ; current segment
     mov   cx,segmentsize
     mul   cx
     div   vwid
; ax has the lines to start of segment
     mov   uy,ax
     mov   ax,siloc
     mov   dx,0
     div   vwid
     mov   ux,dx
     add   uy,ax
; the upper left hand corner of screen are in ux,uy
; save in variable in case needed
     mov   ax,uy
     mov   ry,ax
     mov   erow,ax
     add   ax,len_bits
     mov   ly,ax
;
     mov   ax,ux
     mov   rx,ax
     mov   ecol,ax
     add   ax,vid_wid
     dec   ax
     mov   lx,ax
     ret

;
;
move_finger:
; this is a waste, but we have to do it somewheres
         call  reset_segs
         mov   ax,8
         mul   vid_wid
         dec   ax
         mov   vid_bits,ax
         mov   ax,vid_len
         mul   interlace
         dec   ax
         mov   len_bits,ax
;
; this is the top of the move_finger loop
         mov   xpass,0
move_loop:
         call  fixplane1
         call  put_finger    ; put finger while we are waiting
         call  reset_segs
         call  do_index
         call  reset_segs
         mov   dx,0
         call  getkey
         cmp   al,27  ;esc
         jne   not_r_esc
         push  ax
         call  fixplane2
         call  present
         pop   ax
         ret
not_r_esc:
         call  fixplane2
         cmp   al,'/'
         je    by_mfx
         cmp   al,'?'
         je    by_mfx
         cmp   ah,68h
         jl    by_68
         cmp   ah,6bh
         jg    by_68
by_mfx:
         jmp   by_mf
by_68:
         cmp   ah,71h
         je    by_mfx
         cmp   r_index,4
         je    doing_typing
         cmp   r_index,7
         je    doing_typing
         jmp   no_typing
doing_typing:
         cmp   ah,34h
         je    by_mfx
         cmp   al,'.'
         je    by_mfx
         cmp   al,'?'
         je    by_mfx
no_typing:
         cmp   r_index,5
         jne   no_zooming
         cmp   al,20h
         jne   no_zooming
         jmp   by_mfx
no_zooming:
         cmp   ah,3bh ; help f1
         jne   no_help
         call  mf_f1
         jmp   move_loop
no_help:
         cmp   ax,2e00h ; clear alt C
         jne   no_clear
         call  mf_clear
         jmp   move_loop
no_clear:
         cmp   ax,1700h ; index alt I
         jne   no_index
         xor   iswitch,1
         jmp   move_loop
no_index:
         cmp   ah,41h
         jne   no_f7
         call  mf_f7
         jmp   by_mf
no_f7:
         cmp   ah,42h
         jne   no_f8
         call  mf_f8
         jmp   by_mf
no_f8:
         cmp   r_index,0
         je    no_del
         cmp   ah,52h
         jne   no_ins
         jmp   by_mf
no_ins:
         cmp   ah,53h
         jne   no_del
         xor   fswitch,1
         jmp   by_mf
exit_mfx:
         jmp   exit_mf
no_del:
         cmp   ah,3ch
         je    exit_mfx
         cmp   bx,0
         jle   by_mf
         cmp   bx,22
         jle   do_mf
         cmp   bx,44
         jl    by_mf
         sub   bx,20
         cmp   bx,36
         ja    by_mf
do_mf:
         push  ax
         call  reset_segs
         call  cs:mf_line[bx]
         call  reset_segs
         pop   ax
         jc    exit_mf
         cmp   r_index,4
         je    by_fingerline
         cmp   r_index,7
         je    by_fingerline1
         jmp   by_mf
by_fingerline1:
         call  sfp_box
         jmp   by_fingerline
by_mf:
; check here for alternate fonts
     cmp    ah,71h
     jne     no_71h
     call   do_font0
     call    blip
         jmp   move_loop
extrn do_font0:near,do_font1:near,do_font2:near,do_font3:near
extrn do_font4:near
fontline dw do_font1,do_font2,do_font3,do_font4
no_71h:
     cmp    ah,68h
     jl     do_blop
     cmp    ah,6bh
     jg     do_blop
     sub    ah,68h
     mov    bl,ah
     mov    bh,0
     shl    bx,1
     call   cs:fontline[bx]
     call   blip
         jmp   move_loop
do_blop:
         call  reset_segs
         call  fixplane1
         mov   bx,r_index
         shl   bx,1
         push  es
         call  cs:fingerline[bx]
         pop   es
         jc    exit_mf
         call  fixplane2
by_fingerline:
         jmp   move_loop
exit_mf:
         call  fixplane2
         call  reset_segs
         ret
mf_bounds:
         mov   dx,0
         cmp   fx,0
         jl    col_lt_0
         mov   ax,vid_bits
         cmp   fx,ax
         jg    col_gt_0
         cmp   fy,0
         jl    row_lt_0
         mov   ax,len_bits
         cmp   fy,ax
         jg    row_gt_0
         clc
         ret
row_lt_0:
         mov   fy,0
         mov   dx,2
         cmp   fat_on,0
         je    fatu1
         mov   dx,0
fatu1:
         call  up_key
         jmp   after_move
row_gt_0:
         mov   ax,len_bits
         mov   fy,ax
         mov   dx,2
         cmp   fat_on,0
         je    fatd1
         mov   dx,0
fatd1:
         call  down_key
         jmp   after_move
col_lt_0:
; here we page to left 1
         mov   ax,vwid
         dec   ax
         and   ax,siloc
         cmp   ax,24
         jg     col_lt_z_n
         mov    fx,0
         jmp   after_move
col_lt_z_n:
         mov   ax,vid_bits
         add   fx,ax
         call  ctright
         jmp   after_move
col_gt_0:
; here we page to left 1
         mov   ax,vid_bits
         dec   ax
         mov   fx,ax
         call  left_key
;        jmp   after_move
after_move:
        call  present
        mov   xpass,0
        clc
        ret
mf_ret:
; the return key has been pressed
; this is a stc return, except for if there is a character working
        mov   al,13
        stc
        ret
mf_f1:
; help key for finger stuff
        mov  helps,1
        call help
        stc
        ret
mf_clear:
; clear the screen
        call present
        ret
mf_f7:
; this is supposed to set us at the last scol and srow
        mov   ax,lastusi
        mov   siloc,ax
        mov   ax,lastuseg
        mov   curr_seg,ax
        mov   ax,lastux
        mov   fx,ax
        mov   ax,lastuy
        mov   fy,ax
        call  present
        clc
        ret
mf_f8:
        mov   ax,lastlsi
        mov   siloc,ax
        mov   ax,lastlseg
        mov   curr_seg,ax
        mov   ax,lastlx
        mov   fx,ax
        mov   ax,lastly
        mov   fy,ax
        call  present
        clc
        ret
ct_left:
; the dh key will have the shift status in it
        mov  ax,vid_bits
        sub  ax,8
        sub  fx,ax
        jmp  mf_bounds
mf_left:
        test  dh,3  ; shifts
        jz   mf_left_nc
        dec   fx
        jmp  mf_bounds
mf_left_nc:
        sub  fx,8
        cmp  dl,2
        jl   mf_left_slow
        sub  fx,32
mf_left_slow:
        jmp  mf_bounds
mf_let:
; we check bx so as not to get here
        ret
ct_right:
         mov   ax,vid_bits
         sub   ax,8
         add   fx,ax
        jmp  mf_bounds
mf_right:
        test  dh,3
        jz   mf_right_nc
        inc   fx
        jmp  mf_bounds
mf_right_nc:
        add  fx,8
        cmp  dl,2
        jl   mf_right_slow
        add  fx,32
mf_right_slow:
        jmp  mf_bounds
ct_home:
        mov  siloc,0
        mov  curr_seg,0
        mov  fx,0
        mov  fy,0
        call present
        clc
        ret
mf_home:
        mov  fx,0
        mov  fy,0
        clc
        ret
ct_pgup:
         mov   ax,len_bits
         sub   ax,8
         sub   fy,ax
        jmp  mf_bounds
mf_up:
        test dh,3
        jz   mf_up_nc
        dec  fy
        jmp  mf_bounds
mf_up_nc:
        sub  fy,2
        cmp  dl,2
        jl   mf_up_slow
        sub  fy,8
mf_up_slow:
        jmp  mf_bounds
ct_end:
         mov   ax,last_si
         mov   siloc,ax
         mov   ax,last_seg
         mov   curr_seg,ax
         call present
mf_end:
         mov   ax,len_bits
         mov   fy,ax
         mov   ax,vid_bits
         mov   fx,ax
         clc
         ret
ct_pgdn:
         mov   ax,len_bits
         sub   ax,8
         add   fy,ax
        jmp  mf_bounds
mf_down:
        test  dh,3
        jz   mf_dn_nc
        inc  fy
        jmp  mf_bounds
mf_dn_nc:
        add  fy,2
        cmp  dl,2
        jl   mf_dn_slow
        add  fy,8
mf_dn_slow:
        jmp  mf_bounds
mf_pgup:
        test dh,4
        jz   mf_pgup_ns
         call  home_key
         jmp  after_move
mf_pgup_ns:
        sub  fy,16
        jmp  mf_bounds
mf_pgdn:
        test dh,4
        jz   mf_pgdn_ns
         call  end_key
         jmp  after_move
mf_pgdn_ns:
        add  fy,16
        jmp  mf_bounds

CSEG    ENDS
        END
