; OKRCHAR.ASM - this performs typeing character to real buffer
;
; PUBLIC ROUTINES ARE:
;
;  do_rchar - prints a character at curx,cury
;
dseg        SEGMENT PUBLIC 'DATA'
            ASSUME CS:cseg,DS:dseg,ES:dseg
EXTRN       attribute:BYTE,font:WORD
extrn       tx:word,ty:word,work_seg:word
EXTRN       vwid:WORD,lscale:word,cwidth:word,fontbuff:byte
lcount      dw  0
dseg        ENDS
cseg        SEGMENT PUBLIC 'CODE'
            ASSUME CS:cseg,DS:dseg,ES:dseg
extrn  reset_segs:near,get_next_seg:near,get_curr_seg:near
extrn  charget:near
segmentsize equ 8000h
PUBLIC      do_rchar
calc_cur_seg  proc  near
; converts tx and ty into real segment and offset
        push cx
        push bx
        push dx
        mov  ax,ty
        mul  vwid
        mov  cx,segmentsize
        div  cx  ; segment number
        mov  di,dx
        mov  work_seg,ax
        mov  ax,tx
        shr  ax,1
        shr  ax,1
        shr  ax,1
        add  di,ax
        call get_curr_seg
        mov  es,ax
        pop  dx
        pop  bx
        pop  ax
        ret
calc_cur_seg  endp
do_rchar     PROC  NEAR
; do_rchar prints a letter to the buffer. The current cursor
; is specified by tx and ty and is in absolute pels
; Pels must be converted to a real location in the buffer
; the char to print is in al
            push  ax
            push  bx
            push  cx
            push  dx
            push  bp
            push  si
            push  di
            PUSH  ES
            call  reset_segs
            mov   lcount,0
            call  charget
            mov   cx,cwidth
            push  cx
            LEA   SI,fontbuff
; si points to the font area which we will be using
; calcualte next where it goes
;
; tx and ty are relative cursor locations on screen in pels
; this must be converted to rastor and byte locations
; first the x direction (from upper left corner)
;
            MOV   bp,tx
            AND   bp,07     ; bp has the significant bits of location
; now calculate segment
            call  calc_cur_seg
;
; di has the byte offset of where the letter goes
; bp has the points
            POP   CX    ; length of char from above
            cmp   lscale,0
            jne   no_scale_0
            shr   cx,1
no_scale_0:
            cmp   lscale,1
            jle   char_loop0
            shl   cx,1
            cmp   lscale,2
            je    char_loop0
            shl   cx,1
char_loop0:  ; this is for each of the line of the char
            PUSH  CX    ; save length
            CLD
            LODSB
; have an element in al, check for scale
            cmp   lscale,1
            je    no_scale
            cmp   lscale,0
            jne    no_zero_scale
            mov   ah,al
            lodsb
            or    al,ah
            jmp   no_scale
no_zero_scale:
            inc   lcount
            cmp   lscale,2
            jne   no_scale_2
            dec   si
            cmp   lcount,1
            je    no_scale
            mov   lcount,0
            inc   si
            jmp   no_scale
no_scale_2:
            dec   si
            cmp   lcount,4
            jl    no_scale
            mov   lcount,0
            inc   si
            jmp   no_scale
no_scale:
            MOV   CX,BP       ; bp has the bit offset for the character
            MOV   BX,0ff00h
            MOV   AH,0
            CMP   CX,0
            JE    by_char_loop1
            MOV   BX,0ffh
; this is the loop for moving the bits right
;
char_loop1:
            SHR   BL,1
            OR    BL,10000000b
            SHR   BH,1
            CLC
            RCR   AL,1
            RCR   AH,1
            LOOP  char_loop1
;
;
by_char_loop1:
; we have to decide whether or not its black on white or revers
            TEST  attribute,1 ; is the one bit on in attribute
            JZ    no_reverse
; we have to make ax a negative letter
            XOR   AX,0ffffh
no_reverse:
;  here decide if we should punch a hole or go direct to screen
            CMP   attribute,1
            JG    no_punch ;only 0 and 1 are punched to screen
; at this point bp has the mask which is anded to screen
; to punch a hole for the letter,
            AND   ES:[DI],Bx
no_punch:
;  check now to see if we can OR, AND or XOR to screen
; 0,1,2,3 are or
            CMP   attribute,3
            JG    not_or
            OR    ES:[DI],AX
            JMP   by_char_loop1a
not_or:
            CMP   attribute,5
            JG    do_xor
            xor   bx,0ffffh
            and   ax,bx
            AND   ES:[DI],AX
            JMP   by_char_loop1a
do_xor:
            xor   bx,0ffffh
            and   ax,bx
            XOR   ES:[DI],AX
;     jmp   by_char_loop1a
by_char_loop1a:
inc_char_line:
            ADD   DI,vwid
            cmp   di,0
            jg    end_char_loop2
            call  get_next_seg
            sub   di,segmentsize
            mov   es,ax
end_char_loop2:
            POP   CX
            LOOP  char_loop2_x
            POP   ES
            pop   di
            pop   si
            pop   bp
            pop   dx
            pop   cx
            pop   bx
           pop    ax
            RET
char_loop2_x:
            JMP   char_loop0
do_rchar     ENDP
cseg    ends
        end
